// ***************************************************************************
// *                                                                         *
// *           Aflow STEFANO CURTAROLO - Duke University 2003-2021           *
// *                                                                         *
// ***************************************************************************
// Stefano Curtarolo - 2009 Duke

// ***************************************************************************
// Total structures holes      = 0
// Total structures calculated = 301071
// Extracted in date  [date=2014-01-14]
// ***************************************************************************

#ifndef _AFLOW_NOMIX_CPP
#define _AFLOW_NOMIX_CPP
#include "aflow.h"

// ***************************************************************************
int MiscibilityCheck(string system_in) {  // (nomix,unknown,mix)
  string system=system_in;vector<string> vspecies;
  // XATOM_SplitAlloySpecies(KBIN::VASP_PseudoPotential_CleanName(system_in),vspecies);
  XATOM_AlphabetizationSpecies(system,vspecies);
  if(system.find("Cs")!=string::npos) return MISCIBILITY_SYSTEM_NOMIX; // Cs bug !
  if(vspecies.size()==1) return MISCIBILITY_SYSTEM_MISCIBLE; // pure element is miscible with itself
  if(system=="AgAl") return MISCIBILITY_SYSTEM_MISCIBLE; // AgAl calcs=1050/200 elements=47,13 [2014-01-14]
  if(system=="AgAs") return MISCIBILITY_SYSTEM_NOMIX; // AgAs calcs=257/200 elements=47,33 [2014-01-14]
  if(system=="AgAu") return MISCIBILITY_SYSTEM_MISCIBLE; // AgAu calcs=294/200 elements=47,79 [2014-01-14]
  if(system=="AgB") return MISCIBILITY_SYSTEM_MISCIBLE; // AgB_h calcs=241/200 elements=47,5 [2014-01-14]
  if(system=="AgBa") return MISCIBILITY_SYSTEM_MISCIBLE; // AgBa_sv calcs=176/200 elements=47,56 [2014-01-14]
  if(system=="AgBe") return MISCIBILITY_SYSTEM_UNKNOWN; // AgBe_sv calcs=185/200 elements=47,4 [2014-01-14]
  if(system=="AgBi") return MISCIBILITY_SYSTEM_NOMIX; // AgBi_d calcs=250/200 elements=47,83 [2014-01-14]
  if(system=="AgBr") return MISCIBILITY_SYSTEM_MISCIBLE; // AgBr calcs=185/200 elements=47,35 [2014-01-14]
  if(system=="AgCa") return MISCIBILITY_SYSTEM_MISCIBLE; // AgCa_sv calcs=194/200 elements=47,20 [2014-01-14]
  if(system=="AgCd") return MISCIBILITY_SYSTEM_MISCIBLE; // AgCd calcs=297/200 elements=47,48 [2014-01-14]
  if(system=="AgCl") return MISCIBILITY_SYSTEM_MISCIBLE; // AgCl calcs=186/200 elements=47,17 [2014-01-14]
  if(system=="AgCo") return MISCIBILITY_SYSTEM_NOMIX; // AgCo calcs=203/200 elements=47,27 [2014-01-14]
  if(system=="AgCr") return MISCIBILITY_SYSTEM_NOMIX; // AgCr_pv calcs=205/200 elements=47,24 [2014-01-14]
  if(system=="AgCu") return MISCIBILITY_SYSTEM_NOMIX; // AgCu_pv calcs=208/200 elements=47,29 [2014-01-14]
  if(system=="AgFe") return MISCIBILITY_SYSTEM_NOMIX; // AgFe_pv calcs=202/200 elements=47,26 [2014-01-14]
  if(system=="AgGa") return MISCIBILITY_SYSTEM_MISCIBLE; // AgGa_h calcs=259/200 elements=47,31 [2014-01-14]
  if(system=="AgGe") return MISCIBILITY_SYSTEM_NOMIX; // AgGe_h calcs=242/200 elements=47,32 [2014-01-14]
  if(system=="AgHf") return MISCIBILITY_SYSTEM_MISCIBLE; // AgHf_pv calcs=299/200 elements=47,72 [2014-01-14]
  if(system=="AgHg") return MISCIBILITY_SYSTEM_NOMIX; // AgHg calcs=204/200 elements=47,80 [2014-01-14]
  if(system=="AgIn") return MISCIBILITY_SYSTEM_MISCIBLE; // AgIn_d calcs=260/200 elements=47,49 [2014-01-14]
  if(system=="AgIr") return MISCIBILITY_SYSTEM_NOMIX; // AgIr calcs=206/200 elements=47,77 [2014-01-14]
  if(system=="AgK") return MISCIBILITY_SYSTEM_MISCIBLE; // AgK_sv calcs=195/200 elements=47,19 [2014-01-14]
  if(system=="AgLa") return MISCIBILITY_SYSTEM_MISCIBLE; // AgLa calcs=297/200 elements=47,57 [2014-01-14]
  if(system=="AgLi") return MISCIBILITY_SYSTEM_MISCIBLE; // AgLi_sv calcs=177/200 elements=47,3 [2014-01-14]
  if(system=="AgMg") return MISCIBILITY_SYSTEM_MISCIBLE; // AgMg_pv calcs=306/200 elements=47,12 [2014-01-14]
  if(system=="AgMn") return MISCIBILITY_SYSTEM_NOMIX; // AgMn_pv calcs=204/200 elements=47,25 [2014-01-14]
  if(system=="AgMo") return MISCIBILITY_SYSTEM_NOMIX; // AgMo_pv calcs=205/200 elements=47,42 [2014-01-14]
  if(system=="AgNa") return MISCIBILITY_SYSTEM_MISCIBLE; // AgNa_sv calcs=165/200 elements=47,11 [2014-01-14]
  if(system=="AgNb") return MISCIBILITY_SYSTEM_NOMIX; // AgNb_sv calcs=205/200 elements=47,41 [2014-01-14]
  if(system=="AgNi") return MISCIBILITY_SYSTEM_NOMIX; // AgNi_pv calcs=205/200 elements=47,28 [2014-01-14]
  if(system=="AgOs") return MISCIBILITY_SYSTEM_NOMIX; // AgOs_pv calcs=204/200 elements=47,76 [2014-01-14]
  if(system=="AgP") return MISCIBILITY_SYSTEM_NOMIX; // AgP calcs=262/200 elements=47,15 [2014-01-14]
  if(system=="AgPb") return MISCIBILITY_SYSTEM_NOMIX; // AgPb_d calcs=243/200 elements=47,82 [2014-01-14]
  if(system=="AgPd") return MISCIBILITY_SYSTEM_MISCIBLE; // AgPd_pv calcs=294/200 elements=47,46 [2014-01-14]
  if(system=="AgPt") return MISCIBILITY_SYSTEM_MISCIBLE; // AgPt calcs=685/200 elements=47,78 [2014-01-14]
  if(system=="AgRe") return MISCIBILITY_SYSTEM_NOMIX; // AgRe_pv calcs=206/200 elements=47,75 [2014-01-14]
  if(system=="AgRh") return MISCIBILITY_SYSTEM_NOMIX; // AgRh_pv calcs=277/200 elements=47,45 [2014-01-14]
  if(system=="AgRu") return MISCIBILITY_SYSTEM_NOMIX; // AgRu_pv calcs=204/200 elements=47,44 [2014-01-14]
  if(system=="AgSb") return MISCIBILITY_SYSTEM_NOMIX; // AgSb calcs=255/200 elements=47,51 [2014-01-14]
  if(system=="AgSc") return MISCIBILITY_SYSTEM_MISCIBLE; // AgSc_sv calcs=299/200 elements=47,21 [2014-01-14]
  if(system=="AgSe") return MISCIBILITY_SYSTEM_MISCIBLE; // AgSe calcs=264/200 elements=47,34 [2014-01-14]
  if(system=="AgSi") return MISCIBILITY_SYSTEM_NOMIX; // AgSi calcs=238/200 elements=47,14 [2014-01-14]
  if(system=="AgSn") return MISCIBILITY_SYSTEM_MISCIBLE; // AgSn calcs=264/200 elements=47,50 [2014-01-14]
  if(system=="AgSr") return MISCIBILITY_SYSTEM_MISCIBLE; // AgSr_sv calcs=171/200 elements=47,38 [2014-01-14]
  if(system=="AgTa") return MISCIBILITY_SYSTEM_NOMIX; // AgTa_pv calcs=207/200 elements=47,73 [2014-01-14]
  if(system=="AgTc") return MISCIBILITY_SYSTEM_NOMIX; // AgTc_pv calcs=206/200 elements=47,43 [2014-01-14]
  if(system=="AgTe") return MISCIBILITY_SYSTEM_MISCIBLE; // AgTe calcs=268/200 elements=47,52 [2014-01-14]
  if(system=="AgTi") return MISCIBILITY_SYSTEM_MISCIBLE; // AgTi_sv calcs=300/200 elements=47,22 [2014-01-14]
  if(system=="AgTl") return MISCIBILITY_SYSTEM_UNKNOWN; // AgTl_d calcs=186/200 elements=47,81 [2014-01-14]
  if(system=="AgV") return MISCIBILITY_SYSTEM_NOMIX; // AgV_sv calcs=206/200 elements=47,23 [2014-01-14]
  if(system=="AgW") return MISCIBILITY_SYSTEM_NOMIX; // AgW_pv calcs=207/200 elements=47,74 [2014-01-14]
  if(system=="AgY") return MISCIBILITY_SYSTEM_MISCIBLE; // AgY_sv calcs=304/200 elements=47,39 [2014-01-14]
  if(system=="AgZn") return MISCIBILITY_SYSTEM_MISCIBLE; // AgZn calcs=298/200 elements=47,30 [2014-01-14]
  if(system=="AgZr") return MISCIBILITY_SYSTEM_MISCIBLE; // AgZr_sv calcs=301/200 elements=47,40 [2014-01-14]
  if(system=="AlAs") return MISCIBILITY_SYSTEM_MISCIBLE; // AlAs calcs=267/200 elements=13,33 [2014-01-14]
  if(system=="AlAu") return MISCIBILITY_SYSTEM_MISCIBLE; // AlAu calcs=272/200 elements=13,79 [2014-01-14]
  if(system=="AlB") return MISCIBILITY_SYSTEM_MISCIBLE; // AlB_h calcs=265/200 elements=13,5 [2014-01-14]
  if(system=="AlBa") return MISCIBILITY_SYSTEM_MISCIBLE; // AlBa_sv calcs=187/200 elements=13,56 [2014-01-14]
  if(system=="AlBe") return MISCIBILITY_SYSTEM_UNKNOWN; // AlBe_sv calcs=169/200 elements=13,4 [2014-01-14]
  if(system=="AlBi") return MISCIBILITY_SYSTEM_NOMIX; // AlBi_d calcs=246/200 elements=13,83 [2014-01-14]
  if(system=="AlBr") return MISCIBILITY_SYSTEM_MISCIBLE; // AlBr calcs=178/200 elements=13,35 [2014-01-14]
  if(system=="AlCa") return MISCIBILITY_SYSTEM_MISCIBLE; // AlCa_sv calcs=181/200 elements=13,20 [2014-01-14]
  if(system=="AlCd") return MISCIBILITY_SYSTEM_MISCIBLE; // AlCd calcs=264/200 elements=13,48 [2014-01-14]
  if(system=="AlCl") return MISCIBILITY_SYSTEM_MISCIBLE; // AlCl calcs=191/200 elements=13,17 [2014-01-14]
  if(system=="AlCo") return MISCIBILITY_SYSTEM_MISCIBLE; // AlCo calcs=278/200 elements=13,27 [2014-01-14]
  if(system=="AlCr") return MISCIBILITY_SYSTEM_MISCIBLE; // AlCr_pv calcs=268/200 elements=13,24 [2014-01-14]
  if(system=="AlCu") return MISCIBILITY_SYSTEM_MISCIBLE; // AlCu_pv calcs=271/200 elements=13,29 [2014-01-14]
  if(system=="AlFe") return MISCIBILITY_SYSTEM_MISCIBLE; // AlFe_pv calcs=271/200 elements=13,26 [2014-01-14]
  if(system=="AlGa") return MISCIBILITY_SYSTEM_NOMIX; // AlGa_h calcs=221/200 elements=13,31 [2014-01-14]
  if(system=="AlGe") return MISCIBILITY_SYSTEM_NOMIX; // AlGe_h calcs=249/200 elements=13,32 [2014-01-14]
  if(system=="AlHf") return MISCIBILITY_SYSTEM_MISCIBLE; // AlHf_pv calcs=283/200 elements=13,72 [2014-01-14]
  if(system=="AlHg") return MISCIBILITY_SYSTEM_NOMIX; // AlHg calcs=242/200 elements=13,80 [2014-01-14]
  if(system=="AlIn") return MISCIBILITY_SYSTEM_NOMIX; // AlIn_d calcs=217/200 elements=13,49 [2014-01-14]
  if(system=="AlIr") return MISCIBILITY_SYSTEM_MISCIBLE; // AlIr calcs=235/200 elements=13,77 [2014-01-14]
  if(system=="AlK") return MISCIBILITY_SYSTEM_UNKNOWN; // AlK_sv calcs=192/200 elements=13,19 [2014-01-14]
  if(system=="AlLa") return MISCIBILITY_SYSTEM_MISCIBLE; // AlLa calcs=188/200 elements=13,57 [2014-01-14]
  if(system=="AlLi") return MISCIBILITY_SYSTEM_MISCIBLE; // AlLi_sv calcs=196/200 elements=13,3 [2014-01-14]
  if(system=="AlMn") return MISCIBILITY_SYSTEM_MISCIBLE; // AlMn_pv calcs=276/200 elements=13,25 [2014-01-14]
  if(system=="AlMo") return MISCIBILITY_SYSTEM_MISCIBLE; // AlMo_pv calcs=231/200 elements=13,42 [2014-01-14]
  if(system=="AlNa") return MISCIBILITY_SYSTEM_UNKNOWN; // AlNa_sv calcs=166/200 elements=13,11 [2014-01-14]
  if(system=="AlNb") return MISCIBILITY_SYSTEM_MISCIBLE; // AlNb_sv calcs=207/200 elements=13,41 [2014-01-14]
  if(system=="AlNi") return MISCIBILITY_SYSTEM_MISCIBLE; // AlNi_pv calcs=271/200 elements=13,28 [2014-01-14]
  if(system=="AlOs") return MISCIBILITY_SYSTEM_MISCIBLE; // AlOs_pv calcs=242/200 elements=13,76 [2014-01-14]
  if(system=="AlP") return MISCIBILITY_SYSTEM_MISCIBLE; // AlP calcs=251/200 elements=13,15 [2014-01-14]
  if(system=="AlPb") return MISCIBILITY_SYSTEM_NOMIX; // AlPb_d calcs=225/200 elements=13,82 [2014-01-14]
  if(system=="AlPd") return MISCIBILITY_SYSTEM_MISCIBLE; // AlPd_pv calcs=261/200 elements=13,46 [2014-01-14]
  if(system=="AlPt") return MISCIBILITY_SYSTEM_MISCIBLE; // AlPt calcs=216/200 elements=13,78 [2014-01-14]
  if(system=="AlRe") return MISCIBILITY_SYSTEM_MISCIBLE; // AlRe_pv calcs=185/200 elements=13,75 [2014-01-14]
  if(system=="AlRh") return MISCIBILITY_SYSTEM_MISCIBLE; // AlRh_pv calcs=357/200 elements=13,45 [2014-01-14]
  if(system=="AlRu") return MISCIBILITY_SYSTEM_MISCIBLE; // AlRu_pv calcs=246/200 elements=13,44 [2014-01-14]
  if(system=="AlSb") return MISCIBILITY_SYSTEM_MISCIBLE; // AlSb calcs=231/200 elements=13,51 [2014-01-14]
  if(system=="AlSc") return MISCIBILITY_SYSTEM_MISCIBLE; // AlSc_sv calcs=193/200 elements=13,21 [2014-01-14]
  if(system=="AlSe") return MISCIBILITY_SYSTEM_MISCIBLE; // AlSe calcs=179/200 elements=13,34 [2014-01-14]
  if(system=="AlSi") return MISCIBILITY_SYSTEM_UNKNOWN; // AlSi calcs=191/200 elements=13,14 [2014-01-14]
  if(system=="AlSn") return MISCIBILITY_SYSTEM_NOMIX; // AlSn calcs=209/200 elements=13,50 [2014-01-14]
  if(system=="AlSr") return MISCIBILITY_SYSTEM_MISCIBLE; // AlSr_sv calcs=189/200 elements=13,38 [2014-01-14]
  if(system=="AlTa") return MISCIBILITY_SYSTEM_MISCIBLE; // AlTa_pv calcs=267/200 elements=13,73 [2014-01-14]
  if(system=="AlTc") return MISCIBILITY_SYSTEM_MISCIBLE; // AlTc_pv calcs=186/200 elements=13,43 [2014-01-14]
  if(system=="AlTe") return MISCIBILITY_SYSTEM_MISCIBLE; // AlTe calcs=188/200 elements=13,52 [2014-01-14]
  if(system=="AlTi") return MISCIBILITY_SYSTEM_MISCIBLE; // AlTi_sv calcs=279/200 elements=13,22 [2014-01-14]
  if(system=="AlTl") return MISCIBILITY_SYSTEM_UNKNOWN; // AlTl_d calcs=169/200 elements=13,81 [2014-01-14]
  if(system=="AlV") return MISCIBILITY_SYSTEM_MISCIBLE; // AlV_sv calcs=191/200 elements=13,23 [2014-01-14]
  if(system=="AlW") return MISCIBILITY_SYSTEM_MISCIBLE; // AlW_pv calcs=197/200 elements=13,74 [2014-01-14]
  if(system=="AlY") return MISCIBILITY_SYSTEM_MISCIBLE; // AlY_sv calcs=256/200 elements=13,39 [2014-01-14]
  if(system=="AlZn") return MISCIBILITY_SYSTEM_UNKNOWN; // AlZn calcs=187/200 elements=13,30 [2014-01-14]
  if(system=="AlZr") return MISCIBILITY_SYSTEM_MISCIBLE; // AlZr_sv calcs=191/200 elements=13,40 [2014-01-14]
  if(system=="AsAu") return MISCIBILITY_SYSTEM_MISCIBLE; // AsAu calcs=188/200 elements=33,79 [2014-01-14]
  if(system=="AsB") return MISCIBILITY_SYSTEM_MISCIBLE; // AsB_h calcs=183/200 elements=33,5 [2014-01-14]
  if(system=="AsBa") return MISCIBILITY_SYSTEM_MISCIBLE; // AsBa_sv calcs=187/200 elements=33,56 [2014-01-14]
  if(system=="AsBe") return MISCIBILITY_SYSTEM_UNKNOWN; // AsBe_sv calcs=194/200 elements=33,4 [2014-01-14]
  if(system=="AsBi") return MISCIBILITY_SYSTEM_NOMIX; // AsBi_d calcs=218/200 elements=33,83 [2014-01-14]
  if(system=="AsBr") return MISCIBILITY_SYSTEM_MISCIBLE; // AsBr calcs=177/200 elements=33,35 [2014-01-14]
  if(system=="AsCa") return MISCIBILITY_SYSTEM_MISCIBLE; // AsCa_sv calcs=181/200 elements=33,20 [2014-01-14]
  if(system=="AsCd") return MISCIBILITY_SYSTEM_MISCIBLE; // AsCd calcs=194/200 elements=33,48 [2014-01-14]
  if(system=="AsCl") return MISCIBILITY_SYSTEM_MISCIBLE; // AsCl calcs=194/200 elements=33,17 [2014-01-14]
  if(system=="AsCo") return MISCIBILITY_SYSTEM_MISCIBLE; // AsCo calcs=195/200 elements=33,27 [2014-01-14]
  if(system=="AsCr") return MISCIBILITY_SYSTEM_MISCIBLE; // AsCr_pv calcs=234/200 elements=33,24 [2014-01-14]
  if(system=="AsCu") return MISCIBILITY_SYSTEM_NOMIX; // AsCu_pv calcs=231/200 elements=33,29 [2014-01-14]
  if(system=="AsFe") return MISCIBILITY_SYSTEM_MISCIBLE; // AsFe_pv calcs=263/200 elements=33,26 [2014-01-14]
  if(system=="AsGa") return MISCIBILITY_SYSTEM_MISCIBLE; // AsGa_h calcs=206/200 elements=33,31 [2014-01-14]
  if(system=="AsGe") return MISCIBILITY_SYSTEM_MISCIBLE; // AsGe_h calcs=185/200 elements=33,32 [2014-01-14]
  if(system=="AsHf") return MISCIBILITY_SYSTEM_MISCIBLE; // AsHf_pv calcs=200/200 elements=33,72 [2014-01-14]
  if(system=="AsHg") return MISCIBILITY_SYSTEM_UNKNOWN; // AsHg calcs=177/200 elements=33,80 [2014-01-14]
  if(system=="AsIn") return MISCIBILITY_SYSTEM_MISCIBLE; // AsIn_d calcs=184/200 elements=33,49 [2014-01-14]
  if(system=="AsIr") return MISCIBILITY_SYSTEM_MISCIBLE; // AsIr calcs=232/200 elements=33,77 [2014-01-14]
  if(system=="AsK") return MISCIBILITY_SYSTEM_MISCIBLE; // AsK_sv calcs=167/200 elements=33,19 [2014-01-14]
  if(system=="AsLa") return MISCIBILITY_SYSTEM_MISCIBLE; // AsLa calcs=187/200 elements=33,57 [2014-01-14]
  if(system=="AsLi") return MISCIBILITY_SYSTEM_MISCIBLE; // AsLi_sv calcs=188/200 elements=33,3 [2014-01-14]
  if(system=="AsMg") return MISCIBILITY_SYSTEM_MISCIBLE; // AsMg_pv calcs=208/200 elements=33,12 [2014-01-14]
  if(system=="AsMn") return MISCIBILITY_SYSTEM_MISCIBLE; // AsMn_pv calcs=193/200 elements=33,25 [2014-01-14]
  if(system=="AsMo") return MISCIBILITY_SYSTEM_MISCIBLE; // AsMo_pv calcs=231/200 elements=33,42 [2014-01-14]
  if(system=="AsNa") return MISCIBILITY_SYSTEM_MISCIBLE; // AsNa_sv calcs=169/200 elements=33,11 [2014-01-14]
  if(system=="AsNb") return MISCIBILITY_SYSTEM_MISCIBLE; // AsNb_sv calcs=230/200 elements=33,41 [2014-01-14]
  if(system=="AsNi") return MISCIBILITY_SYSTEM_MISCIBLE; // AsNi_pv calcs=197/200 elements=33,28 [2014-01-14]
  if(system=="AsOs") return MISCIBILITY_SYSTEM_MISCIBLE; // AsOs_pv calcs=182/200 elements=33,76 [2014-01-14]
  if(system=="AsP") return MISCIBILITY_SYSTEM_NOMIX; // AsP calcs=213/200 elements=33,15 [2014-01-14]
  if(system=="AsPb") return MISCIBILITY_SYSTEM_MISCIBLE; // AsPb_d calcs=234/200 elements=33,82 [2014-01-14]
  if(system=="AsPd") return MISCIBILITY_SYSTEM_MISCIBLE; // AsPd_pv calcs=218/200 elements=33,46 [2014-01-14]
  if(system=="AsPt") return MISCIBILITY_SYSTEM_MISCIBLE; // AsPt calcs=193/200 elements=33,78 [2014-01-14]
  if(system=="AsRe") return MISCIBILITY_SYSTEM_MISCIBLE; // AsRe_pv calcs=182/200 elements=33,75 [2014-01-14]
  if(system=="AsRh") return MISCIBILITY_SYSTEM_MISCIBLE; // AsRh_pv calcs=175/200 elements=33,45 [2014-01-14]
  if(system=="AsRu") return MISCIBILITY_SYSTEM_UNKNOWN; // AsRu_pv calcs=181/200 elements=33,44 [2014-01-14]
  if(system=="AsSb") return MISCIBILITY_SYSTEM_MISCIBLE; // AsSb calcs=186/200 elements=33,51 [2014-01-14]
  if(system=="AsSc") return MISCIBILITY_SYSTEM_MISCIBLE; // AsSc_sv calcs=193/200 elements=33,21 [2014-01-14]
  if(system=="AsSe") return MISCIBILITY_SYSTEM_MISCIBLE; // AsSe calcs=190/200 elements=33,34 [2014-01-14]
  if(system=="AsSi") return MISCIBILITY_SYSTEM_MISCIBLE; // AsSi calcs=198/200 elements=33,14 [2014-01-14]
  if(system=="AsSn") return MISCIBILITY_SYSTEM_MISCIBLE; // AsSn calcs=194/200 elements=33,50 [2014-01-14]
  if(system=="AsSr") return MISCIBILITY_SYSTEM_MISCIBLE; // AsSr_sv calcs=188/200 elements=33,38 [2014-01-14]
  if(system=="AsTa") return MISCIBILITY_SYSTEM_MISCIBLE; // AsTa_pv calcs=230/200 elements=33,73 [2014-01-14]
  if(system=="AsTc") return MISCIBILITY_SYSTEM_MISCIBLE; // AsTc_pv calcs=217/200 elements=33,43 [2014-01-14]
  if(system=="AsTe") return MISCIBILITY_SYSTEM_MISCIBLE; // AsTe calcs=209/200 elements=33,52 [2014-01-14]
  if(system=="AsTi") return MISCIBILITY_SYSTEM_MISCIBLE; // AsTi_sv calcs=232/200 elements=33,22 [2014-01-14]
  if(system=="AsTl") return MISCIBILITY_SYSTEM_MISCIBLE; // AsTl_d calcs=170/200 elements=33,81 [2014-01-14]
  if(system=="AsV") return MISCIBILITY_SYSTEM_MISCIBLE; // AsV_sv calcs=244/200 elements=33,23 [2014-01-14]
  if(system=="AsW") return MISCIBILITY_SYSTEM_MISCIBLE; // AsW_pv calcs=201/200 elements=33,74 [2014-01-14]
  if(system=="AsY") return MISCIBILITY_SYSTEM_MISCIBLE; // AsY_sv calcs=238/200 elements=33,39 [2014-01-14]
  if(system=="AsZn") return MISCIBILITY_SYSTEM_MISCIBLE; // AsZn calcs=189/200 elements=33,30 [2014-01-14]
  if(system=="AsZr") return MISCIBILITY_SYSTEM_MISCIBLE; // AsZr_sv calcs=178/200 elements=33,40 [2014-01-14]
  if(system=="AuB") return MISCIBILITY_SYSTEM_MISCIBLE; // AuB_h calcs=179/200 elements=79,5 [2014-01-14]
  if(system=="AuBa") return MISCIBILITY_SYSTEM_MISCIBLE; // AuBa_sv calcs=183/200 elements=79,56 [2014-01-14]
  if(system=="AuBe") return MISCIBILITY_SYSTEM_MISCIBLE; // AuBe_sv calcs=187/200 elements=79,4 [2014-01-14]
  if(system=="AuBi") return MISCIBILITY_SYSTEM_MISCIBLE; // AuBi_d calcs=256/200 elements=79,83 [2014-01-14]
  if(system=="AuBr") return MISCIBILITY_SYSTEM_MISCIBLE; // AuBr calcs=172/200 elements=79,35 [2014-01-14]
  if(system=="AuCa") return MISCIBILITY_SYSTEM_MISCIBLE; // AuCa_sv calcs=179/200 elements=79,20 [2014-01-14]
  if(system=="AuCd") return MISCIBILITY_SYSTEM_MISCIBLE; // AuCd calcs=293/200 elements=79,48 [2014-01-14]
  if(system=="AuCl") return MISCIBILITY_SYSTEM_MISCIBLE; // AuCl calcs=190/200 elements=79,17 [2014-01-14]
  if(system=="AuCo") return MISCIBILITY_SYSTEM_NOMIX; // AuCo calcs=231/200 elements=79,27 [2014-01-14]
  if(system=="AuCr") return MISCIBILITY_SYSTEM_NOMIX; // AuCr_pv calcs=206/200 elements=79,24 [2014-01-14]
  if(system=="AuCu") return MISCIBILITY_SYSTEM_MISCIBLE; // AuCu_pv calcs=300/200 elements=79,29 [2014-01-14]
  if(system=="AuFe") return MISCIBILITY_SYSTEM_NOMIX; // AuFe_pv calcs=201/200 elements=79,26 [2014-01-14]
  if(system=="AuGa") return MISCIBILITY_SYSTEM_MISCIBLE; // AuGa_h calcs=183/200 elements=79,31 [2014-01-14]
  if(system=="AuGe") return MISCIBILITY_SYSTEM_NOMIX; // AuGe_h calcs=209/200 elements=79,32 [2014-01-14]
  if(system=="AuHf") return MISCIBILITY_SYSTEM_MISCIBLE; // AuHf_pv calcs=298/200 elements=79,72 [2014-01-14]
  if(system=="AuHg") return MISCIBILITY_SYSTEM_NOMIX; // AuHg calcs=204/200 elements=79,80 [2014-01-14]
  if(system=="AuIn") return MISCIBILITY_SYSTEM_MISCIBLE; // AuIn_d calcs=184/200 elements=79,49 [2014-01-14]
  if(system=="AuIr") return MISCIBILITY_SYSTEM_NOMIX; // AuIr calcs=205/200 elements=79,77 [2014-01-14]
  if(system=="AuK") return MISCIBILITY_SYSTEM_MISCIBLE; // AuK_sv calcs=183/200 elements=79,19 [2014-01-14]
  if(system=="AuLa") return MISCIBILITY_SYSTEM_MISCIBLE; // AuLa calcs=295/200 elements=79,57 [2014-01-14]
  if(system=="AuLi") return MISCIBILITY_SYSTEM_MISCIBLE; // AuLi_sv calcs=180/200 elements=79,3 [2014-01-14]
  if(system=="AuMg") return MISCIBILITY_SYSTEM_MISCIBLE; // AuMg_pv calcs=280/200 elements=79,12 [2014-01-14]
  if(system=="AuMn") return MISCIBILITY_SYSTEM_MISCIBLE; // AuMn_pv calcs=294/200 elements=79,25 [2014-01-14]
  if(system=="AuMo") return MISCIBILITY_SYSTEM_NOMIX; // AuMo_pv calcs=203/200 elements=79,42 [2014-01-14]
  if(system=="AuNa") return MISCIBILITY_SYSTEM_MISCIBLE; // AuNa_sv calcs=158/200 elements=79,11 [2014-01-14]
  if(system=="AuNb") return MISCIBILITY_SYSTEM_MISCIBLE; // AuNb_sv calcs=289/200 elements=79,41 [2014-01-14]
  if(system=="AuNi") return MISCIBILITY_SYSTEM_NOMIX; // AuNi_pv calcs=201/200 elements=79,28 [2014-01-14]
  if(system=="AuOs") return MISCIBILITY_SYSTEM_NOMIX; // AuOs_pv calcs=204/200 elements=79,76 [2014-01-14]
  if(system=="AuP") return MISCIBILITY_SYSTEM_MISCIBLE; // AuP calcs=202/200 elements=79,15 [2014-01-14]
  if(system=="AuPb") return MISCIBILITY_SYSTEM_MISCIBLE; // AuPb_d calcs=239/200 elements=79,82 [2014-01-14]
  if(system=="AuPd") return MISCIBILITY_SYSTEM_MISCIBLE; // AuPd_pv calcs=261/200 elements=79,46 [2014-01-14]
  if(system=="AuPt") return MISCIBILITY_SYSTEM_NOMIX; // AuPt calcs=206/200 elements=79,78 [2014-01-14]
  if(system=="AuRe") return MISCIBILITY_SYSTEM_NOMIX; // AuRe_pv calcs=208/200 elements=79,75 [2014-01-14]
  if(system=="AuRh") return MISCIBILITY_SYSTEM_NOMIX; // AuRh_pv calcs=206/200 elements=79,45 [2014-01-14]
  if(system=="AuRu") return MISCIBILITY_SYSTEM_NOMIX; // AuRu_pv calcs=205/200 elements=79,44 [2014-01-14]
  if(system=="AuSb") return MISCIBILITY_SYSTEM_MISCIBLE; // AuSb calcs=263/200 elements=79,51 [2014-01-14]
  if(system=="AuSc") return MISCIBILITY_SYSTEM_MISCIBLE; // AuSc_sv calcs=271/200 elements=79,21 [2014-01-14]
  if(system=="AuSe") return MISCIBILITY_SYSTEM_MISCIBLE; // AuSe calcs=237/200 elements=79,34 [2014-01-14]
  if(system=="AuSi") return MISCIBILITY_SYSTEM_UNKNOWN; // AuSi calcs=189/200 elements=79,14 [2014-01-14]
  if(system=="AuSn") return MISCIBILITY_SYSTEM_MISCIBLE; // AuSn calcs=238/200 elements=79,50 [2014-01-14]
  if(system=="AuSr") return MISCIBILITY_SYSTEM_MISCIBLE; // AuSr_sv calcs=169/200 elements=79,38 [2014-01-14]
  if(system=="AuTa") return MISCIBILITY_SYSTEM_MISCIBLE; // AuTa_pv calcs=258/200 elements=79,73 [2014-01-14]
  if(system=="AuTc") return MISCIBILITY_SYSTEM_NOMIX; // AuTc_pv calcs=203/200 elements=79,43 [2014-01-14]
  if(system=="AuTe") return MISCIBILITY_SYSTEM_MISCIBLE; // AuTe calcs=197/200 elements=79,52 [2014-01-14]
  if(system=="AuTi") return MISCIBILITY_SYSTEM_MISCIBLE; // AuTi_sv calcs=265/200 elements=79,22 [2014-01-14]
  if(system=="AuTl") return MISCIBILITY_SYSTEM_MISCIBLE; // AuTl_d calcs=185/200 elements=79,81 [2014-01-14]
  if(system=="AuV") return MISCIBILITY_SYSTEM_MISCIBLE; // AuV_sv calcs=258/200 elements=79,23 [2014-01-14]
  if(system=="AuW") return MISCIBILITY_SYSTEM_NOMIX; // AuW_pv calcs=204/200 elements=79,74 [2014-01-14]
  if(system=="AuY") return MISCIBILITY_SYSTEM_MISCIBLE; // AuY_sv calcs=275/200 elements=79,39 [2014-01-14]
  if(system=="AuZn") return MISCIBILITY_SYSTEM_MISCIBLE; // AuZn calcs=271/200 elements=79,30 [2014-01-14]
  if(system=="AuZr") return MISCIBILITY_SYSTEM_MISCIBLE; // AuZr_sv calcs=260/200 elements=79,40 [2014-01-14]
  if(system=="BBa") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hBa_sv calcs=155/200 elements=5,56 [2014-01-14]
  if(system=="BBe") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hBe_sv calcs=179/200 elements=5,4 [2014-01-14]
  if(system=="BBi") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hBi_d calcs=145/200 elements=5,83 [2014-01-14]
  if(system=="BBr") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hBr calcs=172/200 elements=5,35 [2014-01-14]
  if(system=="BCa") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hCa_sv calcs=163/200 elements=5,20 [2014-01-14]
  if(system=="BCd") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hCd calcs=178/200 elements=5,48 [2014-01-14]
  if(system=="BCl") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hCl calcs=181/200 elements=5,17 [2014-01-14]
  if(system=="BCo") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hCo calcs=235/200 elements=5,27 [2014-01-14]
  if(system=="BCr") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hCr_pv calcs=243/200 elements=5,24 [2014-01-14]
  if(system=="BCu") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hCu_pv calcs=214/200 elements=5,29 [2014-01-14]
  if(system=="BFe") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hFe_pv calcs=266/200 elements=5,26 [2014-01-14]
  if(system=="BGa") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hGa_h calcs=159/200 elements=5,31 [2014-01-14]
  if(system=="BGe") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hGe_h calcs=151/200 elements=5,32 [2014-01-14]
  if(system=="BHf") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hHf_pv calcs=195/200 elements=5,72 [2014-01-14]
  if(system=="BHg") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hHg calcs=172/200 elements=5,80 [2014-01-14]
  if(system=="BIn") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hIn_d calcs=197/200 elements=5,49 [2014-01-14]
  if(system=="BIr") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hIr calcs=175/200 elements=5,77 [2014-01-14]
  if(system=="BK") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hK_sv calcs=146/200 elements=5,19 [2014-01-14]
  if(system=="BLa") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hLa calcs=193/200 elements=5,57 [2014-01-14]
  if(system=="BLi") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hLi_sv calcs=194/200 elements=5,3 [2014-01-14]
  if(system=="BMg") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hMg_pv calcs=193/200 elements=5,12 [2014-01-14]
  if(system=="BMn") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hMn_pv calcs=187/200 elements=5,25 [2014-01-14]
  if(system=="BMo") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hMo_pv calcs=200/200 elements=5,42 [2014-01-14]
  if(system=="BNa") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hNa_sv calcs=169/200 elements=5,11 [2014-01-14]
  if(system=="BNb") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hNb_sv calcs=178/200 elements=5,41 [2014-01-14]
  if(system=="BNi") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hNi_pv calcs=188/200 elements=5,28 [2014-01-14]
  if(system=="BOs") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hOs_pv calcs=213/200 elements=5,76 [2014-01-14]
  if(system=="BP") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hP calcs=211/200 elements=5,15 [2014-01-14]
  if(system=="BPb") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hPb_d calcs=177/200 elements=5,82 [2014-01-14]
  if(system=="BPd") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hPd_pv calcs=199/200 elements=5,46 [2014-01-14]
  if(system=="BPt") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hPt calcs=213/200 elements=5,78 [2014-01-14]
  if(system=="BRe") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hRe_pv calcs=182/200 elements=5,75 [2014-01-14]
  if(system=="BRh") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hRh_pv calcs=174/200 elements=5,45 [2014-01-14]
  if(system=="BRu") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hRu_pv calcs=169/200 elements=5,44 [2014-01-14]
  if(system=="BSb") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hSb calcs=167/200 elements=5,51 [2014-01-14]
  if(system=="BSc") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hSc_sv calcs=232/200 elements=5,21 [2014-01-14]
  if(system=="BSe") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hSe calcs=227/200 elements=5,34 [2014-01-14]
  if(system=="BSi") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hSi calcs=202/200 elements=5,14 [2014-01-14]
  if(system=="BSn") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hSn calcs=172/200 elements=5,50 [2014-01-14]
  if(system=="BSr") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hSr_sv calcs=156/200 elements=5,38 [2014-01-14]
  if(system=="BTa") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hTa_pv calcs=234/200 elements=5,73 [2014-01-14]
  if(system=="BTc") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hTc_pv calcs=236/200 elements=5,43 [2014-01-14]
  if(system=="BTe") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hTe calcs=172/200 elements=5,52 [2014-01-14]
  if(system=="BTi") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hTi_sv calcs=180/200 elements=5,22 [2014-01-14]
  if(system=="BTl") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hTl_d calcs=180/200 elements=5,81 [2014-01-14]
  if(system=="BV") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hV_sv calcs=226/200 elements=5,23 [2014-01-14]
  if(system=="BW") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hW_pv calcs=190/200 elements=5,74 [2014-01-14]
  if(system=="BY") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hY_sv calcs=216/200 elements=5,39 [2014-01-14]
  if(system=="BZn") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hZn calcs=181/200 elements=5,30 [2014-01-14]
  if(system=="BZr") return MISCIBILITY_SYSTEM_MISCIBLE; // B_hZr_sv calcs=179/200 elements=5,40 [2014-01-14]
  if(system=="BHf") return MISCIBILITY_SYSTEM_MISCIBLE; // B_sHf_pv calcs=249/200 elements=5,72 [2014-01-14]
  if(system=="BaBe") return MISCIBILITY_SYSTEM_UNKNOWN; // Ba_svBe_sv calcs=170/200 elements=56,4 [2014-01-14]
  if(system=="BaBi") return MISCIBILITY_SYSTEM_MISCIBLE; // Ba_svBi_d calcs=181/200 elements=56,83 [2014-01-14]
  if(system=="BaBr") return MISCIBILITY_SYSTEM_MISCIBLE; // Ba_svBr calcs=169/200 elements=56,35 [2014-01-14]
  if(system=="BaCa") return MISCIBILITY_SYSTEM_UNKNOWN; // Ba_svCa_sv calcs=169/200 elements=56,20 [2014-01-14]
  if(system=="BaCd") return MISCIBILITY_SYSTEM_MISCIBLE; // Ba_svCd calcs=175/200 elements=56,48 [2014-01-14]
  if(system=="BaCl") return MISCIBILITY_SYSTEM_MISCIBLE; // Ba_svCl calcs=176/200 elements=56,17 [2014-01-14]
  if(system=="BaCo") return MISCIBILITY_SYSTEM_UNKNOWN; // Ba_svCo calcs=152/200 elements=56,27 [2014-01-14]
  if(system=="BaCr") return MISCIBILITY_SYSTEM_UNKNOWN; // Ba_svCr_pv calcs=163/200 elements=56,24 [2014-01-14]
  if(system=="BaCu") return MISCIBILITY_SYSTEM_MISCIBLE; // Ba_svCu_pv calcs=149/200 elements=56,29 [2014-01-14]
  if(system=="BaFe") return MISCIBILITY_SYSTEM_UNKNOWN; // Ba_svFe_pv calcs=170/200 elements=56,26 [2014-01-14]
  if(system=="BaGa") return MISCIBILITY_SYSTEM_MISCIBLE; // Ba_svGa_h calcs=132/200 elements=56,31 [2014-01-14]
  if(system=="BaGe") return MISCIBILITY_SYSTEM_MISCIBLE; // Ba_svGe_h calcs=173/200 elements=56,32 [2014-01-14]
  if(system=="BaHf") return MISCIBILITY_SYSTEM_NOMIX; // Ba_svHf_pv calcs=214/200 elements=56,72 [2014-01-14]
  if(system=="BaHg") return MISCIBILITY_SYSTEM_MISCIBLE; // Ba_svHg calcs=164/200 elements=56,80 [2014-01-14]
  if(system=="BaIn") return MISCIBILITY_SYSTEM_MISCIBLE; // Ba_svIn_d calcs=149/200 elements=56,49 [2014-01-14]
  if(system=="BaIr") return MISCIBILITY_SYSTEM_MISCIBLE; // Ba_svIr calcs=159/200 elements=56,77 [2014-01-14]
  if(system=="BaK") return MISCIBILITY_SYSTEM_UNKNOWN; // Ba_svK_sv calcs=172/200 elements=56,19 [2014-01-14]
  if(system=="BaLa") return MISCIBILITY_SYSTEM_UNKNOWN; // Ba_svLa calcs=161/200 elements=56,57 [2014-01-14]
  if(system=="BaLi") return MISCIBILITY_SYSTEM_UNKNOWN; // Ba_svLi_sv calcs=179/200 elements=56,3 [2014-01-14]
  if(system=="BaMg") return MISCIBILITY_SYSTEM_MISCIBLE; // Ba_svMg_pv calcs=263/200 elements=56,12 [2014-01-14]
  if(system=="BaMn") return MISCIBILITY_SYSTEM_UNKNOWN; // Ba_svMn_pv calcs=141/200 elements=56,25 [2014-01-14]
  if(system=="BaMo") return MISCIBILITY_SYSTEM_UNKNOWN; // Ba_svMo_pv calcs=141/200 elements=56,42 [2014-01-14]
  if(system=="BaNa") return MISCIBILITY_SYSTEM_UNKNOWN; // Ba_svNa_sv calcs=125/200 elements=56,11 [2014-01-14]
  if(system=="BaNb") return MISCIBILITY_SYSTEM_UNKNOWN; // Ba_svNb_sv calcs=156/200 elements=56,41 [2014-01-14]
  if(system=="BaNi") return MISCIBILITY_SYSTEM_MISCIBLE; // Ba_svNi_pv calcs=138/200 elements=56,28 [2014-01-14]
  if(system=="BaOs") return MISCIBILITY_SYSTEM_UNKNOWN; // Ba_svOs_pv calcs=145/200 elements=56,76 [2014-01-14]
  if(system=="BaP") return MISCIBILITY_SYSTEM_MISCIBLE; // Ba_svP calcs=195/200 elements=56,15 [2014-01-14]
  if(system=="BaPb") return MISCIBILITY_SYSTEM_MISCIBLE; // Ba_svPb_d calcs=175/200 elements=56,82 [2014-01-14]
  if(system=="BaPd") return MISCIBILITY_SYSTEM_MISCIBLE; // Ba_svPd_pv calcs=239/200 elements=56,46 [2014-01-14]
  if(system=="BaPt") return MISCIBILITY_SYSTEM_MISCIBLE; // Ba_svPt calcs=240/200 elements=56,78 [2014-01-14]
  if(system=="BaRe") return MISCIBILITY_SYSTEM_UNKNOWN; // Ba_svRe_pv calcs=148/200 elements=56,75 [2014-01-14]
  if(system=="BaRh") return MISCIBILITY_SYSTEM_MISCIBLE; // Ba_svRh_pv calcs=149/200 elements=56,45 [2014-01-14]
  if(system=="BaRu") return MISCIBILITY_SYSTEM_UNKNOWN; // Ba_svRu_pv calcs=153/200 elements=56,44 [2014-01-14]
  if(system=="BaSb") return MISCIBILITY_SYSTEM_MISCIBLE; // Ba_svSb calcs=161/200 elements=56,51 [2014-01-14]
  if(system=="BaSc") return MISCIBILITY_SYSTEM_UNKNOWN; // Ba_svSc_sv calcs=144/200 elements=56,21 [2014-01-14]
  if(system=="BaSe") return MISCIBILITY_SYSTEM_MISCIBLE; // Ba_svSe calcs=174/200 elements=56,34 [2014-01-14]
  if(system=="BaSi") return MISCIBILITY_SYSTEM_MISCIBLE; // Ba_svSi calcs=172/200 elements=56,14 [2014-01-14]
  if(system=="BaSn") return MISCIBILITY_SYSTEM_MISCIBLE; // Ba_svSn calcs=164/200 elements=56,50 [2014-01-14]
  if(system=="BaSr") return MISCIBILITY_SYSTEM_UNKNOWN; // Ba_svSr_sv calcs=164/200 elements=56,38 [2014-01-14]
  if(system=="BaTa") return MISCIBILITY_SYSTEM_UNKNOWN; // Ba_svTa_pv calcs=143/200 elements=56,73 [2014-01-14]
  if(system=="BaTc") return MISCIBILITY_SYSTEM_UNKNOWN; // Ba_svTc_pv calcs=141/200 elements=56,43 [2014-01-14]
  if(system=="BaTe") return MISCIBILITY_SYSTEM_MISCIBLE; // Ba_svTe calcs=155/200 elements=56,52 [2014-01-14]
  if(system=="BaTi") return MISCIBILITY_SYSTEM_UNKNOWN; // Ba_svTi_sv calcs=151/200 elements=56,22 [2014-01-14]
  if(system=="BaTl") return MISCIBILITY_SYSTEM_MISCIBLE; // Ba_svTl_d calcs=149/200 elements=56,81 [2014-01-14]
  if(system=="BaV") return MISCIBILITY_SYSTEM_UNKNOWN; // Ba_svV_sv calcs=147/200 elements=56,23 [2014-01-14]
  if(system=="BaW") return MISCIBILITY_SYSTEM_UNKNOWN; // Ba_svW_pv calcs=138/200 elements=56,74 [2014-01-14]
  if(system=="BaY") return MISCIBILITY_SYSTEM_UNKNOWN; // Ba_svY_sv calcs=147/200 elements=56,39 [2014-01-14]
  if(system=="BaZn") return MISCIBILITY_SYSTEM_MISCIBLE; // Ba_svZn calcs=147/200 elements=56,30 [2014-01-14]
  if(system=="BaZr") return MISCIBILITY_SYSTEM_UNKNOWN; // Ba_svZr_sv calcs=148/200 elements=56,40 [2014-01-14]
  if(system=="BeHf") return MISCIBILITY_SYSTEM_MISCIBLE; // BeHf_pv calcs=262/200 elements=4,72 [2014-01-14]
  if(system=="BeBi") return MISCIBILITY_SYSTEM_UNKNOWN; // Be_svBi_d calcs=140/200 elements=4,83 [2014-01-14]
  if(system=="BeBr") return MISCIBILITY_SYSTEM_MISCIBLE; // Be_svBr calcs=147/200 elements=4,35 [2014-01-14]
  if(system=="BeCa") return MISCIBILITY_SYSTEM_MISCIBLE; // Be_svCa_sv calcs=141/200 elements=4,20 [2014-01-14]
  if(system=="BeCd") return MISCIBILITY_SYSTEM_NOMIX; // Be_svCd calcs=237/200 elements=4,48 [2014-01-14]
  if(system=="BeCl") return MISCIBILITY_SYSTEM_MISCIBLE; // Be_svCl calcs=143/200 elements=4,17 [2014-01-14]
  if(system=="BeCo") return MISCIBILITY_SYSTEM_MISCIBLE; // Be_svCo calcs=253/200 elements=4,27 [2014-01-14]
  if(system=="BeCr") return MISCIBILITY_SYSTEM_MISCIBLE; // Be_svCr_pv calcs=142/200 elements=4,24 [2014-01-14]
  if(system=="BeCu") return MISCIBILITY_SYSTEM_MISCIBLE; // Be_svCu_pv calcs=152/200 elements=4,29 [2014-01-14]
  if(system=="BeFe") return MISCIBILITY_SYSTEM_MISCIBLE; // Be_svFe_pv calcs=174/200 elements=4,26 [2014-01-14]
  if(system=="BeGa") return MISCIBILITY_SYSTEM_UNKNOWN; // Be_svGa_h calcs=150/200 elements=4,31 [2014-01-14]
  if(system=="BeGe") return MISCIBILITY_SYSTEM_UNKNOWN; // Be_svGe_h calcs=137/200 elements=4,32 [2014-01-14]
  if(system=="BeHg") return MISCIBILITY_SYSTEM_UNKNOWN; // Be_svHg calcs=139/200 elements=4,80 [2014-01-14]
  if(system=="BeIn") return MISCIBILITY_SYSTEM_UNKNOWN; // Be_svIn_d calcs=131/200 elements=4,49 [2014-01-14]
  if(system=="BeIr") return MISCIBILITY_SYSTEM_MISCIBLE; // Be_svIr calcs=151/200 elements=4,77 [2014-01-14]
  if(system=="BeK") return MISCIBILITY_SYSTEM_UNKNOWN; // Be_svK_sv calcs=129/200 elements=4,19 [2014-01-14]
  if(system=="BeLa") return MISCIBILITY_SYSTEM_MISCIBLE; // Be_svLa calcs=128/200 elements=4,57 [2014-01-14]
  if(system=="BeLi") return MISCIBILITY_SYSTEM_UNKNOWN; // Be_svLi_sv calcs=138/200 elements=4,3 [2014-01-14]
  if(system=="BeMg") return MISCIBILITY_SYSTEM_NOMIX; // Be_svMg_pv calcs=255/200 elements=4,12 [2014-01-14]
  if(system=="BeMn") return MISCIBILITY_SYSTEM_MISCIBLE; // Be_svMn_pv calcs=135/200 elements=4,25 [2014-01-14]
  if(system=="BeMo") return MISCIBILITY_SYSTEM_MISCIBLE; // Be_svMo_pv calcs=135/200 elements=4,42 [2014-01-14]
  if(system=="BeNa") return MISCIBILITY_SYSTEM_UNKNOWN; // Be_svNa_sv calcs=118/200 elements=4,11 [2014-01-14]
  if(system=="BeNb") return MISCIBILITY_SYSTEM_MISCIBLE; // Be_svNb_sv calcs=163/200 elements=4,41 [2014-01-14]
  if(system=="BeNi") return MISCIBILITY_SYSTEM_MISCIBLE; // Be_svNi_pv calcs=139/200 elements=4,28 [2014-01-14]
  if(system=="BeOs") return MISCIBILITY_SYSTEM_MISCIBLE; // Be_svOs_pv calcs=247/200 elements=4,76 [2014-01-14]
  if(system=="BeP") return MISCIBILITY_SYSTEM_MISCIBLE; // Be_svP calcs=154/200 elements=4,15 [2014-01-14]
  if(system=="BePb") return MISCIBILITY_SYSTEM_UNKNOWN; // Be_svPb_d calcs=152/200 elements=4,82 [2014-01-14]
  if(system=="BePd") return MISCIBILITY_SYSTEM_MISCIBLE; // Be_svPd_pv calcs=254/200 elements=4,46 [2014-01-14]
  if(system=="BePt") return MISCIBILITY_SYSTEM_MISCIBLE; // Be_svPt calcs=252/200 elements=4,78 [2014-01-14]
  if(system=="BeRe") return MISCIBILITY_SYSTEM_MISCIBLE; // Be_svRe_pv calcs=247/200 elements=4,75 [2014-01-14]
  if(system=="BeRh") return MISCIBILITY_SYSTEM_MISCIBLE; // Be_svRh_pv calcs=246/200 elements=4,45 [2014-01-14]
  if(system=="BeRu") return MISCIBILITY_SYSTEM_MISCIBLE; // Be_svRu_pv calcs=248/200 elements=4,44 [2014-01-14]
  if(system=="BeSb") return MISCIBILITY_SYSTEM_UNKNOWN; // Be_svSb calcs=126/200 elements=4,51 [2014-01-14]
  if(system=="BeSc") return MISCIBILITY_SYSTEM_MISCIBLE; // Be_svSc_sv calcs=250/200 elements=4,21 [2014-01-14]
  if(system=="BeSe") return MISCIBILITY_SYSTEM_UNKNOWN; // Be_svSe calcs=127/200 elements=4,34 [2014-01-14]
  if(system=="BeSi") return MISCIBILITY_SYSTEM_MISCIBLE; // Be_svSi calcs=129/200 elements=4,14 [2014-01-14]
  if(system=="BeSn") return MISCIBILITY_SYSTEM_UNKNOWN; // Be_svSn calcs=114/200 elements=4,50 [2014-01-14]
  if(system=="BeSr") return MISCIBILITY_SYSTEM_MISCIBLE; // Be_svSr_sv calcs=122/200 elements=4,38 [2014-01-14]
  if(system=="BeTa") return MISCIBILITY_SYSTEM_MISCIBLE; // Be_svTa_pv calcs=134/200 elements=4,73 [2014-01-14]
  if(system=="BeTc") return MISCIBILITY_SYSTEM_MISCIBLE; // Be_svTc_pv calcs=246/200 elements=4,43 [2014-01-14]
  if(system=="BeTe") return MISCIBILITY_SYSTEM_MISCIBLE; // Be_svTe calcs=135/200 elements=4,52 [2014-01-14]
  if(system=="BeTi") return MISCIBILITY_SYSTEM_MISCIBLE; // Be_svTi_sv calcs=260/200 elements=4,22 [2014-01-14]
  if(system=="BeTl") return MISCIBILITY_SYSTEM_NOMIX; // Be_svTl_d calcs=228/200 elements=4,81 [2014-01-14]
  if(system=="BeV") return MISCIBILITY_SYSTEM_MISCIBLE; // Be_svV_sv calcs=126/200 elements=4,23 [2014-01-14]
  if(system=="BeW") return MISCIBILITY_SYSTEM_MISCIBLE; // Be_svW_pv calcs=121/200 elements=4,74 [2014-01-14]
  if(system=="BeY") return MISCIBILITY_SYSTEM_MISCIBLE; // Be_svY_sv calcs=244/200 elements=4,39 [2014-01-14]
  if(system=="BeZn") return MISCIBILITY_SYSTEM_NOMIX; // Be_svZn calcs=240/200 elements=4,30 [2014-01-14]
  if(system=="BeZr") return MISCIBILITY_SYSTEM_MISCIBLE; // Be_svZr_sv calcs=250/200 elements=4,40 [2014-01-14]
  if(system=="BiBr") return MISCIBILITY_SYSTEM_MISCIBLE; // Bi_dBr calcs=127/200 elements=83,35 [2014-01-14]
  if(system=="BiCa") return MISCIBILITY_SYSTEM_MISCIBLE; // Bi_dCa_sv calcs=106/200 elements=83,20 [2014-01-14]
  if(system=="BiCd") return MISCIBILITY_SYSTEM_NOMIX; // Bi_dCd calcs=236/200 elements=83,48 [2014-01-14]
  if(system=="BiCl") return MISCIBILITY_SYSTEM_MISCIBLE; // Bi_dCl calcs=121/200 elements=83,17 [2014-01-14]
  if(system=="BiCo") return MISCIBILITY_SYSTEM_NOMIX; // Bi_dCo calcs=235/200 elements=83,27 [2014-01-14]
  if(system=="BiCr") return MISCIBILITY_SYSTEM_NOMIX; // Bi_dCr_pv calcs=245/200 elements=83,24 [2014-01-14]
  if(system=="BiCu") return MISCIBILITY_SYSTEM_NOMIX; // Bi_dCu_pv calcs=223/200 elements=83,29 [2014-01-14]
  if(system=="BiFe") return MISCIBILITY_SYSTEM_NOMIX; // Bi_dFe_pv calcs=219/200 elements=83,26 [2014-01-14]
  if(system=="BiGa") return MISCIBILITY_SYSTEM_MISCIBLE; // Bi_dGa_h calcs=174/200 elements=83,31 [2014-01-14]
  if(system=="BiGe") return MISCIBILITY_SYSTEM_UNKNOWN; // Bi_dGe_h calcs=123/200 elements=83,32 [2014-01-14]
  if(system=="BiHf") return MISCIBILITY_SYSTEM_MISCIBLE; // Bi_dHf_pv calcs=365/200 elements=83,72 [2014-01-14]
  if(system=="BiHg") return MISCIBILITY_SYSTEM_NOMIX; // Bi_dHg calcs=302/200 elements=83,80 [2014-01-14]
  if(system=="BiIn") return MISCIBILITY_SYSTEM_MISCIBLE; // Bi_dIn_d calcs=355/200 elements=83,49 [2014-01-14]
  if(system=="BiIr") return MISCIBILITY_SYSTEM_MISCIBLE; // Bi_dIr calcs=364/200 elements=83,77 [2014-01-14]
  if(system=="BiK") return MISCIBILITY_SYSTEM_MISCIBLE; // Bi_dK_sv calcs=115/200 elements=83,19 [2014-01-14]
  if(system=="BiLa") return MISCIBILITY_SYSTEM_MISCIBLE; // Bi_dLa calcs=231/200 elements=83,57 [2014-01-14]
  if(system=="BiLi") return MISCIBILITY_SYSTEM_MISCIBLE; // Bi_dLi_sv calcs=120/200 elements=83,3 [2014-01-14]
  if(system=="BiMg") return MISCIBILITY_SYSTEM_MISCIBLE; // Bi_dMg_pv calcs=206/200 elements=83,12 [2014-01-14]
  if(system=="BiMn") return MISCIBILITY_SYSTEM_NOMIX; // Bi_dMn_pv calcs=200/200 elements=83,25 [2014-01-14]
  if(system=="BiMo") return MISCIBILITY_SYSTEM_NOMIX; // Bi_dMo_pv calcs=242/200 elements=83,42 [2014-01-14]
  if(system=="BiNa") return MISCIBILITY_SYSTEM_MISCIBLE; // Bi_dNa_sv calcs=103/200 elements=83,11 [2014-01-14]
  if(system=="BiNb") return MISCIBILITY_SYSTEM_MISCIBLE; // Bi_dNb_sv calcs=220/200 elements=83,41 [2014-01-14]
  if(system=="BiNi") return MISCIBILITY_SYSTEM_MISCIBLE; // Bi_dNi_pv calcs=252/200 elements=83,28 [2014-01-14]
  if(system=="BiOs") return MISCIBILITY_SYSTEM_NOMIX; // Bi_dOs_pv calcs=237/200 elements=83,76 [2014-01-14]
  if(system=="BiP") return MISCIBILITY_SYSTEM_NOMIX; // Bi_dP calcs=214/200 elements=83,15 [2014-01-14]
  if(system=="BiPb") return MISCIBILITY_SYSTEM_MISCIBLE; // Bi_dPb_d calcs=156/200 elements=83,82 [2014-01-14]
  if(system=="BiPd") return MISCIBILITY_SYSTEM_MISCIBLE; // Bi_dPd_pv calcs=255/200 elements=83,46 [2014-01-14]
  if(system=="BiPt") return MISCIBILITY_SYSTEM_MISCIBLE; // Bi_dPt calcs=258/200 elements=83,78 [2014-01-14]
  if(system=="BiRe") return MISCIBILITY_SYSTEM_NOMIX; // Bi_dRe_pv calcs=228/200 elements=83,75 [2014-01-14]
  if(system=="BiRh") return MISCIBILITY_SYSTEM_MISCIBLE; // Bi_dRh_pv calcs=259/200 elements=83,45 [2014-01-14]
  if(system=="BiRu") return MISCIBILITY_SYSTEM_NOMIX; // Bi_dRu_pv calcs=222/200 elements=83,44 [2014-01-14]
  if(system=="BiSb") return MISCIBILITY_SYSTEM_MISCIBLE; // Bi_dSb calcs=116/200 elements=83,51 [2014-01-14]
  if(system=="BiSc") return MISCIBILITY_SYSTEM_MISCIBLE; // Bi_dSc_sv calcs=244/200 elements=83,21 [2014-01-14]
  if(system=="BiSe") return MISCIBILITY_SYSTEM_MISCIBLE; // Bi_dSe calcs=123/200 elements=83,34 [2014-01-14]
  if(system=="BiSi") return MISCIBILITY_SYSTEM_UNKNOWN; // Bi_dSi calcs=192/200 elements=83,14 [2014-01-14]
  if(system=="BiSn") return MISCIBILITY_SYSTEM_UNKNOWN; // Bi_dSn calcs=198/200 elements=83,50 [2014-01-14]
  if(system=="BiSr") return MISCIBILITY_SYSTEM_MISCIBLE; // Bi_dSr_sv calcs=125/200 elements=83,38 [2014-01-14]
  if(system=="BiTa") return MISCIBILITY_SYSTEM_NOMIX; // Bi_dTa_pv calcs=218/200 elements=83,73 [2014-01-14]
  if(system=="BiTc") return MISCIBILITY_SYSTEM_NOMIX; // Bi_dTc_pv calcs=222/200 elements=83,43 [2014-01-14]
  if(system=="BiTe") return MISCIBILITY_SYSTEM_MISCIBLE; // Bi_dTe calcs=123/200 elements=83,52 [2014-01-14]
  if(system=="BiTi") return MISCIBILITY_SYSTEM_MISCIBLE; // Bi_dTi_sv calcs=212/200 elements=83,22 [2014-01-14]
  if(system=="BiTl") return MISCIBILITY_SYSTEM_MISCIBLE; // Bi_dTl_d calcs=128/200 elements=83,81 [2014-01-14]
  if(system=="BiV") return MISCIBILITY_SYSTEM_NOMIX; // Bi_dV_sv calcs=214/200 elements=83,23 [2014-01-14]
  if(system=="BiW") return MISCIBILITY_SYSTEM_NOMIX; // Bi_dW_pv calcs=206/200 elements=83,74 [2014-01-14]
  if(system=="BiY") return MISCIBILITY_SYSTEM_MISCIBLE; // Bi_dY_sv calcs=230/200 elements=83,39 [2014-01-14]
  if(system=="BiZn") return MISCIBILITY_SYSTEM_NOMIX; // Bi_dZn calcs=203/200 elements=83,30 [2014-01-14]
  if(system=="BiZr") return MISCIBILITY_SYSTEM_MISCIBLE; // Bi_dZr_sv calcs=228/200 elements=83,40 [2014-01-14]
  if(system=="BrCa") return MISCIBILITY_SYSTEM_MISCIBLE; // BrCa_sv calcs=116/200 elements=35,20 [2014-01-14]
  if(system=="BrCd") return MISCIBILITY_SYSTEM_MISCIBLE; // BrCd calcs=121/200 elements=35,48 [2014-01-14]
  if(system=="BrCl") return MISCIBILITY_SYSTEM_MISCIBLE; // BrCl calcs=114/200 elements=35,17 [2014-01-14]
  if(system=="BrCo") return MISCIBILITY_SYSTEM_MISCIBLE; // BrCo calcs=117/200 elements=35,27 [2014-01-14]
  if(system=="BrCr") return MISCIBILITY_SYSTEM_MISCIBLE; // BrCr_pv calcs=119/200 elements=35,24 [2014-01-14]
  if(system=="BrCu") return MISCIBILITY_SYSTEM_MISCIBLE; // BrCu_pv calcs=109/200 elements=35,29 [2014-01-14]
  if(system=="BrFe") return MISCIBILITY_SYSTEM_MISCIBLE; // BrFe_pv calcs=157/200 elements=35,26 [2014-01-14]
  if(system=="BrGa") return MISCIBILITY_SYSTEM_MISCIBLE; // BrGa_h calcs=119/200 elements=35,31 [2014-01-14]
  if(system=="BrGe") return MISCIBILITY_SYSTEM_MISCIBLE; // BrGe_h calcs=114/200 elements=35,32 [2014-01-14]
  if(system=="BrHf") return MISCIBILITY_SYSTEM_MISCIBLE; // BrHf_pv calcs=145/200 elements=35,72 [2014-01-14]
  if(system=="BrHg") return MISCIBILITY_SYSTEM_MISCIBLE; // BrHg calcs=130/200 elements=35,80 [2014-01-14]
  if(system=="BrIn") return MISCIBILITY_SYSTEM_MISCIBLE; // BrIn_d calcs=130/200 elements=35,49 [2014-01-14]
  if(system=="BrIr") return MISCIBILITY_SYSTEM_MISCIBLE; // BrIr calcs=122/200 elements=35,77 [2014-01-14]
  if(system=="BrK") return MISCIBILITY_SYSTEM_MISCIBLE; // BrK_sv calcs=112/200 elements=35,19 [2014-01-14]
  if(system=="BrLa") return MISCIBILITY_SYSTEM_MISCIBLE; // BrLa calcs=109/200 elements=35,57 [2014-01-14]
  if(system=="BrLi") return MISCIBILITY_SYSTEM_MISCIBLE; // BrLi_sv calcs=117/200 elements=35,3 [2014-01-14]
  if(system=="BrMg") return MISCIBILITY_SYSTEM_MISCIBLE; // BrMg_pv calcs=126/200 elements=35,12 [2014-01-14]
  if(system=="BrMn") return MISCIBILITY_SYSTEM_MISCIBLE; // BrMn_pv calcs=115/200 elements=35,25 [2014-01-14]
  if(system=="BrMo") return MISCIBILITY_SYSTEM_MISCIBLE; // BrMo_pv calcs=118/200 elements=35,42 [2014-01-14]
  if(system=="BrNa") return MISCIBILITY_SYSTEM_MISCIBLE; // BrNa_sv calcs=106/200 elements=35,11 [2014-01-14]
  if(system=="BrNb") return MISCIBILITY_SYSTEM_MISCIBLE; // BrNb_sv calcs=112/200 elements=35,41 [2014-01-14]
  if(system=="BrNi") return MISCIBILITY_SYSTEM_MISCIBLE; // BrNi_pv calcs=118/200 elements=35,28 [2014-01-14]
  if(system=="BrOs") return MISCIBILITY_SYSTEM_MISCIBLE; // BrOs_pv calcs=122/200 elements=35,76 [2014-01-14]
  if(system=="BrP") return MISCIBILITY_SYSTEM_MISCIBLE; // BrP calcs=161/200 elements=35,15 [2014-01-14]
  if(system=="BrPb") return MISCIBILITY_SYSTEM_MISCIBLE; // BrPb_d calcs=245/200 elements=35,82 [2014-01-14]
  if(system=="BrPd") return MISCIBILITY_SYSTEM_MISCIBLE; // BrPd_pv calcs=150/200 elements=35,46 [2014-01-14]
  if(system=="BrPt") return MISCIBILITY_SYSTEM_MISCIBLE; // BrPt calcs=173/200 elements=35,78 [2014-01-14]
  if(system=="BrRe") return MISCIBILITY_SYSTEM_MISCIBLE; // BrRe_pv calcs=122/200 elements=35,75 [2014-01-14]
  if(system=="BrRh") return MISCIBILITY_SYSTEM_MISCIBLE; // BrRh_pv calcs=108/200 elements=35,45 [2014-01-14]
  if(system=="BrRu") return MISCIBILITY_SYSTEM_MISCIBLE; // BrRu_pv calcs=119/200 elements=35,44 [2014-01-14]
  if(system=="BrSb") return MISCIBILITY_SYSTEM_MISCIBLE; // BrSb calcs=124/200 elements=35,51 [2014-01-14]
  if(system=="BrSc") return MISCIBILITY_SYSTEM_MISCIBLE; // BrSc_sv calcs=119/200 elements=35,21 [2014-01-14]
  if(system=="BrSe") return MISCIBILITY_SYSTEM_MISCIBLE; // BrSe calcs=133/200 elements=35,34 [2014-01-14]
  if(system=="BrSi") return MISCIBILITY_SYSTEM_MISCIBLE; // BrSi calcs=132/200 elements=35,14 [2014-01-14]
  if(system=="BrSn") return MISCIBILITY_SYSTEM_MISCIBLE; // BrSn calcs=127/200 elements=35,50 [2014-01-14]
  if(system=="BrSr") return MISCIBILITY_SYSTEM_MISCIBLE; // BrSr_sv calcs=262/200 elements=35,38 [2014-01-14]
  if(system=="BrTa") return MISCIBILITY_SYSTEM_MISCIBLE; // BrTa_pv calcs=134/200 elements=35,73 [2014-01-14]
  if(system=="BrTc") return MISCIBILITY_SYSTEM_MISCIBLE; // BrTc_pv calcs=125/200 elements=35,43 [2014-01-14]
  if(system=="BrTe") return MISCIBILITY_SYSTEM_MISCIBLE; // BrTe calcs=123/200 elements=35,52 [2014-01-14]
  if(system=="BrTi") return MISCIBILITY_SYSTEM_MISCIBLE; // BrTi_sv calcs=133/200 elements=35,22 [2014-01-14]
  if(system=="BrTl") return MISCIBILITY_SYSTEM_MISCIBLE; // BrTl_d calcs=126/200 elements=35,81 [2014-01-14]
  if(system=="BrV") return MISCIBILITY_SYSTEM_MISCIBLE; // BrV_sv calcs=134/200 elements=35,23 [2014-01-14]
  if(system=="BrW") return MISCIBILITY_SYSTEM_MISCIBLE; // BrW_pv calcs=129/200 elements=35,74 [2014-01-14]
  if(system=="BrY") return MISCIBILITY_SYSTEM_MISCIBLE; // BrY_sv calcs=123/200 elements=35,39 [2014-01-14]
  if(system=="BrZn") return MISCIBILITY_SYSTEM_MISCIBLE; // BrZn calcs=117/200 elements=35,30 [2014-01-14]
  if(system=="BrZr") return MISCIBILITY_SYSTEM_MISCIBLE; // BrZr_sv calcs=137/200 elements=35,40 [2014-01-14]
  if(system=="CNi") return MISCIBILITY_SYSTEM_NOMIX; // CNi_pv calcs=250/200 elements=6,28 [2014-01-14]
  if(system=="CaCd") return MISCIBILITY_SYSTEM_MISCIBLE; // Ca_svCd calcs=131/200 elements=20,48 [2014-01-14]
  if(system=="CaCl") return MISCIBILITY_SYSTEM_MISCIBLE; // Ca_svCl calcs=130/200 elements=20,17 [2014-01-14]
  if(system=="CaCo") return MISCIBILITY_SYSTEM_UNKNOWN; // Ca_svCo calcs=116/200 elements=20,27 [2014-01-14]
  if(system=="CaCr") return MISCIBILITY_SYSTEM_UNKNOWN; // Ca_svCr_pv calcs=113/200 elements=20,24 [2014-01-14]
  if(system=="CaCu") return MISCIBILITY_SYSTEM_MISCIBLE; // Ca_svCu_pv calcs=120/200 elements=20,29 [2014-01-14]
  if(system=="CaFe") return MISCIBILITY_SYSTEM_UNKNOWN; // Ca_svFe_pv calcs=150/200 elements=20,26 [2014-01-14]
  if(system=="CaGa") return MISCIBILITY_SYSTEM_MISCIBLE; // Ca_svGa_h calcs=94/200 elements=20,31 [2014-01-14]
  if(system=="CaGe") return MISCIBILITY_SYSTEM_MISCIBLE; // Ca_svGe_h calcs=118/200 elements=20,32 [2014-01-14]
  if(system=="CaHf") return MISCIBILITY_SYSTEM_NOMIX; // Ca_svHf_pv calcs=223/200 elements=20,72 [2014-01-14]
  if(system=="CaHg") return MISCIBILITY_SYSTEM_MISCIBLE; // Ca_svHg calcs=122/200 elements=20,80 [2014-01-14]
  if(system=="CaIn") return MISCIBILITY_SYSTEM_MISCIBLE; // Ca_svIn_d calcs=111/200 elements=20,49 [2014-01-14]
  if(system=="CaIr") return MISCIBILITY_SYSTEM_MISCIBLE; // Ca_svIr calcs=127/200 elements=20,77 [2014-01-14]
  if(system=="CaK") return MISCIBILITY_SYSTEM_UNKNOWN; // Ca_svK_sv calcs=110/200 elements=20,19 [2014-01-14]
  if(system=="CaLa") return MISCIBILITY_SYSTEM_UNKNOWN; // Ca_svLa calcs=115/200 elements=20,57 [2014-01-14]
  if(system=="CaLi") return MISCIBILITY_SYSTEM_MISCIBLE; // Ca_svLi_sv calcs=134/200 elements=20,3 [2014-01-14]
  if(system=="CaMg") return MISCIBILITY_SYSTEM_MISCIBLE; // Ca_svMg_pv calcs=264/200 elements=20,12 [2014-01-14]
  if(system=="CaMn") return MISCIBILITY_SYSTEM_UNKNOWN; // Ca_svMn_pv calcs=117/200 elements=20,25 [2014-01-14]
  if(system=="CaMo") return MISCIBILITY_SYSTEM_UNKNOWN; // Ca_svMo_pv calcs=112/200 elements=20,42 [2014-01-14]
  if(system=="CaNa") return MISCIBILITY_SYSTEM_UNKNOWN; // Ca_svNa_sv calcs=109/200 elements=20,11 [2014-01-14]
  if(system=="CaNb") return MISCIBILITY_SYSTEM_UNKNOWN; // Ca_svNb_sv calcs=124/200 elements=20,41 [2014-01-14]
  if(system=="CaNi") return MISCIBILITY_SYSTEM_MISCIBLE; // Ca_svNi_pv calcs=121/200 elements=20,28 [2014-01-14]
  if(system=="CaOs") return MISCIBILITY_SYSTEM_UNKNOWN; // Ca_svOs_pv calcs=114/200 elements=20,76 [2014-01-14]
  if(system=="CaP") return MISCIBILITY_SYSTEM_MISCIBLE; // Ca_svP calcs=152/200 elements=20,15 [2014-01-14]
  if(system=="CaPb") return MISCIBILITY_SYSTEM_MISCIBLE; // Ca_svPb_d calcs=125/200 elements=20,82 [2014-01-14]
  if(system=="CaPd") return MISCIBILITY_SYSTEM_MISCIBLE; // Ca_svPd_pv calcs=230/200 elements=20,46 [2014-01-14]
  if(system=="CaPt") return MISCIBILITY_SYSTEM_MISCIBLE; // Ca_svPt calcs=286/200 elements=20,78 [2014-01-14]
  if(system=="CaRe") return MISCIBILITY_SYSTEM_UNKNOWN; // Ca_svRe_pv calcs=119/200 elements=20,75 [2014-01-14]
  if(system=="CaRh") return MISCIBILITY_SYSTEM_MISCIBLE; // Ca_svRh_pv calcs=123/200 elements=20,45 [2014-01-14]
  if(system=="CaRu") return MISCIBILITY_SYSTEM_UNKNOWN; // Ca_svRu_pv calcs=119/200 elements=20,44 [2014-01-14]
  if(system=="CaSb") return MISCIBILITY_SYSTEM_MISCIBLE; // Ca_svSb calcs=121/200 elements=20,51 [2014-01-14]
  if(system=="CaSc") return MISCIBILITY_SYSTEM_UNKNOWN; // Ca_svSc_sv calcs=124/200 elements=20,21 [2014-01-14]
  if(system=="CaSe") return MISCIBILITY_SYSTEM_MISCIBLE; // Ca_svSe calcs=129/200 elements=20,34 [2014-01-14]
  if(system=="CaSi") return MISCIBILITY_SYSTEM_MISCIBLE; // Ca_svSi calcs=128/200 elements=20,14 [2014-01-14]
  if(system=="CaSn") return MISCIBILITY_SYSTEM_MISCIBLE; // Ca_svSn calcs=129/200 elements=20,50 [2014-01-14]
  if(system=="CaSr") return MISCIBILITY_SYSTEM_UNKNOWN; // Ca_svSr_sv calcs=115/200 elements=20,38 [2014-01-14]
  if(system=="CaTa") return MISCIBILITY_SYSTEM_UNKNOWN; // Ca_svTa_pv calcs=118/200 elements=20,73 [2014-01-14]
  if(system=="CaTc") return MISCIBILITY_SYSTEM_UNKNOWN; // Ca_svTc_pv calcs=120/200 elements=20,43 [2014-01-14]
  if(system=="CaTe") return MISCIBILITY_SYSTEM_MISCIBLE; // Ca_svTe calcs=124/200 elements=20,52 [2014-01-14]
  if(system=="CaTi") return MISCIBILITY_SYSTEM_UNKNOWN; // Ca_svTi_sv calcs=131/200 elements=20,22 [2014-01-14]
  if(system=="CaTl") return MISCIBILITY_SYSTEM_MISCIBLE; // Ca_svTl_d calcs=121/200 elements=20,81 [2014-01-14]
  if(system=="CaV") return MISCIBILITY_SYSTEM_UNKNOWN; // Ca_svV_sv calcs=104/200 elements=20,23 [2014-01-14]
  if(system=="CaW") return MISCIBILITY_SYSTEM_UNKNOWN; // Ca_svW_pv calcs=120/200 elements=20,74 [2014-01-14]
  if(system=="CaY") return MISCIBILITY_SYSTEM_UNKNOWN; // Ca_svY_sv calcs=123/200 elements=20,39 [2014-01-14]
  if(system=="CaZn") return MISCIBILITY_SYSTEM_MISCIBLE; // Ca_svZn calcs=125/200 elements=20,30 [2014-01-14]
  if(system=="CaZr") return MISCIBILITY_SYSTEM_UNKNOWN; // Ca_svZr_sv calcs=131/200 elements=20,40 [2014-01-14]
  if(system=="CdCl") return MISCIBILITY_SYSTEM_MISCIBLE; // CdCl calcs=132/200 elements=48,17 [2014-01-14]
  if(system=="CdCo") return MISCIBILITY_SYSTEM_NOMIX; // CdCo calcs=205/200 elements=48,27 [2014-01-14]
  if(system=="CdCr") return MISCIBILITY_SYSTEM_NOMIX; // CdCr_pv calcs=205/200 elements=48,24 [2014-01-14]
  if(system=="CdCu") return MISCIBILITY_SYSTEM_NOMIX; // CdCu_pv calcs=209/200 elements=48,29 [2014-01-14]
  if(system=="CdFe") return MISCIBILITY_SYSTEM_NOMIX; // CdFe_pv calcs=207/200 elements=48,26 [2014-01-14]
  if(system=="CdGa") return MISCIBILITY_SYSTEM_NOMIX; // CdGa_h calcs=201/200 elements=48,31 [2014-01-14]
  if(system=="CdGe") return MISCIBILITY_SYSTEM_UNKNOWN; // CdGe_h calcs=198/200 elements=48,32 [2014-01-14]
  if(system=="CdHf") return MISCIBILITY_SYSTEM_MISCIBLE; // CdHf_pv calcs=630/200 elements=48,72 [2014-01-14]
  if(system=="CdHg") return MISCIBILITY_SYSTEM_MISCIBLE; // CdHg calcs=242/200 elements=48,80 [2014-01-14]
  if(system=="CdIn") return MISCIBILITY_SYSTEM_UNKNOWN; // CdIn_d calcs=182/200 elements=48,49 [2014-01-14]
  if(system=="CdIr") return MISCIBILITY_SYSTEM_NOMIX; // CdIr calcs=205/200 elements=48,77 [2014-01-14]
  if(system=="CdK") return MISCIBILITY_SYSTEM_MISCIBLE; // CdK_sv calcs=124/200 elements=48,19 [2014-01-14]
  if(system=="CdLa") return MISCIBILITY_SYSTEM_MISCIBLE; // CdLa calcs=269/200 elements=48,57 [2014-01-14]
  if(system=="CdLi") return MISCIBILITY_SYSTEM_MISCIBLE; // CdLi_sv calcs=123/200 elements=48,3 [2014-01-14]
  if(system=="CdMg") return MISCIBILITY_SYSTEM_MISCIBLE; // CdMg_pv calcs=275/200 elements=48,12 [2014-01-14]
  if(system=="CdMn") return MISCIBILITY_SYSTEM_NOMIX; // CdMn_pv calcs=211/200 elements=48,25 [2014-01-14]
  if(system=="CdMo") return MISCIBILITY_SYSTEM_NOMIX; // CdMo_pv calcs=208/200 elements=48,42 [2014-01-14]
  if(system=="CdNa") return MISCIBILITY_SYSTEM_MISCIBLE; // CdNa_sv calcs=105/200 elements=48,11 [2014-01-14]
  if(system=="CdNb") return MISCIBILITY_SYSTEM_NOMIX; // CdNb_sv calcs=218/200 elements=48,41 [2014-01-14]
  if(system=="CdNi") return MISCIBILITY_SYSTEM_MISCIBLE; // CdNi_pv calcs=247/200 elements=48,28 [2014-01-14]
  if(system=="CdOs") return MISCIBILITY_SYSTEM_NOMIX; // CdOs_pv calcs=206/200 elements=48,76 [2014-01-14]
  if(system=="CdP") return MISCIBILITY_SYSTEM_MISCIBLE; // CdP calcs=222/200 elements=48,15 [2014-01-14]
  if(system=="CdPb") return MISCIBILITY_SYSTEM_UNKNOWN; // CdPb_d calcs=191/200 elements=48,82 [2014-01-14]
  if(system=="CdPd") return MISCIBILITY_SYSTEM_MISCIBLE; // CdPd_pv calcs=270/200 elements=48,46 [2014-01-14]
  if(system=="CdPt") return MISCIBILITY_SYSTEM_MISCIBLE; // CdPt calcs=258/200 elements=48,78 [2014-01-14]
  if(system=="CdRe") return MISCIBILITY_SYSTEM_NOMIX; // CdRe_pv calcs=208/200 elements=48,75 [2014-01-14]
  if(system=="CdRh") return MISCIBILITY_SYSTEM_MISCIBLE; // CdRh_pv calcs=265/200 elements=48,45 [2014-01-14]
  if(system=="CdRu") return MISCIBILITY_SYSTEM_NOMIX; // CdRu_pv calcs=206/200 elements=48,44 [2014-01-14]
  if(system=="CdSb") return MISCIBILITY_SYSTEM_MISCIBLE; // CdSb calcs=199/200 elements=48,51 [2014-01-14]
  if(system=="CdSc") return MISCIBILITY_SYSTEM_MISCIBLE; // CdSc_sv calcs=257/200 elements=48,21 [2014-01-14]
  if(system=="CdSe") return MISCIBILITY_SYSTEM_MISCIBLE; // CdSe calcs=112/200 elements=48,34 [2014-01-14]
  if(system=="CdSi") return MISCIBILITY_SYSTEM_MISCIBLE; // CdSi calcs=132/200 elements=48,14 [2014-01-14]
  if(system=="CdSn") return MISCIBILITY_SYSTEM_UNKNOWN; // CdSn calcs=192/200 elements=48,50 [2014-01-14]
  if(system=="CdSr") return MISCIBILITY_SYSTEM_MISCIBLE; // CdSr_sv calcs=118/200 elements=48,38 [2014-01-14]
  if(system=="CdTa") return MISCIBILITY_SYSTEM_NOMIX; // CdTa_pv calcs=205/200 elements=48,73 [2014-01-14]
  if(system=="CdTc") return MISCIBILITY_SYSTEM_NOMIX; // CdTc_pv calcs=203/200 elements=48,43 [2014-01-14]
  if(system=="CdTe") return MISCIBILITY_SYSTEM_MISCIBLE; // CdTe calcs=133/200 elements=48,52 [2014-01-14]
  if(system=="CdTi") return MISCIBILITY_SYSTEM_MISCIBLE; // CdTi_sv calcs=256/200 elements=48,22 [2014-01-14]
  if(system=="CdTl") return MISCIBILITY_SYSTEM_NOMIX; // CdTl_d calcs=215/200 elements=48,81 [2014-01-14]
  if(system=="CdV") return MISCIBILITY_SYSTEM_NOMIX; // CdV_sv calcs=218/200 elements=48,23 [2014-01-14]
  if(system=="CdW") return MISCIBILITY_SYSTEM_NOMIX; // CdW_pv calcs=212/200 elements=48,74 [2014-01-14]
  if(system=="CdY") return MISCIBILITY_SYSTEM_MISCIBLE; // CdY_sv calcs=263/200 elements=48,39 [2014-01-14]
  if(system=="CdZn") return MISCIBILITY_SYSTEM_NOMIX; // CdZn calcs=205/200 elements=48,30 [2014-01-14]
  if(system=="CdZr") return MISCIBILITY_SYSTEM_MISCIBLE; // CdZr_sv calcs=254/200 elements=48,40 [2014-01-14]
  if(system=="ClCo") return MISCIBILITY_SYSTEM_MISCIBLE; // ClCo calcs=109/200 elements=17,27 [2014-01-14]
  if(system=="ClCr") return MISCIBILITY_SYSTEM_MISCIBLE; // ClCr_pv calcs=116/200 elements=17,24 [2014-01-14]
  if(system=="ClCu") return MISCIBILITY_SYSTEM_MISCIBLE; // ClCu_pv calcs=118/200 elements=17,29 [2014-01-14]
  if(system=="ClFe") return MISCIBILITY_SYSTEM_MISCIBLE; // ClFe_pv calcs=152/200 elements=17,26 [2014-01-14]
  if(system=="ClGa") return MISCIBILITY_SYSTEM_MISCIBLE; // ClGa_h calcs=128/200 elements=17,31 [2014-01-14]
  if(system=="ClGe") return MISCIBILITY_SYSTEM_MISCIBLE; // ClGe_h calcs=112/200 elements=17,32 [2014-01-14]
  if(system=="ClHf") return MISCIBILITY_SYSTEM_MISCIBLE; // ClHf_pv calcs=168/200 elements=17,72 [2014-01-14]
  if(system=="ClHg") return MISCIBILITY_SYSTEM_MISCIBLE; // ClHg calcs=123/200 elements=17,80 [2014-01-14]
  if(system=="ClIn") return MISCIBILITY_SYSTEM_MISCIBLE; // ClIn_d calcs=126/200 elements=17,49 [2014-01-14]
  if(system=="ClIr") return MISCIBILITY_SYSTEM_MISCIBLE; // ClIr calcs=126/200 elements=17,77 [2014-01-14]
  if(system=="ClK") return MISCIBILITY_SYSTEM_MISCIBLE; // ClK_sv calcs=117/200 elements=17,19 [2014-01-14]
  if(system=="ClLa") return MISCIBILITY_SYSTEM_MISCIBLE; // ClLa calcs=115/200 elements=17,57 [2014-01-14]
  if(system=="ClLi") return MISCIBILITY_SYSTEM_MISCIBLE; // ClLi_sv calcs=118/200 elements=17,3 [2014-01-14]
  if(system=="ClMg") return MISCIBILITY_SYSTEM_MISCIBLE; // ClMg_pv calcs=130/200 elements=17,12 [2014-01-14]
  if(system=="ClMn") return MISCIBILITY_SYSTEM_MISCIBLE; // ClMn_pv calcs=121/200 elements=17,25 [2014-01-14]
  if(system=="ClMo") return MISCIBILITY_SYSTEM_MISCIBLE; // ClMo_pv calcs=130/200 elements=17,42 [2014-01-14]
  if(system=="ClNa") return MISCIBILITY_SYSTEM_MISCIBLE; // ClNa_sv calcs=98/200 elements=17,11 [2014-01-14]
  if(system=="ClNb") return MISCIBILITY_SYSTEM_MISCIBLE; // ClNb_sv calcs=125/200 elements=17,41 [2014-01-14]
  if(system=="ClNi") return MISCIBILITY_SYSTEM_MISCIBLE; // ClNi_pv calcs=121/200 elements=17,28 [2014-01-14]
  if(system=="ClOs") return MISCIBILITY_SYSTEM_MISCIBLE; // ClOs_pv calcs=117/200 elements=17,76 [2014-01-14]
  if(system=="ClP") return MISCIBILITY_SYSTEM_MISCIBLE; // ClP calcs=155/200 elements=17,15 [2014-01-14]
  if(system=="ClPb") return MISCIBILITY_SYSTEM_MISCIBLE; // ClPb_d calcs=160/200 elements=17,82 [2014-01-14]
  if(system=="ClPd") return MISCIBILITY_SYSTEM_MISCIBLE; // ClPd_pv calcs=143/200 elements=17,46 [2014-01-14]
  if(system=="ClPt") return MISCIBILITY_SYSTEM_MISCIBLE; // ClPt calcs=154/200 elements=17,78 [2014-01-14]
  if(system=="ClRe") return MISCIBILITY_SYSTEM_MISCIBLE; // ClRe_pv calcs=134/200 elements=17,75 [2014-01-14]
  if(system=="ClRh") return MISCIBILITY_SYSTEM_MISCIBLE; // ClRh_pv calcs=125/200 elements=17,45 [2014-01-14]
  if(system=="ClRu") return MISCIBILITY_SYSTEM_MISCIBLE; // ClRu_pv calcs=121/200 elements=17,44 [2014-01-14]
  if(system=="ClSb") return MISCIBILITY_SYSTEM_MISCIBLE; // ClSb calcs=120/200 elements=17,51 [2014-01-14]
  if(system=="ClSc") return MISCIBILITY_SYSTEM_MISCIBLE; // ClSc_sv calcs=127/200 elements=17,21 [2014-01-14]
  if(system=="ClSe") return MISCIBILITY_SYSTEM_MISCIBLE; // ClSe calcs=118/200 elements=17,34 [2014-01-14]
  if(system=="ClSi") return MISCIBILITY_SYSTEM_MISCIBLE; // ClSi calcs=133/200 elements=17,14 [2014-01-14]
  if(system=="ClSn") return MISCIBILITY_SYSTEM_MISCIBLE; // ClSn calcs=114/200 elements=17,50 [2014-01-14]
  if(system=="ClSr") return MISCIBILITY_SYSTEM_MISCIBLE; // ClSr_sv calcs=125/200 elements=17,38 [2014-01-14]
  if(system=="ClTa") return MISCIBILITY_SYSTEM_MISCIBLE; // ClTa_pv calcs=124/200 elements=17,73 [2014-01-14]
  if(system=="ClTc") return MISCIBILITY_SYSTEM_MISCIBLE; // ClTc_pv calcs=123/200 elements=17,43 [2014-01-14]
  if(system=="ClTe") return MISCIBILITY_SYSTEM_MISCIBLE; // ClTe calcs=123/200 elements=17,52 [2014-01-14]
  if(system=="ClTi") return MISCIBILITY_SYSTEM_MISCIBLE; // ClTi_sv calcs=133/200 elements=17,22 [2014-01-14]
  if(system=="ClTl") return MISCIBILITY_SYSTEM_MISCIBLE; // ClTl_d calcs=136/200 elements=17,81 [2014-01-14]
  if(system=="ClV") return MISCIBILITY_SYSTEM_MISCIBLE; // ClV_sv calcs=121/200 elements=17,23 [2014-01-14]
  if(system=="ClW") return MISCIBILITY_SYSTEM_MISCIBLE; // ClW_pv calcs=122/200 elements=17,74 [2014-01-14]
  if(system=="ClY") return MISCIBILITY_SYSTEM_MISCIBLE; // ClY_sv calcs=116/200 elements=17,39 [2014-01-14]
  if(system=="ClZn") return MISCIBILITY_SYSTEM_MISCIBLE; // ClZn calcs=126/200 elements=17,30 [2014-01-14]
  if(system=="ClZr") return MISCIBILITY_SYSTEM_MISCIBLE; // ClZr_sv calcs=122/200 elements=17,40 [2014-01-14]
  if(system=="CoCr") return MISCIBILITY_SYSTEM_NOMIX; // CoCr_pv calcs=206/200 elements=27,24 [2014-01-14]
  if(system=="CoCu") return MISCIBILITY_SYSTEM_NOMIX; // CoCu_pv calcs=211/200 elements=27,29 [2014-01-14]
  if(system=="CoFe") return MISCIBILITY_SYSTEM_MISCIBLE; // CoFe_pv calcs=904/200 elements=27,26 [2014-01-14]
  if(system=="CoGa") return MISCIBILITY_SYSTEM_MISCIBLE; // CoGa_h calcs=269/200 elements=27,31 [2014-01-14]
  if(system=="CoGe") return MISCIBILITY_SYSTEM_MISCIBLE; // CoGe_h calcs=266/200 elements=27,32 [2014-01-14]
  if(system=="CoHf") return MISCIBILITY_SYSTEM_MISCIBLE; // CoHf_pv calcs=269/200 elements=27,72 [2014-01-14]
  if(system=="CoHg") return MISCIBILITY_SYSTEM_NOMIX; // CoHg calcs=202/200 elements=27,80 [2014-01-14]
  if(system=="CoIn") return MISCIBILITY_SYSTEM_MISCIBLE; // CoIn_d calcs=188/200 elements=27,49 [2014-01-14]
  if(system=="CoIr") return MISCIBILITY_SYSTEM_NOMIX; // CoIr calcs=205/200 elements=27,77 [2014-01-14]
  if(system=="CoK") return MISCIBILITY_SYSTEM_UNKNOWN; // CoK_sv calcs=108/200 elements=27,19 [2014-01-14]
  if(system=="CoLa") return MISCIBILITY_SYSTEM_MISCIBLE; // CoLa calcs=259/200 elements=27,57 [2014-01-14]
  if(system=="CoLi") return MISCIBILITY_SYSTEM_UNKNOWN; // CoLi_sv calcs=116/200 elements=27,3 [2014-01-14]
  if(system=="CoMg") return MISCIBILITY_SYSTEM_NOMIX; // CoMg_pv calcs=257/200 elements=27,12 [2014-01-14]
  if(system=="CoMn") return MISCIBILITY_SYSTEM_MISCIBLE; // CoMn_pv calcs=271/200 elements=27,25 [2014-01-14]
  if(system=="CoMo") return MISCIBILITY_SYSTEM_MISCIBLE; // CoMo_pv calcs=239/200 elements=27,42 [2014-01-14]
  if(system=="CoNa") return MISCIBILITY_SYSTEM_UNKNOWN; // CoNa_sv calcs=95/200 elements=27,11 [2014-01-14]
  if(system=="CoNb") return MISCIBILITY_SYSTEM_MISCIBLE; // CoNb_sv calcs=264/200 elements=27,41 [2014-01-14]
  if(system=="CoNi") return MISCIBILITY_SYSTEM_MISCIBLE; // CoNi_pv calcs=248/200 elements=27,28 [2014-01-14]
  if(system=="CoOs") return MISCIBILITY_SYSTEM_NOMIX; // CoOs_pv calcs=202/200 elements=27,76 [2014-01-14]
  if(system=="CoP") return MISCIBILITY_SYSTEM_MISCIBLE; // CoP calcs=272/200 elements=27,15 [2014-01-14]
  if(system=="CoPb") return MISCIBILITY_SYSTEM_NOMIX; // CoPb_d calcs=208/200 elements=27,82 [2014-01-14]
  if(system=="CoPd") return MISCIBILITY_SYSTEM_MISCIBLE; // CoPd_pv calcs=268/200 elements=27,46 [2014-01-14]
  if(system=="CoPt") return MISCIBILITY_SYSTEM_MISCIBLE; // CoPt calcs=269/200 elements=27,78 [2014-01-14]
  if(system=="CoRe") return MISCIBILITY_SYSTEM_MISCIBLE; // CoRe_pv calcs=261/200 elements=27,75 [2014-01-14]
  if(system=="CoRh") return MISCIBILITY_SYSTEM_NOMIX; // CoRh_pv calcs=410/200 elements=27,45 [2014-01-14]
  if(system=="CoRu") return MISCIBILITY_SYSTEM_NOMIX; // CoRu_pv calcs=205/200 elements=27,44 [2014-01-14]
  if(system=="CoSb") return MISCIBILITY_SYSTEM_MISCIBLE; // CoSb calcs=125/200 elements=27,51 [2014-01-14]
  if(system=="CoSc") return MISCIBILITY_SYSTEM_MISCIBLE; // CoSc_sv calcs=266/200 elements=27,21 [2014-01-14]
  if(system=="CoSe") return MISCIBILITY_SYSTEM_MISCIBLE; // CoSe calcs=122/200 elements=27,34 [2014-01-14]
  if(system=="CoSi") return MISCIBILITY_SYSTEM_MISCIBLE; // CoSi calcs=211/200 elements=27,14 [2014-01-14]
  if(system=="CoSn") return MISCIBILITY_SYSTEM_MISCIBLE; // CoSn calcs=209/200 elements=27,50 [2014-01-14]
  if(system=="CoSr") return MISCIBILITY_SYSTEM_UNKNOWN; // CoSr_sv calcs=109/200 elements=27,38 [2014-01-14]
  if(system=="CoTa") return MISCIBILITY_SYSTEM_MISCIBLE; // CoTa_pv calcs=241/200 elements=27,73 [2014-01-14]
  if(system=="CoTc") return MISCIBILITY_SYSTEM_MISCIBLE; // CoTc_pv calcs=252/200 elements=27,43 [2014-01-14]
  if(system=="CoTe") return MISCIBILITY_SYSTEM_MISCIBLE; // CoTe calcs=173/200 elements=27,52 [2014-01-14]
  if(system=="CoTi") return MISCIBILITY_SYSTEM_MISCIBLE; // CoTi_sv calcs=244/200 elements=27,22 [2014-01-14]
  if(system=="CoTl") return MISCIBILITY_SYSTEM_NOMIX; // CoTl_d calcs=226/200 elements=27,81 [2014-01-14]
  if(system=="CoV") return MISCIBILITY_SYSTEM_MISCIBLE; // CoV_sv calcs=242/200 elements=27,23 [2014-01-14]
  if(system=="CoW") return MISCIBILITY_SYSTEM_MISCIBLE; // CoW_pv calcs=246/200 elements=27,74 [2014-01-14]
  if(system=="CoY") return MISCIBILITY_SYSTEM_MISCIBLE; // CoY_sv calcs=245/200 elements=27,39 [2014-01-14]
  if(system=="CoZn") return MISCIBILITY_SYSTEM_MISCIBLE; // CoZn calcs=240/200 elements=27,30 [2014-01-14]
  if(system=="CoZr") return MISCIBILITY_SYSTEM_MISCIBLE; // CoZr_sv calcs=237/200 elements=27,40 [2014-01-14]
  if(system=="CrCu") return MISCIBILITY_SYSTEM_NOMIX; // Cr_pvCu_pv calcs=212/200 elements=24,29 [2014-01-14]
  if(system=="CrFe") return MISCIBILITY_SYSTEM_NOMIX; // Cr_pvFe_pv calcs=205/200 elements=24,26 [2014-01-14]
  if(system=="CrGa") return MISCIBILITY_SYSTEM_MISCIBLE; // Cr_pvGa_h calcs=130/200 elements=24,31 [2014-01-14]
  if(system=="CrGe") return MISCIBILITY_SYSTEM_MISCIBLE; // Cr_pvGe_h calcs=207/200 elements=24,32 [2014-01-14]
  if(system=="CrHf") return MISCIBILITY_SYSTEM_MISCIBLE; // Cr_pvHf_pv calcs=259/200 elements=24,72 [2014-01-14]
  if(system=="CrHg") return MISCIBILITY_SYSTEM_NOMIX; // Cr_pvHg calcs=204/200 elements=24,80 [2014-01-14]
  if(system=="CrIn") return MISCIBILITY_SYSTEM_UNKNOWN; // Cr_pvIn_d calcs=122/200 elements=24,49 [2014-01-14]
  if(system=="CrIr") return MISCIBILITY_SYSTEM_MISCIBLE; // Cr_pvIr calcs=256/200 elements=24,77 [2014-01-14]
  if(system=="CrK") return MISCIBILITY_SYSTEM_UNKNOWN; // Cr_pvK_sv calcs=109/200 elements=24,19 [2014-01-14]
  if(system=="CrLa") return MISCIBILITY_SYSTEM_NOMIX; // Cr_pvLa calcs=206/200 elements=24,57 [2014-01-14]
  if(system=="CrLi") return MISCIBILITY_SYSTEM_UNKNOWN; // Cr_pvLi_sv calcs=121/200 elements=24,3 [2014-01-14]
  if(system=="CrMg") return MISCIBILITY_SYSTEM_NOMIX; // Cr_pvMg_pv calcs=239/200 elements=24,12 [2014-01-14]
  if(system=="CrMn") return MISCIBILITY_SYSTEM_NOMIX; // Cr_pvMn_pv calcs=208/200 elements=24,25 [2014-01-14]
  if(system=="CrMo") return MISCIBILITY_SYSTEM_NOMIX; // Cr_pvMo_pv calcs=217/200 elements=24,42 [2014-01-14]
  if(system=="CrNa") return MISCIBILITY_SYSTEM_UNKNOWN; // Cr_pvNa_sv calcs=118/200 elements=24,11 [2014-01-14]
  if(system=="CrNb") return MISCIBILITY_SYSTEM_MISCIBLE; // Cr_pvNb_sv calcs=241/200 elements=24,41 [2014-01-14]
  if(system=="CrNi") return MISCIBILITY_SYSTEM_MISCIBLE; // Cr_pvNi_pv calcs=250/200 elements=24,28 [2014-01-14]
  if(system=="CrOs") return MISCIBILITY_SYSTEM_MISCIBLE; // Cr_pvOs_pv calcs=252/200 elements=24,76 [2014-01-14]
  if(system=="CrP") return MISCIBILITY_SYSTEM_MISCIBLE; // Cr_pvP calcs=162/200 elements=24,15 [2014-01-14]
  if(system=="CrPb") return MISCIBILITY_SYSTEM_NOMIX; // Cr_pvPb_d calcs=221/200 elements=24,82 [2014-01-14]
  if(system=="CrPd") return MISCIBILITY_SYSTEM_MISCIBLE; // Cr_pvPd_pv calcs=262/200 elements=24,46 [2014-01-14]
  if(system=="CrPt") return MISCIBILITY_SYSTEM_MISCIBLE; // Cr_pvPt calcs=249/200 elements=24,78 [2014-01-14]
  if(system=="CrRe") return MISCIBILITY_SYSTEM_NOMIX; // Cr_pvRe_pv calcs=239/200 elements=24,75 [2014-01-14]
  if(system=="CrRh") return MISCIBILITY_SYSTEM_MISCIBLE; // Cr_pvRh_pv calcs=256/200 elements=24,45 [2014-01-14]
  if(system=="CrRu") return MISCIBILITY_SYSTEM_NOMIX; // Cr_pvRu_pv calcs=240/200 elements=24,44 [2014-01-14]
  if(system=="CrSb") return MISCIBILITY_SYSTEM_UNKNOWN; // Cr_pvSb calcs=123/200 elements=24,51 [2014-01-14]
  if(system=="CrSc") return MISCIBILITY_SYSTEM_NOMIX; // Cr_pvSc_sv calcs=214/200 elements=24,21 [2014-01-14]
  if(system=="CrSe") return MISCIBILITY_SYSTEM_MISCIBLE; // Cr_pvSe calcs=201/200 elements=24,34 [2014-01-14]
  if(system=="CrSi") return MISCIBILITY_SYSTEM_MISCIBLE; // Cr_pvSi calcs=125/200 elements=24,14 [2014-01-14]
  if(system=="CrSn") return MISCIBILITY_SYSTEM_UNKNOWN; // Cr_pvSn calcs=165/200 elements=24,50 [2014-01-14]
  if(system=="CrSr") return MISCIBILITY_SYSTEM_UNKNOWN; // Cr_pvSr_sv calcs=110/200 elements=24,38 [2014-01-14]
  if(system=="CrTa") return MISCIBILITY_SYSTEM_MISCIBLE; // Cr_pvTa_pv calcs=238/200 elements=24,73 [2014-01-14]
  if(system=="CrTc") return MISCIBILITY_SYSTEM_NOMIX; // Cr_pvTc_pv calcs=209/200 elements=24,43 [2014-01-14]
  if(system=="CrTe") return MISCIBILITY_SYSTEM_MISCIBLE; // Cr_pvTe calcs=114/200 elements=24,52 [2014-01-14]
  if(system=="CrTi") return MISCIBILITY_SYSTEM_MISCIBLE; // Cr_pvTi_sv calcs=258/200 elements=24,22 [2014-01-14]
  if(system=="CrTl") return MISCIBILITY_SYSTEM_UNKNOWN; // Cr_pvTl_d calcs=105/200 elements=24,81 [2014-01-14]
  if(system=="CrV") return MISCIBILITY_SYSTEM_MISCIBLE; // Cr_pvV_sv calcs=253/200 elements=24,23 [2014-01-14]
  if(system=="CrW") return MISCIBILITY_SYSTEM_NOMIX; // Cr_pvW_pv calcs=226/200 elements=24,74 [2014-01-14]
  if(system=="CrY") return MISCIBILITY_SYSTEM_NOMIX; // Cr_pvY_sv calcs=214/200 elements=24,39 [2014-01-14]
  if(system=="CrZn") return MISCIBILITY_SYSTEM_NOMIX; // Cr_pvZn calcs=208/200 elements=24,30 [2014-01-14]
  if(system=="CrZr") return MISCIBILITY_SYSTEM_MISCIBLE; // Cr_pvZr_sv calcs=260/200 elements=24,40 [2014-01-14]
  if(system=="CuFe") return MISCIBILITY_SYSTEM_NOMIX; // Cu_pvFe_pv calcs=207/200 elements=29,26 [2014-01-14]
  if(system=="CuGa") return MISCIBILITY_SYSTEM_MISCIBLE; // Cu_pvGa_h calcs=177/200 elements=29,31 [2014-01-14]
  if(system=="CuGe") return MISCIBILITY_SYSTEM_MISCIBLE; // Cu_pvGe_h calcs=199/200 elements=29,32 [2014-01-14]
  if(system=="CuHf") return MISCIBILITY_SYSTEM_MISCIBLE; // Cu_pvHf_pv calcs=259/200 elements=29,72 [2014-01-14]
  if(system=="CuHg") return MISCIBILITY_SYSTEM_NOMIX; // Cu_pvHg calcs=311/200 elements=29,80 [2014-01-14]
  if(system=="CuIn") return MISCIBILITY_SYSTEM_MISCIBLE; // Cu_pvIn_d calcs=123/200 elements=29,49 [2014-01-14]
  if(system=="CuIr") return MISCIBILITY_SYSTEM_NOMIX; // Cu_pvIr calcs=209/200 elements=29,77 [2014-01-14]
  if(system=="CuK") return MISCIBILITY_SYSTEM_UNKNOWN; // Cu_pvK_sv calcs=91/200 elements=29,19 [2014-01-14]
  if(system=="CuLa") return MISCIBILITY_SYSTEM_MISCIBLE; // Cu_pvLa calcs=262/200 elements=29,57 [2014-01-14]
  if(system=="CuLi") return MISCIBILITY_SYSTEM_MISCIBLE; // Cu_pvLi_sv calcs=123/200 elements=29,3 [2014-01-14]
  if(system=="CuMg") return MISCIBILITY_SYSTEM_MISCIBLE; // Cu_pvMg_pv calcs=267/200 elements=29,12 [2014-01-14]
  if(system=="CuMn") return MISCIBILITY_SYSTEM_NOMIX; // Cu_pvMn_pv calcs=212/200 elements=29,25 [2014-01-14]
  if(system=="CuMo") return MISCIBILITY_SYSTEM_NOMIX; // Cu_pvMo_pv calcs=217/200 elements=29,42 [2014-01-14]
  if(system=="CuNa") return MISCIBILITY_SYSTEM_UNKNOWN; // Cu_pvNa_sv calcs=115/200 elements=29,11 [2014-01-14]
  if(system=="CuNb") return MISCIBILITY_SYSTEM_MISCIBLE; // Cu_pvNb_sv calcs=231/200 elements=29,41 [2014-01-14]
  if(system=="CuNi") return MISCIBILITY_SYSTEM_MISCIBLE; // Cu_pvNi_pv calcs=227/200 elements=29,28 [2014-01-14]
  if(system=="CuOs") return MISCIBILITY_SYSTEM_NOMIX; // Cu_pvOs_pv calcs=213/200 elements=29,76 [2014-01-14]
  if(system=="CuP") return MISCIBILITY_SYSTEM_MISCIBLE; // Cu_pvP calcs=164/200 elements=29,15 [2014-01-14]
  if(system=="CuPb") return MISCIBILITY_SYSTEM_NOMIX; // Cu_pvPb_d calcs=209/200 elements=29,82 [2014-01-14]
  if(system=="CuPd") return MISCIBILITY_SYSTEM_MISCIBLE; // Cu_pvPd_pv calcs=247/200 elements=29,46 [2014-01-14]
  if(system=="CuPt") return MISCIBILITY_SYSTEM_MISCIBLE; // Cu_pvPt calcs=453/200 elements=29,78 [2014-01-14]
  if(system=="CuRe") return MISCIBILITY_SYSTEM_NOMIX; // Cu_pvRe_pv calcs=217/200 elements=29,75 [2014-01-14]
  if(system=="CuRh") return MISCIBILITY_SYSTEM_MISCIBLE; // Cu_pvRh_pv calcs=239/200 elements=29,45 [2014-01-14]
  if(system=="CuRu") return MISCIBILITY_SYSTEM_NOMIX; // Cu_pvRu_pv calcs=208/200 elements=29,44 [2014-01-14]
  if(system=="CuSb") return MISCIBILITY_SYSTEM_MISCIBLE; // Cu_pvSb calcs=115/200 elements=29,51 [2014-01-14]
  if(system=="CuSc") return MISCIBILITY_SYSTEM_MISCIBLE; // Cu_pvSc_sv calcs=229/200 elements=29,21 [2014-01-14]
  if(system=="CuSe") return MISCIBILITY_SYSTEM_MISCIBLE; // Cu_pvSe calcs=216/200 elements=29,34 [2014-01-14]
  if(system=="CuSi") return MISCIBILITY_SYSTEM_MISCIBLE; // Cu_pvSi calcs=130/200 elements=29,14 [2014-01-14]
  if(system=="CuSn") return MISCIBILITY_SYSTEM_MISCIBLE; // Cu_pvSn calcs=223/200 elements=29,50 [2014-01-14]
  if(system=="CuSr") return MISCIBILITY_SYSTEM_MISCIBLE; // Cu_pvSr_sv calcs=113/200 elements=29,38 [2014-01-14]
  if(system=="CuTa") return MISCIBILITY_SYSTEM_NOMIX; // Cu_pvTa_pv calcs=213/200 elements=29,73 [2014-01-14]
  if(system=="CuTc") return MISCIBILITY_SYSTEM_NOMIX; // Cu_pvTc_pv calcs=205/200 elements=29,43 [2014-01-14]
  if(system=="CuTe") return MISCIBILITY_SYSTEM_MISCIBLE; // Cu_pvTe calcs=113/200 elements=29,52 [2014-01-14]
  if(system=="CuTi") return MISCIBILITY_SYSTEM_MISCIBLE; // Cu_pvTi_sv calcs=264/200 elements=29,22 [2014-01-14]
  if(system=="CuTl") return MISCIBILITY_SYSTEM_UNKNOWN; // Cu_pvTl_d calcs=109/200 elements=29,81 [2014-01-14]
  if(system=="CuV") return MISCIBILITY_SYSTEM_NOMIX; // Cu_pvV_sv calcs=218/200 elements=29,23 [2014-01-14]
  if(system=="CuW") return MISCIBILITY_SYSTEM_NOMIX; // Cu_pvW_pv calcs=213/200 elements=29,74 [2014-01-14]
  if(system=="CuY") return MISCIBILITY_SYSTEM_MISCIBLE; // Cu_pvY_sv calcs=249/200 elements=29,39 [2014-01-14]
  if(system=="CuZn") return MISCIBILITY_SYSTEM_MISCIBLE; // Cu_pvZn calcs=242/200 elements=29,30 [2014-01-14]
  if(system=="CuZr") return MISCIBILITY_SYSTEM_MISCIBLE; // Cu_pvZr_sv calcs=244/200 elements=29,40 [2014-01-14]
  if(system=="FeGa") return MISCIBILITY_SYSTEM_MISCIBLE; // Fe_pvGa_h calcs=267/200 elements=26,31 [2014-01-14]
  if(system=="FeGe") return MISCIBILITY_SYSTEM_MISCIBLE; // Fe_pvGe_h calcs=237/200 elements=26,32 [2014-01-14]
  if(system=="FeHf") return MISCIBILITY_SYSTEM_MISCIBLE; // Fe_pvHf_pv calcs=744/200 elements=26,72 [2014-01-14]
  if(system=="FeHg") return MISCIBILITY_SYSTEM_NOMIX; // Fe_pvHg calcs=316/200 elements=26,80 [2014-01-14]
  if(system=="FeIn") return MISCIBILITY_SYSTEM_NOMIX; // Fe_pvIn_d calcs=203/200 elements=26,49 [2014-01-14]
  if(system=="FeIr") return MISCIBILITY_SYSTEM_MISCIBLE; // Fe_pvIr calcs=256/200 elements=26,77 [2014-01-14]
  if(system=="FeK") return MISCIBILITY_SYSTEM_UNKNOWN; // Fe_pvK_sv calcs=120/200 elements=26,19 [2014-01-14]
  if(system=="FeLa") return MISCIBILITY_SYSTEM_NOMIX; // Fe_pvLa calcs=208/200 elements=26,57 [2014-01-14]
  if(system=="FeLi") return MISCIBILITY_SYSTEM_UNKNOWN; // Fe_pvLi_sv calcs=152/200 elements=26,3 [2014-01-14]
  if(system=="FeMg") return MISCIBILITY_SYSTEM_NOMIX; // Fe_pvMg_pv calcs=251/200 elements=26,12 [2014-01-14]
  if(system=="FeMn") return MISCIBILITY_SYSTEM_NOMIX; // Fe_pvMn_pv calcs=213/200 elements=26,25 [2014-01-14]
  if(system=="FeMo") return MISCIBILITY_SYSTEM_NOMIX; // Fe_pvMo_pv calcs=255/200 elements=26,42 [2014-01-14]
  if(system=="FeNa") return MISCIBILITY_SYSTEM_UNKNOWN; // Fe_pvNa_sv calcs=125/200 elements=26,11 [2014-01-14]
  if(system=="FeNb") return MISCIBILITY_SYSTEM_MISCIBLE; // Fe_pvNb_sv calcs=256/200 elements=26,41 [2014-01-14]
  if(system=="FeNi") return MISCIBILITY_SYSTEM_MISCIBLE; // Fe_pvNi_pv calcs=246/200 elements=26,28 [2014-01-14]
  if(system=="FeOs") return MISCIBILITY_SYSTEM_NOMIX; // Fe_pvOs_pv calcs=207/200 elements=26,76 [2014-01-14]
  if(system=="FeP") return MISCIBILITY_SYSTEM_MISCIBLE; // Fe_pvP calcs=277/200 elements=26,15 [2014-01-14]
  if(system=="FePb") return MISCIBILITY_SYSTEM_NOMIX; // Fe_pvPb_d calcs=228/200 elements=26,82 [2014-01-14]
  if(system=="FePd") return MISCIBILITY_SYSTEM_MISCIBLE; // Fe_pvPd_pv calcs=266/200 elements=26,46 [2014-01-14]
  if(system=="FePt") return MISCIBILITY_SYSTEM_MISCIBLE; // Fe_pvPt calcs=269/200 elements=26,78 [2014-01-14]
  if(system=="FeRe") return MISCIBILITY_SYSTEM_MISCIBLE; // Fe_pvRe_pv calcs=239/200 elements=26,75 [2014-01-14]
  if(system=="FeRh") return MISCIBILITY_SYSTEM_MISCIBLE; // Fe_pvRh_pv calcs=459/200 elements=26,45 [2014-01-14]
  if(system=="FeRu") return MISCIBILITY_SYSTEM_NOMIX; // Fe_pvRu_pv calcs=209/200 elements=26,44 [2014-01-14]
  if(system=="FeSb") return MISCIBILITY_SYSTEM_MISCIBLE; // Fe_pvSb calcs=201/200 elements=26,51 [2014-01-14]
  if(system=="FeSc") return MISCIBILITY_SYSTEM_MISCIBLE; // Fe_pvSc_sv calcs=240/200 elements=26,21 [2014-01-14]
  if(system=="FeSe") return MISCIBILITY_SYSTEM_MISCIBLE; // Fe_pvSe calcs=231/200 elements=26,34 [2014-01-14]
  if(system=="FeSi") return MISCIBILITY_SYSTEM_MISCIBLE; // Fe_pvSi calcs=270/200 elements=26,14 [2014-01-14]
  if(system=="FeSn") return MISCIBILITY_SYSTEM_MISCIBLE; // Fe_pvSn calcs=161/200 elements=26,50 [2014-01-14]
  if(system=="FeSr") return MISCIBILITY_SYSTEM_UNKNOWN; // Fe_pvSr_sv calcs=138/200 elements=26,38 [2014-01-14]
  if(system=="FeTa") return MISCIBILITY_SYSTEM_MISCIBLE; // Fe_pvTa_pv calcs=245/200 elements=26,73 [2014-01-14]
  if(system=="FeTc") return MISCIBILITY_SYSTEM_MISCIBLE; // Fe_pvTc_pv calcs=246/200 elements=26,43 [2014-01-14]
  if(system=="FeTe") return MISCIBILITY_SYSTEM_MISCIBLE; // Fe_pvTe calcs=147/200 elements=26,52 [2014-01-14]
  if(system=="FeTi") return MISCIBILITY_SYSTEM_MISCIBLE; // Fe_pvTi_sv calcs=265/200 elements=26,22 [2014-01-14]
  if(system=="FeTl") return MISCIBILITY_SYSTEM_UNKNOWN; // Fe_pvTl_d calcs=149/200 elements=26,81 [2014-01-14]
  if(system=="FeV") return MISCIBILITY_SYSTEM_MISCIBLE; // Fe_pvV_sv calcs=273/200 elements=26,23 [2014-01-14]
  if(system=="FeW") return MISCIBILITY_SYSTEM_MISCIBLE; // Fe_pvW_pv calcs=244/200 elements=26,74 [2014-01-14]
  if(system=="FeY") return MISCIBILITY_SYSTEM_MISCIBLE; // Fe_pvY_sv calcs=250/200 elements=26,39 [2014-01-14]
  if(system=="FeZn") return MISCIBILITY_SYSTEM_MISCIBLE; // Fe_pvZn calcs=237/200 elements=26,30 [2014-01-14]
  if(system=="FeZr") return MISCIBILITY_SYSTEM_MISCIBLE; // Fe_pvZr_sv calcs=242/200 elements=26,40 [2014-01-14]
  if(system=="GaGe") return MISCIBILITY_SYSTEM_UNKNOWN; // Ga_hGe_h calcs=134/200 elements=31,32 [2014-01-14]
  if(system=="GaHf") return MISCIBILITY_SYSTEM_MISCIBLE; // Ga_hHf_pv calcs=242/200 elements=31,72 [2014-01-14]
  if(system=="GaHg") return MISCIBILITY_SYSTEM_NOMIX; // Ga_hHg calcs=203/200 elements=31,80 [2014-01-14]
  if(system=="GaIn") return MISCIBILITY_SYSTEM_UNKNOWN; // Ga_hIn_d calcs=124/200 elements=31,49 [2014-01-14]
  if(system=="GaIr") return MISCIBILITY_SYSTEM_MISCIBLE; // Ga_hIr calcs=148/200 elements=31,77 [2014-01-14]
  if(system=="GaK") return MISCIBILITY_SYSTEM_MISCIBLE; // Ga_hK_sv calcs=96/200 elements=31,19 [2014-01-14]
  if(system=="GaLa") return MISCIBILITY_SYSTEM_MISCIBLE; // Ga_hLa calcs=170/200 elements=31,57 [2014-01-14]
  if(system=="GaLi") return MISCIBILITY_SYSTEM_MISCIBLE; // Ga_hLi_sv calcs=118/200 elements=31,3 [2014-01-14]
  if(system=="GaMg") return MISCIBILITY_SYSTEM_MISCIBLE; // Ga_hMg_pv calcs=124/200 elements=31,12 [2014-01-14]
  if(system=="GaMn") return MISCIBILITY_SYSTEM_MISCIBLE; // Ga_hMn_pv calcs=258/200 elements=31,25 [2014-01-14]
  if(system=="GaMo") return MISCIBILITY_SYSTEM_MISCIBLE; // Ga_hMo_pv calcs=111/200 elements=31,42 [2014-01-14]
  if(system=="GaNa") return MISCIBILITY_SYSTEM_MISCIBLE; // Ga_hNa_sv calcs=104/200 elements=31,11 [2014-01-14]
  if(system=="GaNb") return MISCIBILITY_SYSTEM_MISCIBLE; // Ga_hNb_sv calcs=196/200 elements=31,41 [2014-01-14]
  if(system=="GaNi") return MISCIBILITY_SYSTEM_MISCIBLE; // Ga_hNi_pv calcs=251/200 elements=31,28 [2014-01-14]
  if(system=="GaOs") return MISCIBILITY_SYSTEM_MISCIBLE; // Ga_hOs_pv calcs=205/200 elements=31,76 [2014-01-14]
  if(system=="GaP") return MISCIBILITY_SYSTEM_MISCIBLE; // Ga_hP calcs=201/200 elements=31,15 [2014-01-14]
  if(system=="GaPb") return MISCIBILITY_SYSTEM_UNKNOWN; // Ga_hPb_d calcs=152/200 elements=31,82 [2014-01-14]
  if(system=="GaPd") return MISCIBILITY_SYSTEM_MISCIBLE; // Ga_hPd_pv calcs=255/200 elements=31,46 [2014-01-14]
  if(system=="GaPt") return MISCIBILITY_SYSTEM_MISCIBLE; // Ga_hPt calcs=251/200 elements=31,78 [2014-01-14]
  if(system=="GaRe") return MISCIBILITY_SYSTEM_MISCIBLE; // Ga_hRe_pv calcs=119/200 elements=31,75 [2014-01-14]
  if(system=="GaRh") return MISCIBILITY_SYSTEM_MISCIBLE; // Ga_hRh_pv calcs=123/200 elements=31,45 [2014-01-14]
  if(system=="GaRu") return MISCIBILITY_SYSTEM_MISCIBLE; // Ga_hRu_pv calcs=178/200 elements=31,44 [2014-01-14]
  if(system=="GaSb") return MISCIBILITY_SYSTEM_MISCIBLE; // Ga_hSb calcs=118/200 elements=31,51 [2014-01-14]
  if(system=="GaSc") return MISCIBILITY_SYSTEM_MISCIBLE; // Ga_hSc_sv calcs=132/200 elements=31,21 [2014-01-14]
  if(system=="GaSe") return MISCIBILITY_SYSTEM_MISCIBLE; // Ga_hSe calcs=161/200 elements=31,34 [2014-01-14]
  if(system=="GaSi") return MISCIBILITY_SYSTEM_MISCIBLE; // Ga_hSi calcs=128/200 elements=31,14 [2014-01-14]
  if(system=="GaSn") return MISCIBILITY_SYSTEM_NOMIX; // Ga_hSn calcs=206/200 elements=31,50 [2014-01-14]
  if(system=="GaSr") return MISCIBILITY_SYSTEM_MISCIBLE; // Ga_hSr_sv calcs=89/200 elements=31,38 [2014-01-14]
  if(system=="GaTa") return MISCIBILITY_SYSTEM_MISCIBLE; // Ga_hTa_pv calcs=196/200 elements=31,73 [2014-01-14]
  if(system=="GaTc") return MISCIBILITY_SYSTEM_MISCIBLE; // Ga_hTc_pv calcs=112/200 elements=31,43 [2014-01-14]
  if(system=="GaTe") return MISCIBILITY_SYSTEM_MISCIBLE; // Ga_hTe calcs=123/200 elements=31,52 [2014-01-14]
  if(system=="GaTi") return MISCIBILITY_SYSTEM_MISCIBLE; // Ga_hTi_sv calcs=194/200 elements=31,22 [2014-01-14]
  if(system=="GaTl") return MISCIBILITY_SYSTEM_UNKNOWN; // Ga_hTl_d calcs=120/200 elements=31,81 [2014-01-14]
  if(system=="GaV") return MISCIBILITY_SYSTEM_MISCIBLE; // Ga_hV_sv calcs=136/200 elements=31,23 [2014-01-14]
  if(system=="GaW") return MISCIBILITY_SYSTEM_MISCIBLE; // Ga_hW_pv calcs=118/200 elements=31,74 [2014-01-14]
  if(system=="GaY") return MISCIBILITY_SYSTEM_MISCIBLE; // Ga_hY_sv calcs=135/200 elements=31,39 [2014-01-14]
  if(system=="GaZn") return MISCIBILITY_SYSTEM_UNKNOWN; // Ga_hZn calcs=123/200 elements=31,30 [2014-01-14]
  if(system=="GaZr") return MISCIBILITY_SYSTEM_MISCIBLE; // Ga_hZr_sv calcs=130/200 elements=31,40 [2014-01-14]
  if(system=="GeHf") return MISCIBILITY_SYSTEM_MISCIBLE; // Ge_hHf_pv calcs=228/200 elements=32,72 [2014-01-14]
  if(system=="GeHg") return MISCIBILITY_SYSTEM_UNKNOWN; // Ge_hHg calcs=119/200 elements=32,80 [2014-01-14]
  if(system=="GeIn") return MISCIBILITY_SYSTEM_MISCIBLE; // Ge_hIn_d calcs=113/200 elements=32,49 [2014-01-14]
  if(system=="GeIr") return MISCIBILITY_SYSTEM_MISCIBLE; // Ge_hIr calcs=214/200 elements=32,77 [2014-01-14]
  if(system=="GeK") return MISCIBILITY_SYSTEM_MISCIBLE; // Ge_hK_sv calcs=113/200 elements=32,19 [2014-01-14]
  if(system=="GeLa") return MISCIBILITY_SYSTEM_MISCIBLE; // Ge_hLa calcs=172/200 elements=32,57 [2014-01-14]
  if(system=="GeLi") return MISCIBILITY_SYSTEM_MISCIBLE; // Ge_hLi_sv calcs=120/200 elements=32,3 [2014-01-14]
  if(system=="GeMg") return MISCIBILITY_SYSTEM_MISCIBLE; // Ge_hMg_pv calcs=174/200 elements=32,12 [2014-01-14]
  if(system=="GeMn") return MISCIBILITY_SYSTEM_MISCIBLE; // Ge_hMn_pv calcs=267/200 elements=32,25 [2014-01-14]
  if(system=="GeMo") return MISCIBILITY_SYSTEM_MISCIBLE; // Ge_hMo_pv calcs=127/200 elements=32,42 [2014-01-14]
  if(system=="GeNa") return MISCIBILITY_SYSTEM_MISCIBLE; // Ge_hNa_sv calcs=107/200 elements=32,11 [2014-01-14]
  if(system=="GeNb") return MISCIBILITY_SYSTEM_MISCIBLE; // Ge_hNb_sv calcs=189/200 elements=32,41 [2014-01-14]
  if(system=="GeNi") return MISCIBILITY_SYSTEM_MISCIBLE; // Ge_hNi_pv calcs=203/200 elements=32,28 [2014-01-14]
  if(system=="GeOs") return MISCIBILITY_SYSTEM_MISCIBLE; // Ge_hOs_pv calcs=109/200 elements=32,76 [2014-01-14]
  if(system=="GeP") return MISCIBILITY_SYSTEM_MISCIBLE; // Ge_hP calcs=157/200 elements=32,15 [2014-01-14]
  if(system=="GePb") return MISCIBILITY_SYSTEM_MISCIBLE; // Ge_hPb_d calcs=199/200 elements=32,82 [2014-01-14]
  if(system=="GePd") return MISCIBILITY_SYSTEM_MISCIBLE; // Ge_hPd_pv calcs=254/200 elements=32,46 [2014-01-14]
  if(system=="GePt") return MISCIBILITY_SYSTEM_MISCIBLE; // Ge_hPt calcs=222/200 elements=32,78 [2014-01-14]
  if(system=="GeRe") return MISCIBILITY_SYSTEM_MISCIBLE; // Ge_hRe_pv calcs=114/200 elements=32,75 [2014-01-14]
  if(system=="GeRh") return MISCIBILITY_SYSTEM_MISCIBLE; // Ge_hRh_pv calcs=121/200 elements=32,45 [2014-01-14]
  if(system=="GeRu") return MISCIBILITY_SYSTEM_MISCIBLE; // Ge_hRu_pv calcs=160/200 elements=32,44 [2014-01-14]
  if(system=="GeSb") return MISCIBILITY_SYSTEM_NOMIX; // Ge_hSb calcs=209/200 elements=32,51 [2014-01-14]
  if(system=="GeSc") return MISCIBILITY_SYSTEM_MISCIBLE; // Ge_hSc_sv calcs=124/200 elements=32,21 [2014-01-14]
  if(system=="GeSe") return MISCIBILITY_SYSTEM_MISCIBLE; // Ge_hSe calcs=140/200 elements=32,34 [2014-01-14]
  if(system=="GeSi") return MISCIBILITY_SYSTEM_MISCIBLE; // Ge_hSi calcs=128/200 elements=32,14 [2014-01-14]
  if(system=="GeSn") return MISCIBILITY_SYSTEM_MISCIBLE; // Ge_hSn calcs=130/200 elements=32,50 [2014-01-14]
  if(system=="GeSr") return MISCIBILITY_SYSTEM_MISCIBLE; // Ge_hSr_sv calcs=118/200 elements=32,38 [2014-01-14]
  if(system=="GeTa") return MISCIBILITY_SYSTEM_MISCIBLE; // Ge_hTa_pv calcs=205/200 elements=32,73 [2014-01-14]
  if(system=="GeTc") return MISCIBILITY_SYSTEM_MISCIBLE; // Ge_hTc_pv calcs=121/200 elements=32,43 [2014-01-14]
  if(system=="GeTe") return MISCIBILITY_SYSTEM_MISCIBLE; // Ge_hTe calcs=206/200 elements=32,52 [2014-01-14]
  if(system=="GeTi") return MISCIBILITY_SYSTEM_MISCIBLE; // Ge_hTi_sv calcs=122/200 elements=32,22 [2014-01-14]
  if(system=="GeTl") return MISCIBILITY_SYSTEM_UNKNOWN; // Ge_hTl_d calcs=124/200 elements=32,81 [2014-01-14]
  if(system=="GeV") return MISCIBILITY_SYSTEM_MISCIBLE; // Ge_hV_sv calcs=121/200 elements=32,23 [2014-01-14]
  if(system=="GeW") return MISCIBILITY_SYSTEM_MISCIBLE; // Ge_hW_pv calcs=120/200 elements=32,74 [2014-01-14]
  if(system=="GeY") return MISCIBILITY_SYSTEM_MISCIBLE; // Ge_hY_sv calcs=114/200 elements=32,39 [2014-01-14]
  if(system=="GeZn") return MISCIBILITY_SYSTEM_MISCIBLE; // Ge_hZn calcs=205/200 elements=32,30 [2014-01-14]
  if(system=="GeZr") return MISCIBILITY_SYSTEM_MISCIBLE; // Ge_hZr_sv calcs=205/200 elements=32,40 [2014-01-14]
  if(system=="HfHg") return MISCIBILITY_SYSTEM_MISCIBLE; // Hf_pvHg calcs=254/200 elements=72,80 [2014-01-14]
  if(system=="HfIn") return MISCIBILITY_SYSTEM_MISCIBLE; // Hf_pvIn_d calcs=234/200 elements=72,49 [2014-01-14]
  if(system=="HfIr") return MISCIBILITY_SYSTEM_MISCIBLE; // Hf_pvIr calcs=253/200 elements=72,77 [2014-01-14]
  if(system=="HfK") return MISCIBILITY_SYSTEM_NOMIX; // Hf_pvK_pv calcs=231/200 elements=72,19 [2014-01-14]
  if(system=="HfLa") return MISCIBILITY_SYSTEM_NOMIX; // Hf_pvLa calcs=206/200 elements=72,57 [2014-01-14]
  if(system=="HfLi") return MISCIBILITY_SYSTEM_NOMIX; // Hf_pvLi_sv calcs=206/200 elements=72,3 [2014-01-14]
  if(system=="HfMg") return MISCIBILITY_SYSTEM_MISCIBLE; // Hf_pvMg_pv calcs=806/200 elements=72,12 [2014-01-14]
  if(system=="HfMn") return MISCIBILITY_SYSTEM_MISCIBLE; // Hf_pvMn_pv calcs=250/200 elements=72,25 [2014-01-14]
  if(system=="HfMo") return MISCIBILITY_SYSTEM_MISCIBLE; // Hf_pvMo_pv calcs=519/200 elements=72,42 [2014-01-14]
  if(system=="HfNa") return MISCIBILITY_SYSTEM_NOMIX; // Hf_pvNa_pv calcs=225/200 elements=72,11 [2014-01-14]
  if(system=="HfNa") return MISCIBILITY_SYSTEM_UNKNOWN; // Hf_pvNa_sv calcs=19/200 elements=72,11 [2014-01-14]
  if(system=="HfNb") return MISCIBILITY_SYSTEM_NOMIX; // Hf_pvNb_sv calcs=205/200 elements=72,41 [2014-01-14]
  if(system=="HfNi") return MISCIBILITY_SYSTEM_MISCIBLE; // Hf_pvNi_pv calcs=257/200 elements=72,28 [2014-01-14]
  if(system=="HfOs") return MISCIBILITY_SYSTEM_MISCIBLE; // Hf_pvOs_pv calcs=268/200 elements=72,76 [2014-01-14]
  if(system=="HfP") return MISCIBILITY_SYSTEM_MISCIBLE; // Hf_pvP calcs=269/200 elements=72,15 [2014-01-14]
  if(system=="HfPb") return MISCIBILITY_SYSTEM_MISCIBLE; // Hf_pvPb_d calcs=770/200 elements=72,82 [2014-01-14]
  if(system=="HfPd") return MISCIBILITY_SYSTEM_MISCIBLE; // Hf_pvPd_pv calcs=277/200 elements=72,46 [2014-01-14]
  if(system=="HfPt") return MISCIBILITY_SYSTEM_MISCIBLE; // Hf_pvPt calcs=277/200 elements=72,78 [2014-01-14]
  if(system=="HfRe") return MISCIBILITY_SYSTEM_MISCIBLE; // Hf_pvRe_pv calcs=269/200 elements=72,75 [2014-01-14]
  if(system=="HfRh") return MISCIBILITY_SYSTEM_MISCIBLE; // Hf_pvRh_pv calcs=259/200 elements=72,45 [2014-01-14]
  if(system=="HfRu") return MISCIBILITY_SYSTEM_MISCIBLE; // Hf_pvRu_pv calcs=258/200 elements=72,44 [2014-01-14]
  if(system=="HfSb") return MISCIBILITY_SYSTEM_MISCIBLE; // Hf_pvSb calcs=209/200 elements=72,51 [2014-01-14]
  if(system=="HfSc") return MISCIBILITY_SYSTEM_MISCIBLE; // Hf_pvSc_sv calcs=786/200 elements=72,21 [2014-01-14]
  if(system=="HfSe") return MISCIBILITY_SYSTEM_MISCIBLE; // Hf_pvSe calcs=165/200 elements=72,34 [2014-01-14]
  if(system=="HfSi") return MISCIBILITY_SYSTEM_MISCIBLE; // Hf_pvSi calcs=175/200 elements=72,14 [2014-01-14]
  if(system=="HfSn") return MISCIBILITY_SYSTEM_MISCIBLE; // Hf_pvSn calcs=172/200 elements=72,50 [2014-01-14]
  if(system=="HfSn") return MISCIBILITY_SYSTEM_MISCIBLE; // Hf_pvSn_d calcs=233/200 elements=72,50 [2014-01-14]
  if(system=="HfSr") return MISCIBILITY_SYSTEM_NOMIX; // Hf_pvSr_sv calcs=225/200 elements=72,38 [2014-01-14]
  if(system=="HfTa") return MISCIBILITY_SYSTEM_NOMIX; // Hf_pvTa_pv calcs=202/200 elements=72,73 [2014-01-14]
  if(system=="HfTc") return MISCIBILITY_SYSTEM_MISCIBLE; // Hf_pvTc_pv calcs=265/200 elements=72,43 [2014-01-14]
  if(system=="HfTe") return MISCIBILITY_SYSTEM_MISCIBLE; // Hf_pvTe calcs=155/200 elements=72,52 [2014-01-14]
  if(system=="HfTi") return MISCIBILITY_SYSTEM_MISCIBLE; // Hf_pvTi_sv calcs=786/200 elements=72,22 [2014-01-14]
  if(system=="HfTl") return MISCIBILITY_SYSTEM_MISCIBLE; // Hf_pvTl_d calcs=769/200 elements=72,81 [2014-01-14]
  if(system=="HfV") return MISCIBILITY_SYSTEM_NOMIX; // Hf_pvV_sv calcs=206/200 elements=72,23 [2014-01-14]
  if(system=="HfW") return MISCIBILITY_SYSTEM_MISCIBLE; // Hf_pvW_pv calcs=248/200 elements=72,74 [2014-01-14]
  if(system=="HfY") return MISCIBILITY_SYSTEM_NOMIX; // Hf_pvY_sv calcs=207/200 elements=72,39 [2014-01-14]
  if(system=="HfZn") return MISCIBILITY_SYSTEM_MISCIBLE; // Hf_pvZn calcs=254/200 elements=72,30 [2014-01-14]
  if(system=="HfZr") return MISCIBILITY_SYSTEM_MISCIBLE; // Hf_pvZr_sv calcs=799/200 elements=72,40 [2014-01-14]
  if(system=="HgIn") return MISCIBILITY_SYSTEM_MISCIBLE; // HgIn_d calcs=212/200 elements=80,49 [2014-01-14]
  if(system=="HgIr") return MISCIBILITY_SYSTEM_NOMIX; // HgIr calcs=209/200 elements=80,77 [2014-01-14]
  if(system=="HgK") return MISCIBILITY_SYSTEM_MISCIBLE; // HgK_sv calcs=128/200 elements=80,19 [2014-01-14]
  if(system=="HgLa") return MISCIBILITY_SYSTEM_MISCIBLE; // HgLa calcs=262/200 elements=80,57 [2014-01-14]
  if(system=="HgLi") return MISCIBILITY_SYSTEM_MISCIBLE; // HgLi_sv calcs=119/200 elements=80,3 [2014-01-14]
  if(system=="HgMg") return MISCIBILITY_SYSTEM_MISCIBLE; // HgMg_pv calcs=272/200 elements=80,12 [2014-01-14]
  if(system=="HgMn") return MISCIBILITY_SYSTEM_NOMIX; // HgMn_pv calcs=265/200 elements=80,25 [2014-01-14]
  if(system=="HgMo") return MISCIBILITY_SYSTEM_NOMIX; // HgMo_pv calcs=279/200 elements=80,42 [2014-01-14]
  if(system=="HgNa") return MISCIBILITY_SYSTEM_MISCIBLE; // HgNa_sv calcs=125/200 elements=80,11 [2014-01-14]
  if(system=="HgNb") return MISCIBILITY_SYSTEM_NOMIX; // HgNb_sv calcs=270/200 elements=80,41 [2014-01-14]
  if(system=="HgNi") return MISCIBILITY_SYSTEM_NOMIX; // HgNi_pv calcs=224/200 elements=80,28 [2014-01-14]
  if(system=="HgOs") return MISCIBILITY_SYSTEM_NOMIX; // HgOs_pv calcs=277/200 elements=80,76 [2014-01-14]
  if(system=="HgP") return MISCIBILITY_SYSTEM_UNKNOWN; // HgP calcs=157/200 elements=80,15 [2014-01-14]
  if(system=="HgPb") return MISCIBILITY_SYSTEM_MISCIBLE; // HgPb_d calcs=174/200 elements=80,82 [2014-01-14]
  if(system=="HgPd") return MISCIBILITY_SYSTEM_MISCIBLE; // HgPd_pv calcs=263/200 elements=80,46 [2014-01-14]
  if(system=="HgPt") return MISCIBILITY_SYSTEM_MISCIBLE; // HgPt calcs=257/200 elements=80,78 [2014-01-14]
  if(system=="HgRe") return MISCIBILITY_SYSTEM_NOMIX; // HgRe_pv calcs=213/200 elements=80,75 [2014-01-14]
  if(system=="HgRh") return MISCIBILITY_SYSTEM_MISCIBLE; // HgRh_pv calcs=236/200 elements=80,45 [2014-01-14]
  if(system=="HgRu") return MISCIBILITY_SYSTEM_NOMIX; // HgRu_pv calcs=212/200 elements=80,44 [2014-01-14]
  if(system=="HgSb") return MISCIBILITY_SYSTEM_NOMIX; // HgSb calcs=206/200 elements=80,51 [2014-01-14]
  if(system=="HgSc") return MISCIBILITY_SYSTEM_MISCIBLE; // HgSc_sv calcs=237/200 elements=80,21 [2014-01-14]
  if(system=="HgSe") return MISCIBILITY_SYSTEM_MISCIBLE; // HgSe calcs=116/200 elements=80,34 [2014-01-14]
  if(system=="HgSi") return MISCIBILITY_SYSTEM_NOMIX; // HgSi calcs=219/200 elements=80,14 [2014-01-14]
  if(system=="HgSn") return MISCIBILITY_SYSTEM_NOMIX; // HgSn calcs=208/200 elements=80,50 [2014-01-14]
  if(system=="HgSr") return MISCIBILITY_SYSTEM_MISCIBLE; // HgSr_sv calcs=123/200 elements=80,38 [2014-01-14]
  if(system=="HgTa") return MISCIBILITY_SYSTEM_NOMIX; // HgTa_pv calcs=224/200 elements=80,73 [2014-01-14]
  if(system=="HgTc") return MISCIBILITY_SYSTEM_NOMIX; // HgTc_pv calcs=271/200 elements=80,43 [2014-01-14]
  if(system=="HgTe") return MISCIBILITY_SYSTEM_MISCIBLE; // HgTe calcs=206/200 elements=80,52 [2014-01-14]
  if(system=="HgTi") return MISCIBILITY_SYSTEM_MISCIBLE; // HgTi_sv calcs=248/200 elements=80,22 [2014-01-14]
  if(system=="HgTl") return MISCIBILITY_SYSTEM_MISCIBLE; // HgTl_d calcs=125/200 elements=80,81 [2014-01-14]
  if(system=="HgV") return MISCIBILITY_SYSTEM_NOMIX; // HgV_sv calcs=246/200 elements=80,23 [2014-01-14]
  if(system=="HgW") return MISCIBILITY_SYSTEM_NOMIX; // HgW_pv calcs=272/200 elements=80,74 [2014-01-14]
  if(system=="HgY") return MISCIBILITY_SYSTEM_MISCIBLE; // HgY_sv calcs=245/200 elements=80,39 [2014-01-14]
  if(system=="HgZn") return MISCIBILITY_SYSTEM_NOMIX; // HgZn calcs=221/200 elements=80,30 [2014-01-14]
  if(system=="HgZr") return MISCIBILITY_SYSTEM_MISCIBLE; // HgZr_sv calcs=248/200 elements=80,40 [2014-01-14]
  if(system=="InIr") return MISCIBILITY_SYSTEM_MISCIBLE; // In_dIr calcs=206/200 elements=49,77 [2014-01-14]
  if(system=="InK") return MISCIBILITY_SYSTEM_MISCIBLE; // In_dK_sv calcs=117/200 elements=49,19 [2014-01-14]
  if(system=="InLa") return MISCIBILITY_SYSTEM_MISCIBLE; // In_dLa calcs=173/200 elements=49,57 [2014-01-14]
  if(system=="InLi") return MISCIBILITY_SYSTEM_MISCIBLE; // In_dLi_sv calcs=129/200 elements=49,3 [2014-01-14]
  if(system=="InMg") return MISCIBILITY_SYSTEM_MISCIBLE; // In_dMg_pv calcs=275/200 elements=49,12 [2014-01-14]
  if(system=="InMn") return MISCIBILITY_SYSTEM_UNKNOWN; // In_dMn_pv calcs=190/200 elements=49,25 [2014-01-14]
  if(system=="InMo") return MISCIBILITY_SYSTEM_MISCIBLE; // In_dMo_pv calcs=196/200 elements=49,42 [2014-01-14]
  if(system=="InNa") return MISCIBILITY_SYSTEM_MISCIBLE; // In_dNa_sv calcs=98/200 elements=49,11 [2014-01-14]
  if(system=="InNb") return MISCIBILITY_SYSTEM_MISCIBLE; // In_dNb_sv calcs=190/200 elements=49,41 [2014-01-14]
  if(system=="InNi") return MISCIBILITY_SYSTEM_MISCIBLE; // In_dNi_pv calcs=193/200 elements=49,28 [2014-01-14]
  if(system=="InOs") return MISCIBILITY_SYSTEM_UNKNOWN; // In_dOs_pv calcs=106/200 elements=49,76 [2014-01-14]
  if(system=="InP") return MISCIBILITY_SYSTEM_MISCIBLE; // In_dP calcs=223/200 elements=49,15 [2014-01-14]
  if(system=="InPb") return MISCIBILITY_SYSTEM_MISCIBLE; // In_dPb_d calcs=153/200 elements=49,82 [2014-01-14]
  if(system=="InPd") return MISCIBILITY_SYSTEM_MISCIBLE; // In_dPd_pv calcs=232/200 elements=49,46 [2014-01-14]
  if(system=="InPt") return MISCIBILITY_SYSTEM_MISCIBLE; // In_dPt calcs=229/200 elements=49,78 [2014-01-14]
  if(system=="InRe") return MISCIBILITY_SYSTEM_NOMIX; // In_dRe_pv calcs=204/200 elements=49,75 [2014-01-14]
  if(system=="InRh") return MISCIBILITY_SYSTEM_MISCIBLE; // In_dRh_pv calcs=125/200 elements=49,45 [2014-01-14]
  if(system=="InRu") return MISCIBILITY_SYSTEM_MISCIBLE; // In_dRu_pv calcs=121/200 elements=49,44 [2014-01-14]
  if(system=="InSb") return MISCIBILITY_SYSTEM_MISCIBLE; // In_dSb calcs=216/200 elements=49,51 [2014-01-14]
  if(system=="InSc") return MISCIBILITY_SYSTEM_MISCIBLE; // In_dSc_sv calcs=185/200 elements=49,21 [2014-01-14]
  if(system=="InSe") return MISCIBILITY_SYSTEM_MISCIBLE; // In_dSe calcs=190/200 elements=49,34 [2014-01-14]
  if(system=="InSi") return MISCIBILITY_SYSTEM_NOMIX; // In_dSi calcs=215/200 elements=49,14 [2014-01-14]
  if(system=="InSn") return MISCIBILITY_SYSTEM_NOMIX; // In_dSn calcs=207/200 elements=49,50 [2014-01-14]
  if(system=="InSr") return MISCIBILITY_SYSTEM_MISCIBLE; // In_dSr_sv calcs=119/200 elements=49,38 [2014-01-14]
  if(system=="InTa") return MISCIBILITY_SYSTEM_UNKNOWN; // In_dTa_pv calcs=126/200 elements=49,73 [2014-01-14]
  if(system=="InTc") return MISCIBILITY_SYSTEM_UNKNOWN; // In_dTc_pv calcs=115/200 elements=49,43 [2014-01-14]
  if(system=="InTe") return MISCIBILITY_SYSTEM_MISCIBLE; // In_dTe calcs=141/200 elements=49,52 [2014-01-14]
  if(system=="InTi") return MISCIBILITY_SYSTEM_MISCIBLE; // In_dTi_sv calcs=118/200 elements=49,22 [2014-01-14]
  if(system=="InTl") return MISCIBILITY_SYSTEM_MISCIBLE; // In_dTl_d calcs=124/200 elements=49,81 [2014-01-14]
  if(system=="InV") return MISCIBILITY_SYSTEM_UNKNOWN; // In_dV_sv calcs=110/200 elements=49,23 [2014-01-14]
  if(system=="InW") return MISCIBILITY_SYSTEM_UNKNOWN; // In_dW_pv calcs=110/200 elements=49,74 [2014-01-14]
  if(system=="InY") return MISCIBILITY_SYSTEM_MISCIBLE; // In_dY_sv calcs=202/200 elements=49,39 [2014-01-14]
  if(system=="InZn") return MISCIBILITY_SYSTEM_NOMIX; // In_dZn calcs=208/200 elements=49,30 [2014-01-14]
  if(system=="InZr") return MISCIBILITY_SYSTEM_MISCIBLE; // In_dZr_sv calcs=151/200 elements=49,40 [2014-01-14]
  if(system=="IrK") return MISCIBILITY_SYSTEM_UNKNOWN; // IrK_sv calcs=110/200 elements=77,19 [2014-01-14]
  if(system=="IrLa") return MISCIBILITY_SYSTEM_MISCIBLE; // IrLa calcs=264/200 elements=77,57 [2014-01-14]
  if(system=="IrLi") return MISCIBILITY_SYSTEM_MISCIBLE; // IrLi_sv calcs=121/200 elements=77,3 [2014-01-14]
  if(system=="IrMg") return MISCIBILITY_SYSTEM_MISCIBLE; // IrMg_pv calcs=276/200 elements=77,12 [2014-01-14]
  if(system=="IrMn") return MISCIBILITY_SYSTEM_MISCIBLE; // IrMn_pv calcs=233/200 elements=77,25 [2014-01-14]
  if(system=="IrMo") return MISCIBILITY_SYSTEM_MISCIBLE; // IrMo_pv calcs=274/200 elements=77,42 [2014-01-14]
  if(system=="IrNa") return MISCIBILITY_SYSTEM_UNKNOWN; // IrNa_sv calcs=119/200 elements=77,11 [2014-01-14]
  if(system=="IrNb") return MISCIBILITY_SYSTEM_MISCIBLE; // IrNb_sv calcs=288/200 elements=77,41 [2014-01-14]
  if(system=="IrNi") return MISCIBILITY_SYSTEM_MISCIBLE; // IrNi_pv calcs=228/200 elements=77,28 [2014-01-14]
  if(system=="IrOs") return MISCIBILITY_SYSTEM_MISCIBLE; // IrOs_pv calcs=233/200 elements=77,76 [2014-01-14]
  if(system=="IrP") return MISCIBILITY_SYSTEM_MISCIBLE; // IrP calcs=167/200 elements=77,15 [2014-01-14]
  if(system=="IrPb") return MISCIBILITY_SYSTEM_UNKNOWN; // IrPb_d calcs=153/200 elements=77,82 [2014-01-14]
  if(system=="IrPd") return MISCIBILITY_SYSTEM_NOMIX; // IrPd_pv calcs=205/200 elements=77,46 [2014-01-14]
  if(system=="IrPt") return MISCIBILITY_SYSTEM_NOMIX; // IrPt calcs=210/200 elements=77,78 [2014-01-14]
  if(system=="IrRe") return MISCIBILITY_SYSTEM_MISCIBLE; // IrRe_pv calcs=263/200 elements=77,75 [2014-01-14]
  if(system=="IrRh") return MISCIBILITY_SYSTEM_MISCIBLE; // IrRh_pv calcs=258/200 elements=77,45 [2014-01-14]
  if(system=="IrRu") return MISCIBILITY_SYSTEM_MISCIBLE; // IrRu_pv calcs=241/200 elements=77,44 [2014-01-14]
  if(system=="IrSb") return MISCIBILITY_SYSTEM_MISCIBLE; // IrSb calcs=165/200 elements=77,51 [2014-01-14]
  if(system=="IrSc") return MISCIBILITY_SYSTEM_MISCIBLE; // IrSc_sv calcs=267/200 elements=77,21 [2014-01-14]
  if(system=="IrSe") return MISCIBILITY_SYSTEM_MISCIBLE; // IrSe calcs=182/200 elements=77,34 [2014-01-14]
  if(system=="IrSi") return MISCIBILITY_SYSTEM_MISCIBLE; // IrSi calcs=214/200 elements=77,14 [2014-01-14]
  if(system=="IrSn") return MISCIBILITY_SYSTEM_MISCIBLE; // IrSn calcs=184/200 elements=77,50 [2014-01-14]
  if(system=="IrSr") return MISCIBILITY_SYSTEM_MISCIBLE; // IrSr_sv calcs=115/200 elements=77,38 [2014-01-14]
  if(system=="IrTa") return MISCIBILITY_SYSTEM_MISCIBLE; // IrTa_pv calcs=289/200 elements=77,73 [2014-01-14]
  if(system=="IrTc") return MISCIBILITY_SYSTEM_MISCIBLE; // IrTc_pv calcs=257/200 elements=77,43 [2014-01-14]
  if(system=="IrTe") return MISCIBILITY_SYSTEM_MISCIBLE; // IrTe calcs=214/200 elements=77,52 [2014-01-14]
  if(system=="IrTi") return MISCIBILITY_SYSTEM_MISCIBLE; // IrTi_sv calcs=244/200 elements=77,22 [2014-01-14]
  if(system=="IrTl") return MISCIBILITY_SYSTEM_UNKNOWN; // IrTl_d calcs=120/200 elements=77,81 [2014-01-14]
  if(system=="IrV") return MISCIBILITY_SYSTEM_MISCIBLE; // IrV_sv calcs=266/200 elements=77,23 [2014-01-14]
  if(system=="IrW") return MISCIBILITY_SYSTEM_MISCIBLE; // IrW_pv calcs=275/200 elements=77,74 [2014-01-14]
  if(system=="IrY") return MISCIBILITY_SYSTEM_MISCIBLE; // IrY_sv calcs=270/200 elements=77,39 [2014-01-14]
  if(system=="IrZn") return MISCIBILITY_SYSTEM_MISCIBLE; // IrZn calcs=238/200 elements=77,30 [2014-01-14]
  if(system=="IrZr") return MISCIBILITY_SYSTEM_MISCIBLE; // IrZr_sv calcs=269/200 elements=77,40 [2014-01-14]
  if(system=="KLa") return MISCIBILITY_SYSTEM_UNKNOWN; // K_svLa calcs=103/200 elements=19,57 [2014-01-14]
  if(system=="KLi") return MISCIBILITY_SYSTEM_UNKNOWN; // K_svLi_sv calcs=121/200 elements=19,3 [2014-01-14]
  if(system=="KMg") return MISCIBILITY_SYSTEM_MISCIBLE; // K_svMg_pv calcs=265/200 elements=19,12 [2014-01-14]
  if(system=="KMn") return MISCIBILITY_SYSTEM_UNKNOWN; // K_svMn_pv calcs=113/200 elements=19,25 [2014-01-14]
  if(system=="KMo") return MISCIBILITY_SYSTEM_UNKNOWN; // K_svMo_pv calcs=111/200 elements=19,42 [2014-01-14]
  if(system=="KNa") return MISCIBILITY_SYSTEM_MISCIBLE; // K_svNa_sv calcs=104/200 elements=19,11 [2014-01-14]
  if(system=="KNb") return MISCIBILITY_SYSTEM_UNKNOWN; // K_svNb_sv calcs=116/200 elements=19,41 [2014-01-14]
  if(system=="KNi") return MISCIBILITY_SYSTEM_UNKNOWN; // K_svNi_pv calcs=90/200 elements=19,28 [2014-01-14]
  if(system=="KOs") return MISCIBILITY_SYSTEM_UNKNOWN; // K_svOs_pv calcs=104/200 elements=19,76 [2014-01-14]
  if(system=="KP") return MISCIBILITY_SYSTEM_MISCIBLE; // K_svP calcs=159/200 elements=19,15 [2014-01-14]
  if(system=="KPb") return MISCIBILITY_SYSTEM_MISCIBLE; // K_svPb_d calcs=125/200 elements=19,82 [2014-01-14]
  if(system=="KPd") return MISCIBILITY_SYSTEM_MISCIBLE; // K_svPd_pv calcs=226/200 elements=19,46 [2014-01-14]
  if(system=="KPt") return MISCIBILITY_SYSTEM_MISCIBLE; // K_svPt calcs=230/200 elements=19,78 [2014-01-14]
  if(system=="KRe") return MISCIBILITY_SYSTEM_UNKNOWN; // K_svRe_pv calcs=114/200 elements=19,75 [2014-01-14]
  if(system=="KRh") return MISCIBILITY_SYSTEM_UNKNOWN; // K_svRh_pv calcs=96/200 elements=19,45 [2014-01-14]
  if(system=="KRu") return MISCIBILITY_SYSTEM_UNKNOWN; // K_svRu_pv calcs=109/200 elements=19,44 [2014-01-14]
  if(system=="KSb") return MISCIBILITY_SYSTEM_MISCIBLE; // K_svSb calcs=123/200 elements=19,51 [2014-01-14]
  if(system=="KSc") return MISCIBILITY_SYSTEM_UNKNOWN; // K_svSc_sv calcs=104/200 elements=19,21 [2014-01-14]
  if(system=="KSe") return MISCIBILITY_SYSTEM_MISCIBLE; // K_svSe calcs=121/200 elements=19,34 [2014-01-14]
  if(system=="KSi") return MISCIBILITY_SYSTEM_MISCIBLE; // K_svSi calcs=133/200 elements=19,14 [2014-01-14]
  if(system=="KSn") return MISCIBILITY_SYSTEM_MISCIBLE; // K_svSn calcs=127/200 elements=19,50 [2014-01-14]
  if(system=="KSr") return MISCIBILITY_SYSTEM_UNKNOWN; // K_svSr_sv calcs=124/200 elements=19,38 [2014-01-14]
  if(system=="KTa") return MISCIBILITY_SYSTEM_UNKNOWN; // K_svTa_pv calcs=124/200 elements=19,73 [2014-01-14]
  if(system=="KTc") return MISCIBILITY_SYSTEM_UNKNOWN; // K_svTc_pv calcs=111/200 elements=19,43 [2014-01-14]
  if(system=="KTe") return MISCIBILITY_SYSTEM_MISCIBLE; // K_svTe calcs=115/200 elements=19,52 [2014-01-14]
  if(system=="KTi") return MISCIBILITY_SYSTEM_UNKNOWN; // K_svTi_sv calcs=119/200 elements=19,22 [2014-01-14]
  if(system=="KTl") return MISCIBILITY_SYSTEM_MISCIBLE; // K_svTl_d calcs=117/200 elements=19,81 [2014-01-14]
  if(system=="KV") return MISCIBILITY_SYSTEM_UNKNOWN; // K_svV_sv calcs=101/200 elements=19,23 [2014-01-14]
  if(system=="KW") return MISCIBILITY_SYSTEM_UNKNOWN; // K_svW_pv calcs=122/200 elements=19,74 [2014-01-14]
  if(system=="KY") return MISCIBILITY_SYSTEM_UNKNOWN; // K_svY_sv calcs=109/200 elements=19,39 [2014-01-14]
  if(system=="KZn") return MISCIBILITY_SYSTEM_MISCIBLE; // K_svZn calcs=115/200 elements=19,30 [2014-01-14]
  if(system=="KZr") return MISCIBILITY_SYSTEM_UNKNOWN; // K_svZr_sv calcs=126/200 elements=19,40 [2014-01-14]
  if(system=="LaLi") return MISCIBILITY_SYSTEM_UNKNOWN; // LaLi_sv calcs=121/200 elements=57,3 [2014-01-14]
  if(system=="LaMg") return MISCIBILITY_SYSTEM_MISCIBLE; // LaMg_pv calcs=264/200 elements=57,12 [2014-01-14]
  if(system=="LaMn") return MISCIBILITY_SYSTEM_NOMIX; // LaMn_pv calcs=207/200 elements=57,25 [2014-01-14]
  if(system=="LaMo") return MISCIBILITY_SYSTEM_NOMIX; // LaMo_pv calcs=225/200 elements=57,42 [2014-01-14]
  if(system=="LaNa") return MISCIBILITY_SYSTEM_UNKNOWN; // LaNa_sv calcs=103/200 elements=57,11 [2014-01-14]
  if(system=="LaNb") return MISCIBILITY_SYSTEM_NOMIX; // LaNb_sv calcs=205/200 elements=57,41 [2014-01-14]
  if(system=="LaNi") return MISCIBILITY_SYSTEM_MISCIBLE; // LaNi_pv calcs=253/200 elements=57,28 [2014-01-14]
  if(system=="LaOs") return MISCIBILITY_SYSTEM_MISCIBLE; // LaOs_pv calcs=266/200 elements=57,76 [2014-01-14]
  if(system=="LaP") return MISCIBILITY_SYSTEM_MISCIBLE; // LaP calcs=151/200 elements=57,15 [2014-01-14]
  if(system=="LaPb") return MISCIBILITY_SYSTEM_MISCIBLE; // LaPb_d calcs=195/200 elements=57,82 [2014-01-14]
  if(system=="LaPd") return MISCIBILITY_SYSTEM_MISCIBLE; // LaPd_pv calcs=268/200 elements=57,46 [2014-01-14]
  if(system=="LaPt") return MISCIBILITY_SYSTEM_MISCIBLE; // LaPt calcs=270/200 elements=57,78 [2014-01-14]
  if(system=="LaRe") return MISCIBILITY_SYSTEM_NOMIX; // LaRe_pv calcs=309/200 elements=57,75 [2014-01-14]
  if(system=="LaRh") return MISCIBILITY_SYSTEM_MISCIBLE; // LaRh_pv calcs=264/200 elements=57,45 [2014-01-14]
  if(system=="LaRu") return MISCIBILITY_SYSTEM_MISCIBLE; // LaRu_pv calcs=270/200 elements=57,44 [2014-01-14]
  if(system=="LaSb") return MISCIBILITY_SYSTEM_MISCIBLE; // LaSb calcs=125/200 elements=57,51 [2014-01-14]
  if(system=="LaSc") return MISCIBILITY_SYSTEM_NOMIX; // LaSc_sv calcs=249/200 elements=57,21 [2014-01-14]
  if(system=="LaSe") return MISCIBILITY_SYSTEM_MISCIBLE; // LaSe calcs=121/200 elements=57,34 [2014-01-14]
  if(system=="LaSi") return MISCIBILITY_SYSTEM_MISCIBLE; // LaSi calcs=135/200 elements=57,14 [2014-01-14]
  if(system=="LaSn") return MISCIBILITY_SYSTEM_MISCIBLE; // LaSn calcs=203/200 elements=57,50 [2014-01-14]
  if(system=="LaSr") return MISCIBILITY_SYSTEM_UNKNOWN; // LaSr_sv calcs=122/200 elements=57,38 [2014-01-14]
  if(system=="LaTa") return MISCIBILITY_SYSTEM_NOMIX; // LaTa_pv calcs=233/200 elements=57,73 [2014-01-14]
  if(system=="LaTc") return MISCIBILITY_SYSTEM_MISCIBLE; // LaTc_pv calcs=279/200 elements=57,43 [2014-01-14]
  if(system=="LaTe") return MISCIBILITY_SYSTEM_MISCIBLE; // LaTe calcs=116/200 elements=57,52 [2014-01-14]
  if(system=="LaTi") return MISCIBILITY_SYSTEM_NOMIX; // LaTi_sv calcs=218/200 elements=57,22 [2014-01-14]
  if(system=="LaTl") return MISCIBILITY_SYSTEM_MISCIBLE; // LaTl_d calcs=120/200 elements=57,81 [2014-01-14]
  if(system=="LaV") return MISCIBILITY_SYSTEM_NOMIX; // LaV_sv calcs=212/200 elements=57,23 [2014-01-14]
  if(system=="LaW") return MISCIBILITY_SYSTEM_NOMIX; // LaW_pv calcs=222/200 elements=57,74 [2014-01-14]
  if(system=="LaY") return MISCIBILITY_SYSTEM_NOMIX; // LaY_sv calcs=214/200 elements=57,39 [2014-01-14]
  if(system=="LaZn") return MISCIBILITY_SYSTEM_MISCIBLE; // LaZn calcs=266/200 elements=57,30 [2014-01-14]
  if(system=="LaZr") return MISCIBILITY_SYSTEM_NOMIX; // LaZr_sv calcs=221/200 elements=57,40 [2014-01-14]
  if(system=="LiMg") return MISCIBILITY_SYSTEM_MISCIBLE; // Li_svMg_pv calcs=265/200 elements=3,12 [2014-01-14]
  if(system=="LiMn") return MISCIBILITY_SYSTEM_UNKNOWN; // Li_svMn_pv calcs=126/200 elements=3,25 [2014-01-14]
  if(system=="LiMo") return MISCIBILITY_SYSTEM_UNKNOWN; // Li_svMo_pv calcs=119/200 elements=3,42 [2014-01-14]
  if(system=="LiNa") return MISCIBILITY_SYSTEM_UNKNOWN; // Li_svNa_sv calcs=118/200 elements=3,11 [2014-01-14]
  if(system=="LiNb") return MISCIBILITY_SYSTEM_UNKNOWN; // Li_svNb_sv calcs=130/200 elements=3,41 [2014-01-14]
  if(system=="LiNi") return MISCIBILITY_SYSTEM_MISCIBLE; // Li_svNi_pv calcs=120/200 elements=3,28 [2014-01-14]
  if(system=="LiOs") return MISCIBILITY_SYSTEM_UNKNOWN; // Li_svOs_pv calcs=118/200 elements=3,76 [2014-01-14]
  if(system=="LiP") return MISCIBILITY_SYSTEM_MISCIBLE; // Li_svP calcs=154/200 elements=3,15 [2014-01-14]
  if(system=="LiPb") return MISCIBILITY_SYSTEM_MISCIBLE; // Li_svPb_d calcs=157/200 elements=3,82 [2014-01-14]
  if(system=="LiPd") return MISCIBILITY_SYSTEM_MISCIBLE; // Li_svPd_pv calcs=232/200 elements=3,46 [2014-01-14]
  if(system=="LiPt") return MISCIBILITY_SYSTEM_MISCIBLE; // Li_svPt calcs=239/200 elements=3,78 [2014-01-14]
  if(system=="LiRe") return MISCIBILITY_SYSTEM_UNKNOWN; // Li_svRe_pv calcs=124/200 elements=3,75 [2014-01-14]
  if(system=="LiRh") return MISCIBILITY_SYSTEM_MISCIBLE; // Li_svRh_pv calcs=127/200 elements=3,45 [2014-01-14]
  if(system=="LiRu") return MISCIBILITY_SYSTEM_UNKNOWN; // Li_svRu_pv calcs=127/200 elements=3,44 [2014-01-14]
  if(system=="LiSb") return MISCIBILITY_SYSTEM_MISCIBLE; // Li_svSb calcs=123/200 elements=3,51 [2014-01-14]
  if(system=="LiSc") return MISCIBILITY_SYSTEM_UNKNOWN; // Li_svSc_sv calcs=118/200 elements=3,21 [2014-01-14]
  if(system=="LiSe") return MISCIBILITY_SYSTEM_MISCIBLE; // Li_svSe calcs=134/200 elements=3,34 [2014-01-14]
  if(system=="LiSi") return MISCIBILITY_SYSTEM_MISCIBLE; // Li_svSi calcs=131/200 elements=3,14 [2014-01-14]
  if(system=="LiSn") return MISCIBILITY_SYSTEM_MISCIBLE; // Li_svSn calcs=131/200 elements=3,50 [2014-01-14]
  if(system=="LiSr") return MISCIBILITY_SYSTEM_MISCIBLE; // Li_svSr_sv calcs=115/200 elements=3,38 [2014-01-14]
  if(system=="LiTa") return MISCIBILITY_SYSTEM_UNKNOWN; // Li_svTa_pv calcs=114/200 elements=3,73 [2014-01-14]
  if(system=="LiTc") return MISCIBILITY_SYSTEM_UNKNOWN; // Li_svTc_pv calcs=116/200 elements=3,43 [2014-01-14]
  if(system=="LiTe") return MISCIBILITY_SYSTEM_MISCIBLE; // Li_svTe calcs=121/200 elements=3,52 [2014-01-14]
  if(system=="LiTi") return MISCIBILITY_SYSTEM_UNKNOWN; // Li_svTi_sv calcs=128/200 elements=3,22 [2014-01-14]
  if(system=="LiTl") return MISCIBILITY_SYSTEM_MISCIBLE; // Li_svTl_d calcs=134/200 elements=3,81 [2014-01-14]
  if(system=="LiV") return MISCIBILITY_SYSTEM_UNKNOWN; // Li_svV_sv calcs=118/200 elements=3,23 [2014-01-14]
  if(system=="LiW") return MISCIBILITY_SYSTEM_UNKNOWN; // Li_svW_pv calcs=113/200 elements=3,74 [2014-01-14]
  if(system=="LiY") return MISCIBILITY_SYSTEM_UNKNOWN; // Li_svY_sv calcs=124/200 elements=3,39 [2014-01-14]
  if(system=="LiZn") return MISCIBILITY_SYSTEM_MISCIBLE; // Li_svZn calcs=125/200 elements=3,30 [2014-01-14]
  if(system=="LiZr") return MISCIBILITY_SYSTEM_UNKNOWN; // Li_svZr_sv calcs=120/200 elements=3,40 [2014-01-14]
  if(system=="MgMn") return MISCIBILITY_SYSTEM_NOMIX; // Mg_pvMn_pv calcs=239/200 elements=12,25 [2014-01-14]
  if(system=="MgMo") return MISCIBILITY_SYSTEM_UNKNOWN; // Mg_pvMo_pv calcs=122/200 elements=12,42 [2014-01-14]
  if(system=="MgNa") return MISCIBILITY_SYSTEM_UNKNOWN; // Mg_pvNa_sv calcs=109/200 elements=12,11 [2014-01-14]
  if(system=="MgNb") return MISCIBILITY_SYSTEM_UNKNOWN; // Mg_pvNb_sv calcs=130/200 elements=12,41 [2014-01-14]
  if(system=="MgNi") return MISCIBILITY_SYSTEM_MISCIBLE; // Mg_pvNi_pv calcs=255/200 elements=12,28 [2014-01-14]
  if(system=="MgOs") return MISCIBILITY_SYSTEM_UNKNOWN; // Mg_pvOs_pv calcs=151/200 elements=12,76 [2014-01-14]
  if(system=="MgP") return MISCIBILITY_SYSTEM_MISCIBLE; // Mg_pvP calcs=173/200 elements=12,15 [2014-01-14]
  if(system=="MgPb") return MISCIBILITY_SYSTEM_MISCIBLE; // Mg_pvPb_d calcs=171/200 elements=12,82 [2014-01-14]
  if(system=="MgPd") return MISCIBILITY_SYSTEM_MISCIBLE; // Mg_pvPd_pv calcs=278/200 elements=12,46 [2014-01-14]
  if(system=="MgPt") return MISCIBILITY_SYSTEM_MISCIBLE; // Mg_pvPt calcs=272/200 elements=12,78 [2014-01-14]
  if(system=="MgRe") return MISCIBILITY_SYSTEM_MISCIBLE; // Mg_pvRe_pv calcs=179/200 elements=12,75 [2014-01-14]
  if(system=="MgRh") return MISCIBILITY_SYSTEM_MISCIBLE; // Mg_pvRh_pv calcs=230/200 elements=12,45 [2014-01-14]
  if(system=="MgRu") return MISCIBILITY_SYSTEM_MISCIBLE; // Mg_pvRu_pv calcs=175/200 elements=12,44 [2014-01-14]
  if(system=="MgSb") return MISCIBILITY_SYSTEM_MISCIBLE; // Mg_pvSb calcs=204/200 elements=12,51 [2014-01-14]
  if(system=="MgSc") return MISCIBILITY_SYSTEM_MISCIBLE; // Mg_pvSc_sv calcs=250/200 elements=12,21 [2014-01-14]
  if(system=="MgSe") return MISCIBILITY_SYSTEM_MISCIBLE; // Mg_pvSe calcs=259/200 elements=12,34 [2014-01-14]
  if(system=="MgSn") return MISCIBILITY_SYSTEM_MISCIBLE; // Mg_pvSn calcs=262/200 elements=12,50 [2014-01-14]
  if(system=="MgSr") return MISCIBILITY_SYSTEM_MISCIBLE; // Mg_pvSr_sv calcs=142/200 elements=12,38 [2014-01-14]
  if(system=="MgTa") return MISCIBILITY_SYSTEM_NOMIX; // Mg_pvTa_pv calcs=248/200 elements=12,73 [2014-01-14]
  if(system=="MgTc") return MISCIBILITY_SYSTEM_MISCIBLE; // Mg_pvTc_pv calcs=391/200 elements=12,43 [2014-01-14]
  if(system=="MgTe") return MISCIBILITY_SYSTEM_MISCIBLE; // Mg_pvTe calcs=217/200 elements=12,52 [2014-01-14]
  if(system=="MgTi") return MISCIBILITY_SYSTEM_NOMIX; // Mg_pvTi_sv calcs=223/200 elements=12,22 [2014-01-14]
  if(system=="MgTl") return MISCIBILITY_SYSTEM_MISCIBLE; // Mg_pvTl_d calcs=261/200 elements=12,81 [2014-01-14]
  if(system=="MgV") return MISCIBILITY_SYSTEM_UNKNOWN; // Mg_pvV_sv calcs=111/200 elements=12,23 [2014-01-14]
  if(system=="MgW") return MISCIBILITY_SYSTEM_NOMIX; // Mg_pvW_pv calcs=214/200 elements=12,74 [2014-01-14]
  if(system=="MgY") return MISCIBILITY_SYSTEM_MISCIBLE; // Mg_pvY_sv calcs=124/200 elements=12,39 [2014-01-14]
  if(system=="MgZn") return MISCIBILITY_SYSTEM_MISCIBLE; // Mg_pvZn calcs=120/200 elements=12,30 [2014-01-14]
  if(system=="MgZr") return MISCIBILITY_SYSTEM_MISCIBLE; // Mg_pvZr_sv calcs=126/200 elements=12,40 [2014-01-14]
  if(system=="MnMo") return MISCIBILITY_SYSTEM_NOMIX; // Mn_pvMo_pv calcs=246/200 elements=25,42 [2014-01-14]
  if(system=="MnNa") return MISCIBILITY_SYSTEM_UNKNOWN; // Mn_pvNa_sv calcs=103/200 elements=25,11 [2014-01-14]
  if(system=="MnNb") return MISCIBILITY_SYSTEM_MISCIBLE; // Mn_pvNb_sv calcs=239/200 elements=25,41 [2014-01-14]
  if(system=="MnNi") return MISCIBILITY_SYSTEM_MISCIBLE; // Mn_pvNi_pv calcs=272/200 elements=25,28 [2014-01-14]
  if(system=="MnOs") return MISCIBILITY_SYSTEM_MISCIBLE; // Mn_pvOs_pv calcs=257/200 elements=25,76 [2014-01-14]
  if(system=="MnP") return MISCIBILITY_SYSTEM_MISCIBLE; // Mn_pvP calcs=272/200 elements=25,15 [2014-01-14]
  if(system=="MnPb") return MISCIBILITY_SYSTEM_NOMIX; // Mn_pvPb_d calcs=234/200 elements=25,82 [2014-01-14]
  if(system=="MnPd") return MISCIBILITY_SYSTEM_MISCIBLE; // Mn_pvPd_pv calcs=271/200 elements=25,46 [2014-01-14]
  if(system=="MnPt") return MISCIBILITY_SYSTEM_MISCIBLE; // Mn_pvPt calcs=270/200 elements=25,78 [2014-01-14]
  if(system=="MnRe") return MISCIBILITY_SYSTEM_MISCIBLE; // Mn_pvRe_pv calcs=266/200 elements=25,75 [2014-01-14]
  if(system=="MnRh") return MISCIBILITY_SYSTEM_MISCIBLE; // Mn_pvRh_pv calcs=241/200 elements=25,45 [2014-01-14]
  if(system=="MnRu") return MISCIBILITY_SYSTEM_MISCIBLE; // Mn_pvRu_pv calcs=254/200 elements=25,44 [2014-01-14]
  if(system=="MnSb") return MISCIBILITY_SYSTEM_MISCIBLE; // Mn_pvSb calcs=218/200 elements=25,51 [2014-01-14]
  if(system=="MnSc") return MISCIBILITY_SYSTEM_NOMIX; // Mn_pvSc_sv calcs=245/200 elements=25,21 [2014-01-14]
  if(system=="MnSe") return MISCIBILITY_SYSTEM_MISCIBLE; // Mn_pvSe calcs=191/200 elements=25,34 [2014-01-14]
  if(system=="MnSi") return MISCIBILITY_SYSTEM_MISCIBLE; // Mn_pvSi calcs=215/200 elements=25,14 [2014-01-14]
  if(system=="MnSn") return MISCIBILITY_SYSTEM_MISCIBLE; // Mn_pvSn calcs=119/200 elements=25,50 [2014-01-14]
  if(system=="MnSr") return MISCIBILITY_SYSTEM_UNKNOWN; // Mn_pvSr_sv calcs=110/200 elements=25,38 [2014-01-14]
  if(system=="MnTa") return MISCIBILITY_SYSTEM_MISCIBLE; // Mn_pvTa_pv calcs=237/200 elements=25,73 [2014-01-14]
  if(system=="MnTc") return MISCIBILITY_SYSTEM_NOMIX; // Mn_pvTc_pv calcs=231/200 elements=25,43 [2014-01-14]
  if(system=="MnTe") return MISCIBILITY_SYSTEM_MISCIBLE; // Mn_pvTe calcs=178/200 elements=25,52 [2014-01-14]
  if(system=="MnTi") return MISCIBILITY_SYSTEM_MISCIBLE; // Mn_pvTi_sv calcs=245/200 elements=25,22 [2014-01-14]
  if(system=="MnTl") return MISCIBILITY_SYSTEM_UNKNOWN; // Mn_pvTl_d calcs=112/200 elements=25,81 [2014-01-14]
  if(system=="MnV") return MISCIBILITY_SYSTEM_MISCIBLE; // Mn_pvV_sv calcs=250/200 elements=25,23 [2014-01-14]
  if(system=="MnW") return MISCIBILITY_SYSTEM_NOMIX; // Mn_pvW_pv calcs=230/200 elements=25,74 [2014-01-14]
  if(system=="MnY") return MISCIBILITY_SYSTEM_NOMIX; // Mn_pvY_sv calcs=209/200 elements=25,39 [2014-01-14]
  if(system=="MnZn") return MISCIBILITY_SYSTEM_MISCIBLE; // Mn_pvZn calcs=245/200 elements=25,30 [2014-01-14]
  if(system=="MnZr") return MISCIBILITY_SYSTEM_MISCIBLE; // Mn_pvZr_sv calcs=240/200 elements=25,40 [2014-01-14]
  if(system=="MgMo") return MISCIBILITY_SYSTEM_NOMIX; // Mo_pvMg_pv calcs=204/200 elements=42,12 [2014-01-14]
  if(system=="MoNa") return MISCIBILITY_SYSTEM_UNKNOWN; // Mo_pvNa_sv calcs=107/200 elements=42,11 [2014-01-14]
  if(system=="MoNb") return MISCIBILITY_SYSTEM_MISCIBLE; // Mo_pvNb_sv calcs=233/200 elements=42,41 [2014-01-14]
  if(system=="MoNi") return MISCIBILITY_SYSTEM_MISCIBLE; // Mo_pvNi_pv calcs=230/200 elements=42,28 [2014-01-14]
  if(system=="MoOs") return MISCIBILITY_SYSTEM_MISCIBLE; // Mo_pvOs_pv calcs=268/200 elements=42,76 [2014-01-14]
  if(system=="MoP") return MISCIBILITY_SYSTEM_MISCIBLE; // Mo_pvP calcs=167/200 elements=42,15 [2014-01-14]
  if(system=="MoPb") return MISCIBILITY_SYSTEM_UNKNOWN; // Mo_pvPb_d calcs=146/200 elements=42,82 [2014-01-14]
  if(system=="MoPd") return MISCIBILITY_SYSTEM_MISCIBLE; // Mo_pvPd_pv calcs=259/200 elements=42,46 [2014-01-14]
  if(system=="MoPt") return MISCIBILITY_SYSTEM_MISCIBLE; // Mo_pvPt calcs=254/200 elements=42,78 [2014-01-14]
  if(system=="MoRe") return MISCIBILITY_SYSTEM_MISCIBLE; // Mo_pvRe_pv calcs=256/200 elements=42,75 [2014-01-14]
  if(system=="MoRh") return MISCIBILITY_SYSTEM_MISCIBLE; // Mo_pvRh_pv calcs=243/200 elements=42,45 [2014-01-14]
  if(system=="MoRu") return MISCIBILITY_SYSTEM_MISCIBLE; // Mo_pvRu_pv calcs=275/200 elements=42,44 [2014-01-14]
  if(system=="MoSb") return MISCIBILITY_SYSTEM_MISCIBLE; // Mo_pvSb calcs=142/200 elements=42,51 [2014-01-14]
  if(system=="MoSc") return MISCIBILITY_SYSTEM_MISCIBLE; // Mo_pvSc_sv calcs=257/200 elements=42,21 [2014-01-14]
  if(system=="MoSe") return MISCIBILITY_SYSTEM_MISCIBLE; // Mo_pvSe calcs=122/200 elements=42,34 [2014-01-14]
  if(system=="MoSi") return MISCIBILITY_SYSTEM_MISCIBLE; // Mo_pvSi calcs=222/200 elements=42,14 [2014-01-14]
  if(system=="MoSn") return MISCIBILITY_SYSTEM_UNKNOWN; // Mo_pvSn calcs=132/200 elements=42,50 [2014-01-14]
  if(system=="MoSr") return MISCIBILITY_SYSTEM_UNKNOWN; // Mo_pvSr_sv calcs=121/200 elements=42,38 [2014-01-14]
  if(system=="MoTa") return MISCIBILITY_SYSTEM_MISCIBLE; // Mo_pvTa_pv calcs=890/200 elements=42,73 [2014-01-14]
  if(system=="MoTc") return MISCIBILITY_SYSTEM_NOMIX; // Mo_pvTc_pv calcs=259/200 elements=42,43 [2014-01-14]
  if(system=="MoTe") return MISCIBILITY_SYSTEM_MISCIBLE; // Mo_pvTe calcs=197/200 elements=42,52 [2014-01-14]
  if(system=="MoTi") return MISCIBILITY_SYSTEM_MISCIBLE; // Mo_pvTi_sv calcs=900/200 elements=42,22 [2014-01-14]
  if(system=="MoTl") return MISCIBILITY_SYSTEM_UNKNOWN; // Mo_pvTl_d calcs=121/200 elements=42,81 [2014-01-14]
  if(system=="MoV") return MISCIBILITY_SYSTEM_MISCIBLE; // Mo_pvV_sv calcs=236/200 elements=42,23 [2014-01-14]
  if(system=="MoW") return MISCIBILITY_SYSTEM_MISCIBLE; // Mo_pvW_pv calcs=260/200 elements=42,74 [2014-01-14]
  if(system=="MoY") return MISCIBILITY_SYSTEM_NOMIX; // Mo_pvY_sv calcs=276/200 elements=42,39 [2014-01-14]
  if(system=="MoZn") return MISCIBILITY_SYSTEM_MISCIBLE; // Mo_pvZn calcs=254/200 elements=42,30 [2014-01-14]
  if(system=="MoZr") return MISCIBILITY_SYSTEM_MISCIBLE; // Mo_pvZr_sv calcs=237/200 elements=42,40 [2014-01-14]
  if(system=="MgNa") return MISCIBILITY_SYSTEM_MISCIBLE; // Na_pvMg_pv calcs=260/200 elements=11,12 [2014-01-14]
  if(system=="NaPd") return MISCIBILITY_SYSTEM_MISCIBLE; // Na_pvPd_pv calcs=247/200 elements=11,46 [2014-01-14]
  if(system=="NaPt") return MISCIBILITY_SYSTEM_MISCIBLE; // Na_pvPt calcs=242/200 elements=11,78 [2014-01-14]
  if(system=="NaNb") return MISCIBILITY_SYSTEM_UNKNOWN; // Na_svNb_sv calcs=121/200 elements=11,41 [2014-01-14]
  if(system=="NaNi") return MISCIBILITY_SYSTEM_UNKNOWN; // Na_svNi_pv calcs=105/200 elements=11,28 [2014-01-14]
  if(system=="NaOs") return MISCIBILITY_SYSTEM_UNKNOWN; // Na_svOs_pv calcs=104/200 elements=11,76 [2014-01-14]
  if(system=="NaP") return MISCIBILITY_SYSTEM_MISCIBLE; // Na_svP calcs=142/200 elements=11,15 [2014-01-14]
  if(system=="NaPb") return MISCIBILITY_SYSTEM_MISCIBLE; // Na_svPb_d calcs=115/200 elements=11,82 [2014-01-14]
  if(system=="NaPd") return MISCIBILITY_SYSTEM_MISCIBLE; // Na_svPd_pv calcs=129/200 elements=11,46 [2014-01-14]
  if(system=="NaPt") return MISCIBILITY_SYSTEM_MISCIBLE; // Na_svPt calcs=143/200 elements=11,78 [2014-01-14]
  if(system=="NaRe") return MISCIBILITY_SYSTEM_UNKNOWN; // Na_svRe_pv calcs=100/200 elements=11,75 [2014-01-14]
  if(system=="NaRh") return MISCIBILITY_SYSTEM_UNKNOWN; // Na_svRh_pv calcs=113/200 elements=11,45 [2014-01-14]
  if(system=="NaRu") return MISCIBILITY_SYSTEM_UNKNOWN; // Na_svRu_pv calcs=98/200 elements=11,44 [2014-01-14]
  if(system=="NaSb") return MISCIBILITY_SYSTEM_MISCIBLE; // Na_svSb calcs=109/200 elements=11,51 [2014-01-14]
  if(system=="NaSc") return MISCIBILITY_SYSTEM_UNKNOWN; // Na_svSc_sv calcs=101/200 elements=11,21 [2014-01-14]
  if(system=="NaSe") return MISCIBILITY_SYSTEM_MISCIBLE; // Na_svSe calcs=112/200 elements=11,34 [2014-01-14]
  if(system=="NaSi") return MISCIBILITY_SYSTEM_MISCIBLE; // Na_svSi calcs=115/200 elements=11,14 [2014-01-14]
  if(system=="NaSn") return MISCIBILITY_SYSTEM_MISCIBLE; // Na_svSn calcs=113/200 elements=11,50 [2014-01-14]
  if(system=="NaSr") return MISCIBILITY_SYSTEM_UNKNOWN; // Na_svSr_sv calcs=107/200 elements=11,38 [2014-01-14]
  if(system=="NaTa") return MISCIBILITY_SYSTEM_UNKNOWN; // Na_svTa_pv calcs=105/200 elements=11,73 [2014-01-14]
  if(system=="NaTc") return MISCIBILITY_SYSTEM_UNKNOWN; // Na_svTc_pv calcs=108/200 elements=11,43 [2014-01-14]
  if(system=="NaTe") return MISCIBILITY_SYSTEM_MISCIBLE; // Na_svTe calcs=103/200 elements=11,52 [2014-01-14]
  if(system=="NaTi") return MISCIBILITY_SYSTEM_UNKNOWN; // Na_svTi_sv calcs=97/200 elements=11,22 [2014-01-14]
  if(system=="NaTl") return MISCIBILITY_SYSTEM_MISCIBLE; // Na_svTl_d calcs=117/200 elements=11,81 [2014-01-14]
  if(system=="NaV") return MISCIBILITY_SYSTEM_UNKNOWN; // Na_svV_sv calcs=102/200 elements=11,23 [2014-01-14]
  if(system=="NaW") return MISCIBILITY_SYSTEM_UNKNOWN; // Na_svW_pv calcs=108/200 elements=11,74 [2014-01-14]
  if(system=="NaY") return MISCIBILITY_SYSTEM_UNKNOWN; // Na_svY_sv calcs=111/200 elements=11,39 [2014-01-14]
  if(system=="NaZn") return MISCIBILITY_SYSTEM_MISCIBLE; // Na_svZn calcs=122/200 elements=11,30 [2014-01-14]
  if(system=="NaZr") return MISCIBILITY_SYSTEM_UNKNOWN; // Na_svZr_sv calcs=115/200 elements=11,40 [2014-01-14]
  if(system=="MgNb") return MISCIBILITY_SYSTEM_NOMIX; // Nb_svMg_pv calcs=204/200 elements=41,12 [2014-01-14]
  if(system=="NbNi") return MISCIBILITY_SYSTEM_MISCIBLE; // Nb_svNi_pv calcs=234/200 elements=41,28 [2014-01-14]
  if(system=="NbOs") return MISCIBILITY_SYSTEM_MISCIBLE; // Nb_svOs_pv calcs=291/200 elements=41,76 [2014-01-14]
  if(system=="NbP") return MISCIBILITY_SYSTEM_MISCIBLE; // Nb_svP calcs=199/200 elements=41,15 [2014-01-14]
  if(system=="NbPb") return MISCIBILITY_SYSTEM_NOMIX; // Nb_svPb_d calcs=213/200 elements=41,82 [2014-01-14]
  if(system=="NbPd") return MISCIBILITY_SYSTEM_MISCIBLE; // Nb_svPd_pv calcs=286/200 elements=41,46 [2014-01-14]
  if(system=="NbPt") return MISCIBILITY_SYSTEM_MISCIBLE; // Nb_svPt calcs=286/200 elements=41,78 [2014-01-14]
  if(system=="NbRe") return MISCIBILITY_SYSTEM_MISCIBLE; // Nb_svRe_pv calcs=264/200 elements=41,75 [2014-01-14]
  if(system=="NbRh") return MISCIBILITY_SYSTEM_MISCIBLE; // Nb_svRh_pv calcs=282/200 elements=41,45 [2014-01-14]
  if(system=="NbRu") return MISCIBILITY_SYSTEM_MISCIBLE; // Nb_svRu_pv calcs=247/200 elements=41,44 [2014-01-14]
  if(system=="NbSb") return MISCIBILITY_SYSTEM_MISCIBLE; // Nb_svSb calcs=190/200 elements=41,51 [2014-01-14]
  if(system=="NbSc") return MISCIBILITY_SYSTEM_NOMIX; // Nb_svSc_sv calcs=264/200 elements=41,21 [2014-01-14]
  if(system=="NbSe") return MISCIBILITY_SYSTEM_MISCIBLE; // Nb_svSe calcs=137/200 elements=41,34 [2014-01-14]
  if(system=="NbSi") return MISCIBILITY_SYSTEM_MISCIBLE; // Nb_svSi calcs=268/200 elements=41,14 [2014-01-14]
  if(system=="NbSn") return MISCIBILITY_SYSTEM_MISCIBLE; // Nb_svSn calcs=122/200 elements=41,50 [2014-01-14]
  if(system=="NbSr") return MISCIBILITY_SYSTEM_UNKNOWN; // Nb_svSr_sv calcs=114/200 elements=41,38 [2014-01-14]
  if(system=="NbTa") return MISCIBILITY_SYSTEM_MISCIBLE; // Nb_svTa_pv calcs=236/200 elements=41,73 [2014-01-14]
  if(system=="NbTc") return MISCIBILITY_SYSTEM_MISCIBLE; // Nb_svTc_pv calcs=255/200 elements=41,43 [2014-01-14]
  if(system=="NbTe") return MISCIBILITY_SYSTEM_MISCIBLE; // Nb_svTe calcs=216/200 elements=41,52 [2014-01-14]
  if(system=="NbTi") return MISCIBILITY_SYSTEM_NOMIX; // Nb_svTi_sv calcs=206/200 elements=41,22 [2014-01-14]
  if(system=="NbTl") return MISCIBILITY_SYSTEM_UNKNOWN; // Nb_svTl_d calcs=112/200 elements=41,81 [2014-01-14]
  if(system=="NbV") return MISCIBILITY_SYSTEM_MISCIBLE; // Nb_svV_sv calcs=261/200 elements=41,23 [2014-01-14]
  if(system=="NbW") return MISCIBILITY_SYSTEM_MISCIBLE; // Nb_svW_pv calcs=235/200 elements=41,74 [2014-01-14]
  if(system=="NbY") return MISCIBILITY_SYSTEM_NOMIX; // Nb_svY_sv calcs=209/200 elements=41,39 [2014-01-14]
  if(system=="NbZn") return MISCIBILITY_SYSTEM_MISCIBLE; // Nb_svZn calcs=260/200 elements=41,30 [2014-01-14]
  if(system=="NbZr") return MISCIBILITY_SYSTEM_NOMIX; // Nb_svZr_sv calcs=207/200 elements=41,40 [2014-01-14]
  if(system=="NiOs") return MISCIBILITY_SYSTEM_NOMIX; // Ni_pvOs_pv calcs=203/200 elements=28,76 [2014-01-14]
  if(system=="NiP") return MISCIBILITY_SYSTEM_MISCIBLE; // Ni_pvP calcs=229/200 elements=28,15 [2014-01-14]
  if(system=="NiPb") return MISCIBILITY_SYSTEM_UNKNOWN; // Ni_pvPb_d calcs=142/200 elements=28,82 [2014-01-14]
  if(system=="NiPd") return MISCIBILITY_SYSTEM_MISCIBLE; // Ni_pvPd_pv calcs=256/200 elements=28,46 [2014-01-14]
  if(system=="NiPt") return MISCIBILITY_SYSTEM_MISCIBLE; // Ni_pvPt calcs=355/200 elements=28,78 [2014-01-14]
  if(system=="NiRe") return MISCIBILITY_SYSTEM_MISCIBLE; // Ni_pvRe_pv calcs=241/200 elements=28,75 [2014-01-14]
  if(system=="NiRh") return MISCIBILITY_SYSTEM_NOMIX; // Ni_pvRh_pv calcs=281/200 elements=28,45 [2014-01-14]
  if(system=="NiRu") return MISCIBILITY_SYSTEM_NOMIX; // Ni_pvRu_pv calcs=204/200 elements=28,44 [2014-01-14]
  if(system=="NiSb") return MISCIBILITY_SYSTEM_MISCIBLE; // Ni_pvSb calcs=126/200 elements=28,51 [2014-01-14]
  if(system=="NiSc") return MISCIBILITY_SYSTEM_MISCIBLE; // Ni_pvSc_sv calcs=256/200 elements=28,21 [2014-01-14]
  if(system=="NiSe") return MISCIBILITY_SYSTEM_MISCIBLE; // Ni_pvSe calcs=212/200 elements=28,34 [2014-01-14]
  if(system=="NiSi") return MISCIBILITY_SYSTEM_MISCIBLE; // Ni_pvSi calcs=219/200 elements=28,14 [2014-01-14]
  if(system=="NiSn") return MISCIBILITY_SYSTEM_MISCIBLE; // Ni_pvSn calcs=158/200 elements=28,50 [2014-01-14]
  if(system=="NiSr") return MISCIBILITY_SYSTEM_MISCIBLE; // Ni_pvSr_sv calcs=112/200 elements=28,38 [2014-01-14]
  if(system=="NiTa") return MISCIBILITY_SYSTEM_MISCIBLE; // Ni_pvTa_pv calcs=233/200 elements=28,73 [2014-01-14]
  if(system=="NiTc") return MISCIBILITY_SYSTEM_MISCIBLE; // Ni_pvTc_pv calcs=246/200 elements=28,43 [2014-01-14]
  if(system=="NiTe") return MISCIBILITY_SYSTEM_MISCIBLE; // Ni_pvTe calcs=207/200 elements=28,52 [2014-01-14]
  if(system=="NiTi") return MISCIBILITY_SYSTEM_MISCIBLE; // Ni_pvTi_sv calcs=261/200 elements=28,22 [2014-01-14]
  if(system=="NiTl") return MISCIBILITY_SYSTEM_UNKNOWN; // Ni_pvTl_d calcs=122/200 elements=28,81 [2014-01-14]
  if(system=="NiV") return MISCIBILITY_SYSTEM_MISCIBLE; // Ni_pvV_sv calcs=889/200 elements=28,23 [2014-01-14]
  if(system=="NiW") return MISCIBILITY_SYSTEM_MISCIBLE; // Ni_pvW_pv calcs=249/200 elements=28,74 [2014-01-14]
  if(system=="NiY") return MISCIBILITY_SYSTEM_MISCIBLE; // Ni_pvY_sv calcs=229/200 elements=28,39 [2014-01-14]
  if(system=="NiZn") return MISCIBILITY_SYSTEM_MISCIBLE; // Ni_pvZn calcs=270/200 elements=28,30 [2014-01-14]
  if(system=="NiZr") return MISCIBILITY_SYSTEM_MISCIBLE; // Ni_pvZr_sv calcs=239/200 elements=28,40 [2014-01-14]
  if(system=="MgOs") return MISCIBILITY_SYSTEM_NOMIX; // Os_pvMg_pv calcs=206/200 elements=76,12 [2014-01-14]
  if(system=="OsP") return MISCIBILITY_SYSTEM_MISCIBLE; // Os_pvP calcs=159/200 elements=76,15 [2014-01-14]
  if(system=="OsPb") return MISCIBILITY_SYSTEM_UNKNOWN; // Os_pvPb_d calcs=163/200 elements=76,82 [2014-01-14]
  if(system=="OsPd") return MISCIBILITY_SYSTEM_NOMIX; // Os_pvPd_pv calcs=200/200 elements=76,46 [2014-01-14]
  if(system=="OsPt") return MISCIBILITY_SYSTEM_NOMIX; // Os_pvPt calcs=208/200 elements=76,78 [2014-01-14]
  if(system=="OsRe") return MISCIBILITY_SYSTEM_MISCIBLE; // Os_pvRe_pv calcs=406/200 elements=76,75 [2014-01-14]
  if(system=="OsRh") return MISCIBILITY_SYSTEM_MISCIBLE; // Os_pvRh_pv calcs=236/200 elements=76,45 [2014-01-14]
  if(system=="OsRu") return MISCIBILITY_SYSTEM_MISCIBLE; // Os_pvRu_pv calcs=258/200 elements=76,44 [2014-01-14]
  if(system=="OsSb") return MISCIBILITY_SYSTEM_MISCIBLE; // Os_pvSb calcs=134/200 elements=76,51 [2014-01-14]
  if(system=="OsSc") return MISCIBILITY_SYSTEM_MISCIBLE; // Os_pvSc_sv calcs=242/200 elements=76,21 [2014-01-14]
  if(system=="OsSe") return MISCIBILITY_SYSTEM_MISCIBLE; // Os_pvSe calcs=129/200 elements=76,34 [2014-01-14]
  if(system=="OsSi") return MISCIBILITY_SYSTEM_MISCIBLE; // Os_pvSi calcs=214/200 elements=76,14 [2014-01-14]
  if(system=="OsSn") return MISCIBILITY_SYSTEM_MISCIBLE; // Os_pvSn calcs=127/200 elements=76,50 [2014-01-14]
  if(system=="OsSr") return MISCIBILITY_SYSTEM_UNKNOWN; // Os_pvSr_sv calcs=109/200 elements=76,38 [2014-01-14]
  if(system=="OsTa") return MISCIBILITY_SYSTEM_MISCIBLE; // Os_pvTa_pv calcs=292/200 elements=76,73 [2014-01-14]
  if(system=="OsTc") return MISCIBILITY_SYSTEM_MISCIBLE; // Os_pvTc_pv calcs=257/200 elements=76,43 [2014-01-14]
  if(system=="OsTe") return MISCIBILITY_SYSTEM_MISCIBLE; // Os_pvTe calcs=168/200 elements=76,52 [2014-01-14]
  if(system=="OsTi") return MISCIBILITY_SYSTEM_MISCIBLE; // Os_pvTi_sv calcs=246/200 elements=76,22 [2014-01-14]
  if(system=="OsTl") return MISCIBILITY_SYSTEM_NOMIX; // Os_pvTl_d calcs=228/200 elements=76,81 [2014-01-14]
  if(system=="OsV") return MISCIBILITY_SYSTEM_MISCIBLE; // Os_pvV_sv calcs=241/200 elements=76,23 [2014-01-14]
  if(system=="OsW") return MISCIBILITY_SYSTEM_MISCIBLE; // Os_pvW_pv calcs=291/200 elements=76,74 [2014-01-14]
  if(system=="OsY") return MISCIBILITY_SYSTEM_MISCIBLE; // Os_pvY_sv calcs=254/200 elements=76,39 [2014-01-14]
  if(system=="OsZn") return MISCIBILITY_SYSTEM_NOMIX; // Os_pvZn calcs=205/200 elements=76,30 [2014-01-14]
  if(system=="OsZr") return MISCIBILITY_SYSTEM_MISCIBLE; // Os_pvZr_sv calcs=258/200 elements=76,40 [2014-01-14]
  if(system=="PPb") return MISCIBILITY_SYSTEM_NOMIX; // PPb_d calcs=211/200 elements=15,82 [2014-01-14]
  if(system=="PPd") return MISCIBILITY_SYSTEM_MISCIBLE; // PPd_pv calcs=135/200 elements=15,46 [2014-01-14]
  if(system=="PPt") return MISCIBILITY_SYSTEM_MISCIBLE; // PPt calcs=145/200 elements=15,78 [2014-01-14]
  if(system=="PRe") return MISCIBILITY_SYSTEM_MISCIBLE; // PRe_pv calcs=217/200 elements=15,75 [2014-01-14]
  if(system=="PRh") return MISCIBILITY_SYSTEM_MISCIBLE; // PRh_pv calcs=148/200 elements=15,45 [2014-01-14]
  if(system=="PRu") return MISCIBILITY_SYSTEM_MISCIBLE; // PRu_pv calcs=144/200 elements=15,44 [2014-01-14]
  if(system=="PSb") return MISCIBILITY_SYSTEM_UNKNOWN; // PSb calcs=139/200 elements=15,51 [2014-01-14]
  if(system=="PSc") return MISCIBILITY_SYSTEM_MISCIBLE; // PSc_sv calcs=204/200 elements=15,21 [2014-01-14]
  if(system=="PSe") return MISCIBILITY_SYSTEM_MISCIBLE; // PSe calcs=151/200 elements=15,34 [2014-01-14]
  if(system=="PSi") return MISCIBILITY_SYSTEM_MISCIBLE; // PSi calcs=141/200 elements=15,14 [2014-01-14]
  if(system=="PSn") return MISCIBILITY_SYSTEM_MISCIBLE; // PSn calcs=157/200 elements=15,50 [2014-01-14]
  if(system=="PSr") return MISCIBILITY_SYSTEM_MISCIBLE; // PSr_sv calcs=133/200 elements=15,38 [2014-01-14]
  if(system=="PTa") return MISCIBILITY_SYSTEM_MISCIBLE; // PTa_pv calcs=130/200 elements=15,73 [2014-01-14]
  if(system=="PTc") return MISCIBILITY_SYSTEM_MISCIBLE; // PTc_pv calcs=198/200 elements=15,43 [2014-01-14]
  if(system=="PTe") return MISCIBILITY_SYSTEM_MISCIBLE; // PTe calcs=142/200 elements=15,52 [2014-01-14]
  if(system=="PTi") return MISCIBILITY_SYSTEM_MISCIBLE; // PTi_sv calcs=269/200 elements=15,22 [2014-01-14]
  if(system=="PTl") return MISCIBILITY_SYSTEM_MISCIBLE; // PTl_d calcs=131/200 elements=15,81 [2014-01-14]
  if(system=="PV") return MISCIBILITY_SYSTEM_MISCIBLE; // PV_sv calcs=132/200 elements=15,23 [2014-01-14]
  if(system=="PW") return MISCIBILITY_SYSTEM_MISCIBLE; // PW_pv calcs=134/200 elements=15,74 [2014-01-14]
  if(system=="PY") return MISCIBILITY_SYSTEM_MISCIBLE; // PY_sv calcs=138/200 elements=15,39 [2014-01-14]
  if(system=="PZn") return MISCIBILITY_SYSTEM_MISCIBLE; // PZn calcs=218/200 elements=15,30 [2014-01-14]
  if(system=="PZr") return MISCIBILITY_SYSTEM_MISCIBLE; // PZr_sv calcs=269/200 elements=15,40 [2014-01-14]
  if(system=="MgPb") return MISCIBILITY_SYSTEM_MISCIBLE; // Pb_dMg_pv calcs=262/200 elements=82,12 [2014-01-14]
  if(system=="PbPd") return MISCIBILITY_SYSTEM_MISCIBLE; // Pb_dPd_pv calcs=250/200 elements=82,46 [2014-01-14]
  if(system=="PbPt") return MISCIBILITY_SYSTEM_MISCIBLE; // Pb_dPt calcs=259/200 elements=82,78 [2014-01-14]
  if(system=="PbRe") return MISCIBILITY_SYSTEM_NOMIX; // Pb_dRe_pv calcs=223/200 elements=82,75 [2014-01-14]
  if(system=="PbRh") return MISCIBILITY_SYSTEM_MISCIBLE; // Pb_dRh_pv calcs=206/200 elements=82,45 [2014-01-14]
  if(system=="PbRu") return MISCIBILITY_SYSTEM_NOMIX; // Pb_dRu_pv calcs=214/200 elements=82,44 [2014-01-14]
  if(system=="PbSb") return MISCIBILITY_SYSTEM_UNKNOWN; // Pb_dSb calcs=173/200 elements=82,51 [2014-01-14]
  if(system=="PbSc") return MISCIBILITY_SYSTEM_MISCIBLE; // Pb_dSc_sv calcs=221/200 elements=82,21 [2014-01-14]
  if(system=="PbSe") return MISCIBILITY_SYSTEM_MISCIBLE; // Pb_dSe calcs=167/200 elements=82,34 [2014-01-14]
  if(system=="PbSi") return MISCIBILITY_SYSTEM_UNKNOWN; // Pb_dSi calcs=136/200 elements=82,14 [2014-01-14]
  if(system=="PbSn") return MISCIBILITY_SYSTEM_UNKNOWN; // Pb_dSn calcs=151/200 elements=82,50 [2014-01-14]
  if(system=="PbSr") return MISCIBILITY_SYSTEM_MISCIBLE; // Pb_dSr_sv calcs=208/200 elements=82,38 [2014-01-14]
  if(system=="PbTa") return MISCIBILITY_SYSTEM_UNKNOWN; // Pb_dTa_pv calcs=171/200 elements=82,73 [2014-01-14]
  if(system=="PbTc") return MISCIBILITY_SYSTEM_UNKNOWN; // Pb_dTc_pv calcs=148/200 elements=82,43 [2014-01-14]
  if(system=="PbTe") return MISCIBILITY_SYSTEM_MISCIBLE; // Pb_dTe calcs=149/200 elements=82,52 [2014-01-14]
  if(system=="PbTi") return MISCIBILITY_SYSTEM_MISCIBLE; // Pb_dTi_sv calcs=127/200 elements=82,22 [2014-01-14]
  if(system=="PbTl") return MISCIBILITY_SYSTEM_MISCIBLE; // Pb_dTl_d calcs=147/200 elements=82,81 [2014-01-14]
  if(system=="PbV") return MISCIBILITY_SYSTEM_NOMIX; // Pb_dV_sv calcs=211/200 elements=82,23 [2014-01-14]
  if(system=="PbW") return MISCIBILITY_SYSTEM_NOMIX; // Pb_dW_pv calcs=207/200 elements=82,74 [2014-01-14]
  if(system=="PbY") return MISCIBILITY_SYSTEM_MISCIBLE; // Pb_dY_sv calcs=189/200 elements=82,39 [2014-01-14]
  if(system=="PbZn") return MISCIBILITY_SYSTEM_UNKNOWN; // Pb_dZn calcs=148/200 elements=82,30 [2014-01-14]
  if(system=="PbZr") return MISCIBILITY_SYSTEM_MISCIBLE; // Pb_dZr_sv calcs=173/200 elements=82,40 [2014-01-14]
  if(system=="PdPt") return MISCIBILITY_SYSTEM_MISCIBLE; // Pd_pvPt calcs=496/200 elements=46,78 [2014-01-14]
  if(system=="PdRe") return MISCIBILITY_SYSTEM_MISCIBLE; // Pd_pvRe_pv calcs=259/200 elements=46,75 [2014-01-14]
  if(system=="PdRh") return MISCIBILITY_SYSTEM_NOMIX; // Pd_pvRh_pv calcs=206/200 elements=46,45 [2014-01-14]
  if(system=="PdRu") return MISCIBILITY_SYSTEM_NOMIX; // Pd_pvRu_pv calcs=202/200 elements=46,44 [2014-01-14]
  if(system=="PdSb") return MISCIBILITY_SYSTEM_MISCIBLE; // Pd_pvSb calcs=213/200 elements=46,51 [2014-01-14]
  if(system=="PdSc") return MISCIBILITY_SYSTEM_MISCIBLE; // Pd_pvSc_sv calcs=273/200 elements=46,21 [2014-01-14]
  if(system=="PdSe") return MISCIBILITY_SYSTEM_MISCIBLE; // Pd_pvSe calcs=241/200 elements=46,34 [2014-01-14]
  if(system=="PdSi") return MISCIBILITY_SYSTEM_MISCIBLE; // Pd_pvSi calcs=199/200 elements=46,14 [2014-01-14]
  if(system=="PdSn") return MISCIBILITY_SYSTEM_MISCIBLE; // Pd_pvSn calcs=159/200 elements=46,50 [2014-01-14]
  if(system=="PdSr") return MISCIBILITY_SYSTEM_MISCIBLE; // Pd_pvSr_sv calcs=141/200 elements=46,38 [2014-01-14]
  if(system=="PdTa") return MISCIBILITY_SYSTEM_MISCIBLE; // Pd_pvTa_pv calcs=288/200 elements=46,73 [2014-01-14]
  if(system=="PdTc") return MISCIBILITY_SYSTEM_MISCIBLE; // Pd_pvTc_pv calcs=253/200 elements=46,43 [2014-01-14]
  if(system=="PdTe") return MISCIBILITY_SYSTEM_MISCIBLE; // Pd_pvTe calcs=155/200 elements=46,52 [2014-01-14]
  if(system=="PdTi") return MISCIBILITY_SYSTEM_MISCIBLE; // Pd_pvTi_sv calcs=271/200 elements=46,22 [2014-01-14]
  if(system=="PdTl") return MISCIBILITY_SYSTEM_MISCIBLE; // Pd_pvTl_d calcs=141/200 elements=46,81 [2014-01-14]
  if(system=="PdV") return MISCIBILITY_SYSTEM_MISCIBLE; // Pd_pvV_sv calcs=246/200 elements=46,23 [2014-01-14]
  if(system=="PdW") return MISCIBILITY_SYSTEM_MISCIBLE; // Pd_pvW_pv calcs=237/200 elements=46,74 [2014-01-14]
  if(system=="PdY") return MISCIBILITY_SYSTEM_MISCIBLE; // Pd_pvY_sv calcs=268/200 elements=46,39 [2014-01-14]
  if(system=="PdZn") return MISCIBILITY_SYSTEM_MISCIBLE; // Pd_pvZn calcs=271/200 elements=46,30 [2014-01-14]
  if(system=="PdZr") return MISCIBILITY_SYSTEM_MISCIBLE; // Pd_pvZr_sv calcs=277/200 elements=46,40 [2014-01-14]
  if(system=="PtRe") return MISCIBILITY_SYSTEM_MISCIBLE; // PtRe_pv calcs=240/200 elements=78,75 [2014-01-14]
  if(system=="PtRh") return MISCIBILITY_SYSTEM_MISCIBLE; // PtRh_pv calcs=246/200 elements=78,45 [2014-01-14]
  if(system=="PtRu") return MISCIBILITY_SYSTEM_MISCIBLE; // PtRu_pv calcs=255/200 elements=78,44 [2014-01-14]
  if(system=="PtSb") return MISCIBILITY_SYSTEM_MISCIBLE; // PtSb calcs=141/200 elements=78,51 [2014-01-14]
  if(system=="PtSc") return MISCIBILITY_SYSTEM_MISCIBLE; // PtSc_sv calcs=278/200 elements=78,21 [2014-01-14]
  if(system=="PtSe") return MISCIBILITY_SYSTEM_MISCIBLE; // PtSe calcs=122/200 elements=78,34 [2014-01-14]
  if(system=="PtSi") return MISCIBILITY_SYSTEM_MISCIBLE; // PtSi calcs=136/200 elements=78,14 [2014-01-14]
  if(system=="PtSn") return MISCIBILITY_SYSTEM_MISCIBLE; // PtSn calcs=128/200 elements=78,50 [2014-01-14]
  if(system=="PtSr") return MISCIBILITY_SYSTEM_MISCIBLE; // PtSr_sv calcs=120/200 elements=78,38 [2014-01-14]
  if(system=="PtTa") return MISCIBILITY_SYSTEM_MISCIBLE; // PtTa_pv calcs=272/200 elements=78,73 [2014-01-14]
  if(system=="PtTc") return MISCIBILITY_SYSTEM_MISCIBLE; // PtTc_pv calcs=258/200 elements=78,43 [2014-01-14]
  if(system=="PtTe") return MISCIBILITY_SYSTEM_MISCIBLE; // PtTe calcs=216/200 elements=78,52 [2014-01-14]
  if(system=="PtTi") return MISCIBILITY_SYSTEM_MISCIBLE; // PtTi_sv calcs=269/200 elements=78,22 [2014-01-14]
  if(system=="PtTl") return MISCIBILITY_SYSTEM_MISCIBLE; // PtTl_d calcs=133/200 elements=78,81 [2014-01-14]
  if(system=="PtV") return MISCIBILITY_SYSTEM_MISCIBLE; // PtV_sv calcs=244/200 elements=78,23 [2014-01-14]
  if(system=="PtW") return MISCIBILITY_SYSTEM_MISCIBLE; // PtW_pv calcs=253/200 elements=78,74 [2014-01-14]
  if(system=="PtY") return MISCIBILITY_SYSTEM_MISCIBLE; // PtY_sv calcs=282/200 elements=78,39 [2014-01-14]
  if(system=="PtZn") return MISCIBILITY_SYSTEM_MISCIBLE; // PtZn calcs=264/200 elements=78,30 [2014-01-14]
  if(system=="PtZr") return MISCIBILITY_SYSTEM_MISCIBLE; // PtZr_sv calcs=277/200 elements=78,40 [2014-01-14]
  if(system=="MgRb") return MISCIBILITY_SYSTEM_MISCIBLE; // Rb_svMg_pv calcs=260/200 elements=37,12 [2014-01-14]
  if(system=="PdRb") return MISCIBILITY_SYSTEM_NOMIX; // Rb_svPd_pv calcs=202/200 elements=37,46 [2014-01-14]
  if(system=="PtRb") return MISCIBILITY_SYSTEM_MISCIBLE; // Rb_svPt calcs=248/200 elements=37,78 [2014-01-14]
  if(system=="MgRe") return MISCIBILITY_SYSTEM_NOMIX; // Re_pvMg_pv calcs=207/200 elements=75,12 [2014-01-14]
  if(system=="ReRh") return MISCIBILITY_SYSTEM_MISCIBLE; // Re_pvRh_pv calcs=409/200 elements=75,45 [2014-01-14]
  if(system=="ReRu") return MISCIBILITY_SYSTEM_MISCIBLE; // Re_pvRu_pv calcs=244/200 elements=75,44 [2014-01-14]
  if(system=="ReSb") return MISCIBILITY_SYSTEM_NOMIX; // Re_pvSb calcs=207/200 elements=75,51 [2014-01-14]
  if(system=="ReSc") return MISCIBILITY_SYSTEM_MISCIBLE; // Re_pvSc_sv calcs=239/200 elements=75,21 [2014-01-14]
  if(system=="ReSe") return MISCIBILITY_SYSTEM_MISCIBLE; // Re_pvSe calcs=202/200 elements=75,34 [2014-01-14]
  if(system=="ReSi") return MISCIBILITY_SYSTEM_MISCIBLE; // Re_pvSi calcs=212/200 elements=75,14 [2014-01-14]
  if(system=="ReSn") return MISCIBILITY_SYSTEM_UNKNOWN; // Re_pvSn calcs=198/200 elements=75,50 [2014-01-14]
  if(system=="ReSr") return MISCIBILITY_SYSTEM_UNKNOWN; // Re_pvSr_sv calcs=103/200 elements=75,38 [2014-01-14]
  if(system=="ReTa") return MISCIBILITY_SYSTEM_MISCIBLE; // Re_pvTa_pv calcs=258/200 elements=75,73 [2014-01-14]
  if(system=="ReTc") return MISCIBILITY_SYSTEM_MISCIBLE; // Re_pvTc_pv calcs=255/200 elements=75,43 [2014-01-14]
  if(system=="ReTe") return MISCIBILITY_SYSTEM_MISCIBLE; // Re_pvTe calcs=119/200 elements=75,52 [2014-01-14]
  if(system=="ReTi") return MISCIBILITY_SYSTEM_MISCIBLE; // Re_pvTi_sv calcs=246/200 elements=75,22 [2014-01-14]
  if(system=="ReTl") return MISCIBILITY_SYSTEM_NOMIX; // Re_pvTl_d calcs=217/200 elements=75,81 [2014-01-14]
  if(system=="ReV") return MISCIBILITY_SYSTEM_MISCIBLE; // Re_pvV_sv calcs=234/200 elements=75,23 [2014-01-14]
  if(system=="ReW") return MISCIBILITY_SYSTEM_NOMIX; // Re_pvW_pv calcs=211/200 elements=75,74 [2014-01-14]
  if(system=="ReY") return MISCIBILITY_SYSTEM_NOMIX; // Re_pvY_sv calcs=228/200 elements=75,39 [2014-01-14]
  if(system=="ReZn") return MISCIBILITY_SYSTEM_NOMIX; // Re_pvZn calcs=209/200 elements=75,30 [2014-01-14]
  if(system=="ReZr") return MISCIBILITY_SYSTEM_MISCIBLE; // Re_pvZr_sv calcs=241/200 elements=75,40 [2014-01-14]
  if(system=="MgRh") return MISCIBILITY_SYSTEM_MISCIBLE; // Rh_pvMg_pv calcs=262/200 elements=45,12 [2014-01-14]
  if(system=="RhRu") return MISCIBILITY_SYSTEM_MISCIBLE; // Rh_pvRu_pv calcs=247/200 elements=45,44 [2014-01-14]
  if(system=="RhSb") return MISCIBILITY_SYSTEM_MISCIBLE; // Rh_pvSb calcs=137/200 elements=45,51 [2014-01-14]
  if(system=="RhSc") return MISCIBILITY_SYSTEM_MISCIBLE; // Rh_pvSc_sv calcs=249/200 elements=45,21 [2014-01-14]
  if(system=="RhSe") return MISCIBILITY_SYSTEM_MISCIBLE; // Rh_pvSe calcs=122/200 elements=45,34 [2014-01-14]
  if(system=="RhSi") return MISCIBILITY_SYSTEM_MISCIBLE; // Rh_pvSi calcs=157/200 elements=45,14 [2014-01-14]
  if(system=="RhSn") return MISCIBILITY_SYSTEM_MISCIBLE; // Rh_pvSn calcs=206/200 elements=45,50 [2014-01-14]
  if(system=="RhSr") return MISCIBILITY_SYSTEM_MISCIBLE; // Rh_pvSr_sv calcs=113/200 elements=45,38 [2014-01-14]
  if(system=="RhTa") return MISCIBILITY_SYSTEM_MISCIBLE; // Rh_pvTa_pv calcs=281/200 elements=45,73 [2014-01-14]
  if(system=="RhTc") return MISCIBILITY_SYSTEM_MISCIBLE; // Rh_pvTc_pv calcs=250/200 elements=45,43 [2014-01-14]
  if(system=="RhTe") return MISCIBILITY_SYSTEM_MISCIBLE; // Rh_pvTe calcs=208/200 elements=45,52 [2014-01-14]
  if(system=="RhTi") return MISCIBILITY_SYSTEM_MISCIBLE; // Rh_pvTi_sv calcs=274/200 elements=45,22 [2014-01-14]
  if(system=="RhTl") return MISCIBILITY_SYSTEM_NOMIX; // Rh_pvTl_d calcs=247/200 elements=45,81 [2014-01-14]
  if(system=="RhV") return MISCIBILITY_SYSTEM_MISCIBLE; // Rh_pvV_sv calcs=260/200 elements=45,23 [2014-01-14]
  if(system=="RhW") return MISCIBILITY_SYSTEM_MISCIBLE; // Rh_pvW_pv calcs=247/200 elements=45,74 [2014-01-14]
  if(system=="RhY") return MISCIBILITY_SYSTEM_MISCIBLE; // Rh_pvY_sv calcs=266/200 elements=45,39 [2014-01-14]
  if(system=="RhZn") return MISCIBILITY_SYSTEM_MISCIBLE; // Rh_pvZn calcs=255/200 elements=45,30 [2014-01-14]
  if(system=="RhZr") return MISCIBILITY_SYSTEM_MISCIBLE; // Rh_pvZr_sv calcs=281/200 elements=45,40 [2014-01-14]
  if(system=="MgRu") return MISCIBILITY_SYSTEM_MISCIBLE; // Ru_pvMg_pv calcs=262/200 elements=44,12 [2014-01-14]
  if(system=="RuSb") return MISCIBILITY_SYSTEM_MISCIBLE; // Ru_pvSb calcs=211/200 elements=44,51 [2014-01-14]
  if(system=="RuSc") return MISCIBILITY_SYSTEM_MISCIBLE; // Ru_pvSc_sv calcs=248/200 elements=44,21 [2014-01-14]
  if(system=="RuSe") return MISCIBILITY_SYSTEM_MISCIBLE; // Ru_pvSe calcs=158/200 elements=44,34 [2014-01-14]
  if(system=="RuSi") return MISCIBILITY_SYSTEM_MISCIBLE; // Ru_pvSi calcs=208/200 elements=44,14 [2014-01-14]
  if(system=="RuSn") return MISCIBILITY_SYSTEM_MISCIBLE; // Ru_pvSn calcs=123/200 elements=44,50 [2014-01-14]
  if(system=="RuSr") return MISCIBILITY_SYSTEM_UNKNOWN; // Ru_pvSr_sv calcs=121/200 elements=44,38 [2014-01-14]
  if(system=="RuTa") return MISCIBILITY_SYSTEM_MISCIBLE; // Ru_pvTa_pv calcs=263/200 elements=44,73 [2014-01-14]
  if(system=="RuTc") return MISCIBILITY_SYSTEM_MISCIBLE; // Ru_pvTc_pv calcs=244/200 elements=44,43 [2014-01-14]
  if(system=="RuTe") return MISCIBILITY_SYSTEM_MISCIBLE; // Ru_pvTe calcs=204/200 elements=44,52 [2014-01-14]
  if(system=="RuTi") return MISCIBILITY_SYSTEM_MISCIBLE; // Ru_pvTi_sv calcs=247/200 elements=44,22 [2014-01-14]
  if(system=="RuTl") return MISCIBILITY_SYSTEM_NOMIX; // Ru_pvTl_d calcs=219/200 elements=44,81 [2014-01-14]
  if(system=="RuV") return MISCIBILITY_SYSTEM_MISCIBLE; // Ru_pvV_sv calcs=258/200 elements=44,23 [2014-01-14]
  if(system=="RuW") return MISCIBILITY_SYSTEM_MISCIBLE; // Ru_pvW_pv calcs=291/200 elements=44,74 [2014-01-14]
  if(system=="RuY") return MISCIBILITY_SYSTEM_MISCIBLE; // Ru_pvY_sv calcs=266/200 elements=44,39 [2014-01-14]
  if(system=="RuZn") return MISCIBILITY_SYSTEM_MISCIBLE; // Ru_pvZn calcs=258/200 elements=44,30 [2014-01-14]
  if(system=="RuZr") return MISCIBILITY_SYSTEM_MISCIBLE; // Ru_pvZr_sv calcs=243/200 elements=44,40 [2014-01-14]
  if(system=="SbSc") return MISCIBILITY_SYSTEM_MISCIBLE; // SbSc_sv calcs=128/200 elements=51,21 [2014-01-14]
  if(system=="SbSe") return MISCIBILITY_SYSTEM_MISCIBLE; // SbSe calcs=205/200 elements=51,34 [2014-01-14]
  if(system=="SbSi") return MISCIBILITY_SYSTEM_NOMIX; // SbSi calcs=212/200 elements=51,14 [2014-01-14]
  if(system=="SbSn") return MISCIBILITY_SYSTEM_MISCIBLE; // SbSn calcs=225/200 elements=51,50 [2014-01-14]
  if(system=="SbSr") return MISCIBILITY_SYSTEM_MISCIBLE; // SbSr_sv calcs=129/200 elements=51,38 [2014-01-14]
  if(system=="SbTa") return MISCIBILITY_SYSTEM_MISCIBLE; // SbTa_pv calcs=168/200 elements=51,73 [2014-01-14]
  if(system=="SbTc") return MISCIBILITY_SYSTEM_MISCIBLE; // SbTc_pv calcs=205/200 elements=51,43 [2014-01-14]
  if(system=="SbTe") return MISCIBILITY_SYSTEM_MISCIBLE; // SbTe calcs=190/200 elements=51,52 [2014-01-14]
  if(system=="SbTi") return MISCIBILITY_SYSTEM_MISCIBLE; // SbTi_sv calcs=174/200 elements=51,22 [2014-01-14]
  if(system=="SbTl") return MISCIBILITY_SYSTEM_MISCIBLE; // SbTl_d calcs=124/200 elements=51,81 [2014-01-14]
  if(system=="SbV") return MISCIBILITY_SYSTEM_MISCIBLE; // SbV_sv calcs=191/200 elements=51,23 [2014-01-14]
  if(system=="SbW") return MISCIBILITY_SYSTEM_NOMIX; // SbW_pv calcs=202/200 elements=51,74 [2014-01-14]
  if(system=="SbY") return MISCIBILITY_SYSTEM_MISCIBLE; // SbY_sv calcs=146/200 elements=51,39 [2014-01-14]
  if(system=="SbZn") return MISCIBILITY_SYSTEM_MISCIBLE; // SbZn calcs=122/200 elements=51,30 [2014-01-14]
  if(system=="SbZr") return MISCIBILITY_SYSTEM_MISCIBLE; // SbZr_sv calcs=210/200 elements=51,40 [2014-01-14]
  if(system=="MgSc") return MISCIBILITY_SYSTEM_MISCIBLE; // Sc_svMg_pv calcs=261/200 elements=21,12 [2014-01-14]
  if(system=="ScSe") return MISCIBILITY_SYSTEM_MISCIBLE; // Sc_svSe calcs=144/200 elements=21,34 [2014-01-14]
  if(system=="ScSi") return MISCIBILITY_SYSTEM_MISCIBLE; // Sc_svSi calcs=122/200 elements=21,14 [2014-01-14]
  if(system=="ScSn") return MISCIBILITY_SYSTEM_MISCIBLE; // Sc_svSn calcs=193/200 elements=21,50 [2014-01-14]
  if(system=="ScSr") return MISCIBILITY_SYSTEM_UNKNOWN; // Sc_svSr_sv calcs=115/200 elements=21,38 [2014-01-14]
  if(system=="ScTa") return MISCIBILITY_SYSTEM_NOMIX; // Sc_svTa_pv calcs=211/200 elements=21,73 [2014-01-14]
  if(system=="ScTc") return MISCIBILITY_SYSTEM_MISCIBLE; // Sc_svTc_pv calcs=243/200 elements=21,43 [2014-01-14]
  if(system=="ScTe") return MISCIBILITY_SYSTEM_MISCIBLE; // Sc_svTe calcs=205/200 elements=21,52 [2014-01-14]
  if(system=="ScTi") return MISCIBILITY_SYSTEM_NOMIX; // Sc_svTi_sv calcs=206/200 elements=21,22 [2014-01-14]
  if(system=="ScTl") return MISCIBILITY_SYSTEM_MISCIBLE; // Sc_svTl_d calcs=255/200 elements=21,81 [2014-01-14]
  if(system=="ScV") return MISCIBILITY_SYSTEM_NOMIX; // Sc_svV_sv calcs=215/200 elements=21,23 [2014-01-14]
  if(system=="ScW") return MISCIBILITY_SYSTEM_NOMIX; // Sc_svW_pv calcs=218/200 elements=21,74 [2014-01-14]
  if(system=="ScY") return MISCIBILITY_SYSTEM_NOMIX; // Sc_svY_sv calcs=220/200 elements=21,39 [2014-01-14]
  if(system=="ScZn") return MISCIBILITY_SYSTEM_MISCIBLE; // Sc_svZn calcs=256/200 elements=21,30 [2014-01-14]
  if(system=="ScZr") return MISCIBILITY_SYSTEM_MISCIBLE; // Sc_svZr_sv calcs=235/200 elements=21,40 [2014-01-14]
  if(system=="SeSi") return MISCIBILITY_SYSTEM_MISCIBLE; // SeSi calcs=212/200 elements=34,14 [2014-01-14]
  if(system=="SeSn") return MISCIBILITY_SYSTEM_MISCIBLE; // SeSn calcs=150/200 elements=34,50 [2014-01-14]
  if(system=="SeSr") return MISCIBILITY_SYSTEM_MISCIBLE; // SeSr_sv calcs=120/200 elements=34,38 [2014-01-14]
  if(system=="SeTa") return MISCIBILITY_SYSTEM_MISCIBLE; // SeTa_pv calcs=165/200 elements=34,73 [2014-01-14]
  if(system=="SeTc") return MISCIBILITY_SYSTEM_MISCIBLE; // SeTc_pv calcs=124/200 elements=34,43 [2014-01-14]
  if(system=="SeTe") return MISCIBILITY_SYSTEM_MISCIBLE; // SeTe calcs=209/200 elements=34,52 [2014-01-14]
  if(system=="SeTi") return MISCIBILITY_SYSTEM_MISCIBLE; // SeTi_sv calcs=136/200 elements=34,22 [2014-01-14]
  if(system=="SeTl") return MISCIBILITY_SYSTEM_MISCIBLE; // SeTl_d calcs=117/200 elements=34,81 [2014-01-14]
  if(system=="SeV") return MISCIBILITY_SYSTEM_MISCIBLE; // SeV_sv calcs=166/200 elements=34,23 [2014-01-14]
  if(system=="SeW") return MISCIBILITY_SYSTEM_MISCIBLE; // SeW_pv calcs=212/200 elements=34,74 [2014-01-14]
  if(system=="SeY") return MISCIBILITY_SYSTEM_MISCIBLE; // SeY_sv calcs=125/200 elements=34,39 [2014-01-14]
  if(system=="SeZn") return MISCIBILITY_SYSTEM_MISCIBLE; // SeZn calcs=122/200 elements=34,30 [2014-01-14]
  if(system=="SeZr") return MISCIBILITY_SYSTEM_MISCIBLE; // SeZr_sv calcs=219/200 elements=34,40 [2014-01-14]
  if(system=="PdSi") return MISCIBILITY_SYSTEM_MISCIBLE; // SiPd_pv calcs=111/200 elements=14,46 [2014-01-14]
  if(system=="PtSi") return MISCIBILITY_SYSTEM_MISCIBLE; // SiPt calcs=112/200 elements=14,78 [2014-01-14]
  if(system=="SiSn") return MISCIBILITY_SYSTEM_MISCIBLE; // SiSn calcs=135/200 elements=14,50 [2014-01-14]
  if(system=="SiSr") return MISCIBILITY_SYSTEM_MISCIBLE; // SiSr_sv calcs=142/200 elements=14,38 [2014-01-14]
  if(system=="SiTa") return MISCIBILITY_SYSTEM_MISCIBLE; // SiTa_pv calcs=268/200 elements=14,73 [2014-01-14]
  if(system=="SiTc") return MISCIBILITY_SYSTEM_MISCIBLE; // SiTc_pv calcs=134/200 elements=14,43 [2014-01-14]
  if(system=="SiTe") return MISCIBILITY_SYSTEM_NOMIX; // SiTe calcs=214/200 elements=14,52 [2014-01-14]
  if(system=="SiTi") return MISCIBILITY_SYSTEM_MISCIBLE; // SiTi_sv calcs=145/200 elements=14,22 [2014-01-14]
  if(system=="SiTl") return MISCIBILITY_SYSTEM_MISCIBLE; // SiTl_d calcs=122/200 elements=14,81 [2014-01-14]
  if(system=="SiV") return MISCIBILITY_SYSTEM_MISCIBLE; // SiV_sv calcs=270/200 elements=14,23 [2014-01-14]
  if(system=="SiW") return MISCIBILITY_SYSTEM_MISCIBLE; // SiW_pv calcs=259/200 elements=14,74 [2014-01-14]
  if(system=="SiY") return MISCIBILITY_SYSTEM_MISCIBLE; // SiY_sv calcs=175/200 elements=14,39 [2014-01-14]
  if(system=="SiZn") return MISCIBILITY_SYSTEM_MISCIBLE; // SiZn calcs=162/200 elements=14,30 [2014-01-14]
  if(system=="SiZr") return MISCIBILITY_SYSTEM_MISCIBLE; // SiZr_sv calcs=188/200 elements=14,40 [2014-01-14]
  if(system=="MgSn") return MISCIBILITY_SYSTEM_MISCIBLE; // SnMg_pv calcs=261/200 elements=50,12 [2014-01-14]
  if(system=="PdSn") return MISCIBILITY_SYSTEM_MISCIBLE; // SnPd_pv calcs=206/200 elements=50,46 [2014-01-14]
  if(system=="PtSn") return MISCIBILITY_SYSTEM_MISCIBLE; // SnPt calcs=209/200 elements=50,78 [2014-01-14]
  if(system=="SnSr") return MISCIBILITY_SYSTEM_MISCIBLE; // SnSr_sv calcs=120/200 elements=50,38 [2014-01-14]
  if(system=="SnTa") return MISCIBILITY_SYSTEM_MISCIBLE; // SnTa_pv calcs=223/200 elements=50,73 [2014-01-14]
  if(system=="SnTc") return MISCIBILITY_SYSTEM_MISCIBLE; // SnTc_pv calcs=205/200 elements=50,43 [2014-01-14]
  if(system=="SnTe") return MISCIBILITY_SYSTEM_MISCIBLE; // SnTe calcs=130/200 elements=50,52 [2014-01-14]
  if(system=="SnTi") return MISCIBILITY_SYSTEM_MISCIBLE; // SnTi_sv calcs=138/200 elements=50,22 [2014-01-14]
  if(system=="SnTl") return MISCIBILITY_SYSTEM_MISCIBLE; // SnTl_d calcs=117/200 elements=50,81 [2014-01-14]
  if(system=="SnV") return MISCIBILITY_SYSTEM_MISCIBLE; // SnV_sv calcs=128/200 elements=50,23 [2014-01-14]
  if(system=="SnW") return MISCIBILITY_SYSTEM_NOMIX; // SnW_pv calcs=200/200 elements=50,74 [2014-01-14]
  if(system=="SnY") return MISCIBILITY_SYSTEM_MISCIBLE; // SnY_sv calcs=216/200 elements=50,39 [2014-01-14]
  if(system=="SnZn") return MISCIBILITY_SYSTEM_UNKNOWN; // SnZn calcs=158/200 elements=50,30 [2014-01-14]
  if(system=="SnZr") return MISCIBILITY_SYSTEM_MISCIBLE; // SnZr_sv calcs=172/200 elements=50,40 [2014-01-14]
  if(system=="MgSr") return MISCIBILITY_SYSTEM_MISCIBLE; // Sr_svMg_pv calcs=264/200 elements=38,12 [2014-01-14]
  if(system=="PdSr") return MISCIBILITY_SYSTEM_MISCIBLE; // Sr_svPd_pv calcs=203/200 elements=38,46 [2014-01-14]
  if(system=="PtSr") return MISCIBILITY_SYSTEM_MISCIBLE; // Sr_svPt calcs=206/200 elements=38,78 [2014-01-14]
  if(system=="SrTa") return MISCIBILITY_SYSTEM_UNKNOWN; // Sr_svTa_pv calcs=121/200 elements=38,73 [2014-01-14]
  if(system=="SrTc") return MISCIBILITY_SYSTEM_UNKNOWN; // Sr_svTc_pv calcs=115/200 elements=38,43 [2014-01-14]
  if(system=="SrTe") return MISCIBILITY_SYSTEM_MISCIBLE; // Sr_svTe calcs=118/200 elements=38,52 [2014-01-14]
  if(system=="SrTi") return MISCIBILITY_SYSTEM_UNKNOWN; // Sr_svTi_sv calcs=121/200 elements=38,22 [2014-01-14]
  if(system=="SrTl") return MISCIBILITY_SYSTEM_MISCIBLE; // Sr_svTl_d calcs=123/200 elements=38,81 [2014-01-14]
  if(system=="SrV") return MISCIBILITY_SYSTEM_UNKNOWN; // Sr_svV_sv calcs=101/200 elements=38,23 [2014-01-14]
  if(system=="SrW") return MISCIBILITY_SYSTEM_UNKNOWN; // Sr_svW_pv calcs=122/200 elements=38,74 [2014-01-14]
  if(system=="SrY") return MISCIBILITY_SYSTEM_UNKNOWN; // Sr_svY_sv calcs=129/200 elements=38,39 [2014-01-14]
  if(system=="SrZn") return MISCIBILITY_SYSTEM_MISCIBLE; // Sr_svZn calcs=121/200 elements=38,30 [2014-01-14]
  if(system=="SrZr") return MISCIBILITY_SYSTEM_UNKNOWN; // Sr_svZr_sv calcs=118/200 elements=38,40 [2014-01-14]
  if(system=="MgTa") return MISCIBILITY_SYSTEM_NOMIX; // Ta_pvMg_pv calcs=205/200 elements=73,12 [2014-01-14]
  if(system=="TaTc") return MISCIBILITY_SYSTEM_MISCIBLE; // Ta_pvTc_pv calcs=241/200 elements=73,43 [2014-01-14]
  if(system=="TaTe") return MISCIBILITY_SYSTEM_MISCIBLE; // Ta_pvTe calcs=181/200 elements=73,52 [2014-01-14]
  if(system=="TaTi") return MISCIBILITY_SYSTEM_NOMIX; // Ta_pvTi_sv calcs=205/200 elements=73,22 [2014-01-14]
  if(system=="TaTl") return MISCIBILITY_SYSTEM_UNKNOWN; // Ta_pvTl_d calcs=124/200 elements=73,81 [2014-01-14]
  if(system=="TaV") return MISCIBILITY_SYSTEM_MISCIBLE; // Ta_pvV_sv calcs=238/200 elements=73,23 [2014-01-14]
  if(system=="TaW") return MISCIBILITY_SYSTEM_MISCIBLE; // Ta_pvW_pv calcs=255/200 elements=73,74 [2014-01-14]
  if(system=="TaY") return MISCIBILITY_SYSTEM_NOMIX; // Ta_pvY_sv calcs=225/200 elements=73,39 [2014-01-14]
  if(system=="TaZn") return MISCIBILITY_SYSTEM_MISCIBLE; // Ta_pvZn calcs=250/200 elements=73,30 [2014-01-14]
  if(system=="TaZr") return MISCIBILITY_SYSTEM_NOMIX; // Ta_pvZr_sv calcs=214/200 elements=73,40 [2014-01-14]
  if(system=="TcTe") return MISCIBILITY_SYSTEM_MISCIBLE; // Tc_pvTe calcs=105/200 elements=43,52 [2014-01-14]
  if(system=="TcTi") return MISCIBILITY_SYSTEM_MISCIBLE; // Tc_pvTi_sv calcs=248/200 elements=43,22 [2014-01-14]
  if(system=="TcTl") return MISCIBILITY_SYSTEM_NOMIX; // Tc_pvTl_d calcs=224/200 elements=43,81 [2014-01-14]
  if(system=="TcV") return MISCIBILITY_SYSTEM_MISCIBLE; // Tc_pvV_sv calcs=239/200 elements=43,23 [2014-01-14]
  if(system=="TcW") return MISCIBILITY_SYSTEM_NOMIX; // Tc_pvW_pv calcs=215/200 elements=43,74 [2014-01-14]
  if(system=="TcY") return MISCIBILITY_SYSTEM_MISCIBLE; // Tc_pvY_sv calcs=235/200 elements=43,39 [2014-01-14]
  if(system=="TcZn") return MISCIBILITY_SYSTEM_MISCIBLE; // Tc_pvZn calcs=273/200 elements=43,30 [2014-01-14]
  if(system=="TcZr") return MISCIBILITY_SYSTEM_MISCIBLE; // Tc_pvZr_sv calcs=261/200 elements=43,40 [2014-01-14]
  if(system=="TeTi") return MISCIBILITY_SYSTEM_MISCIBLE; // TeTi_sv calcs=124/200 elements=52,22 [2014-01-14]
  if(system=="TeTl") return MISCIBILITY_SYSTEM_MISCIBLE; // TeTl_d calcs=126/200 elements=52,81 [2014-01-14]
  if(system=="TeV") return MISCIBILITY_SYSTEM_MISCIBLE; // TeV_sv calcs=217/200 elements=52,23 [2014-01-14]
  if(system=="TeW") return MISCIBILITY_SYSTEM_MISCIBLE; // TeW_pv calcs=127/200 elements=52,74 [2014-01-14]
  if(system=="TeY") return MISCIBILITY_SYSTEM_MISCIBLE; // TeY_sv calcs=206/200 elements=52,39 [2014-01-14]
  if(system=="TeZn") return MISCIBILITY_SYSTEM_MISCIBLE; // TeZn calcs=205/200 elements=52,30 [2014-01-14]
  if(system=="TeZr") return MISCIBILITY_SYSTEM_MISCIBLE; // TeZr_sv calcs=211/200 elements=52,40 [2014-01-14]
  if(system=="MgTi") return MISCIBILITY_SYSTEM_NOMIX; // Ti_svMg_pv calcs=207/200 elements=22,12 [2014-01-14]
  if(system=="TiTl") return MISCIBILITY_SYSTEM_MISCIBLE; // Ti_svTl_d calcs=260/200 elements=22,81 [2014-01-14]
  if(system=="TiV") return MISCIBILITY_SYSTEM_NOMIX; // Ti_svV_sv calcs=208/200 elements=22,23 [2014-01-14]
  if(system=="TiW") return MISCIBILITY_SYSTEM_MISCIBLE; // Ti_svW_pv calcs=258/200 elements=22,74 [2014-01-14]
  if(system=="TiY") return MISCIBILITY_SYSTEM_NOMIX; // Ti_svY_sv calcs=208/200 elements=22,39 [2014-01-14]
  if(system=="TiZn") return MISCIBILITY_SYSTEM_MISCIBLE; // Ti_svZn calcs=247/200 elements=22,30 [2014-01-14]
  if(system=="TiZr") return MISCIBILITY_SYSTEM_NOMIX; // Ti_svZr_sv calcs=208/200 elements=22,40 [2014-01-14]
  if(system=="TlV") return MISCIBILITY_SYSTEM_UNKNOWN; // Tl_dV_sv calcs=118/200 elements=81,23 [2014-01-14]
  if(system=="TlW") return MISCIBILITY_SYSTEM_UNKNOWN; // Tl_dW_pv calcs=123/200 elements=81,74 [2014-01-14]
  if(system=="TlY") return MISCIBILITY_SYSTEM_MISCIBLE; // Tl_dY_sv calcs=250/200 elements=81,39 [2014-01-14]
  if(system=="TlZn") return MISCIBILITY_SYSTEM_MISCIBLE; // Tl_dZn calcs=247/200 elements=81,30 [2014-01-14]
  if(system=="TlZr") return MISCIBILITY_SYSTEM_MISCIBLE; // Tl_dZr_sv calcs=249/200 elements=81,40 [2014-01-14]
  if(system=="MgV") return MISCIBILITY_SYSTEM_NOMIX; // V_svMg_pv calcs=204/200 elements=23,12 [2014-01-14]
  if(system=="VW") return MISCIBILITY_SYSTEM_MISCIBLE; // V_svW_pv calcs=236/200 elements=23,74 [2014-01-14]
  if(system=="VY") return MISCIBILITY_SYSTEM_NOMIX; // V_svY_sv calcs=223/200 elements=23,39 [2014-01-14]
  if(system=="VZn") return MISCIBILITY_SYSTEM_MISCIBLE; // V_svZn calcs=243/200 elements=23,30 [2014-01-14]
  if(system=="VZr") return MISCIBILITY_SYSTEM_NOMIX; // V_svZr_sv calcs=213/200 elements=23,40 [2014-01-14]
  if(system=="MgW") return MISCIBILITY_SYSTEM_NOMIX; // W_pvMg_pv calcs=204/200 elements=74,12 [2014-01-14]
  if(system=="WY") return MISCIBILITY_SYSTEM_NOMIX; // W_pvY_sv calcs=217/200 elements=74,39 [2014-01-14]
  if(system=="WZn") return MISCIBILITY_SYSTEM_NOMIX; // W_pvZn calcs=230/200 elements=74,30 [2014-01-14]
  if(system=="WZr") return MISCIBILITY_SYSTEM_MISCIBLE; // W_pvZr_sv calcs=245/200 elements=74,40 [2014-01-14]
  if(system=="MgY") return MISCIBILITY_SYSTEM_MISCIBLE; // Y_svMg_pv calcs=264/200 elements=39,12 [2014-01-14]
  if(system=="YZn") return MISCIBILITY_SYSTEM_MISCIBLE; // Y_svZn calcs=288/200 elements=39,30 [2014-01-14]
  if(system=="YZr") return MISCIBILITY_SYSTEM_NOMIX; // Y_svZr_sv calcs=207/200 elements=39,40 [2014-01-14]
  if(system=="MgZn") return MISCIBILITY_SYSTEM_MISCIBLE; // ZnMg_pv calcs=263/200 elements=30,12 [2014-01-14]
  if(system=="ZnZr") return MISCIBILITY_SYSTEM_MISCIBLE; // ZnZr_sv calcs=291/200 elements=30,40 [2014-01-14]
  if(system=="MgZr") return MISCIBILITY_SYSTEM_MISCIBLE; // Zr_svMg_pv calcs=261/200 elements=40,12 [2014-01-14]
  // If not found then not known 
  return MISCIBILITY_SYSTEM_UNKNOWN; // unknown 
} 
// ***************************************************************************
// Total structures holes      = 0
// Total structures calculated = 301071
// Extracted in date  [date=2014-01-14]
// ***************************************************************************
#endif 

// ***************************************************************************
// *                                                                         *
// *           Aflow STEFANO CURTAROLO - Duke University 2003-2021           *
// *                                                                         *
// ***************************************************************************
